package Editor;

import javax.swing.*;
/**
 * This type was created in VisualAge.
 * This panel is used in displaying the architecture of
 * and agent or component.
 * @author: Jennifer Mifflin
  *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
import system.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
public class AgentPanel extends ATpanel
{
	//Higher class- this panel is a representation of either an
	//agent architecture or a component architecture
	//So, these are only needed to define the architecture
	private system.ATagent agent = null;
	private system.ATagentComponent comp = null;
	//the architecture this panel represents
	private system.ATarchitecture architecture = null;
	
	//first ATagentComponent in a conversation
	private ATagentComponent first = null;
	
	private system.ATagentComponent selectedComponent = null;
	private system.ATagentComponentAttribute editAttr = null;
	private system.ATagentComponentMethod editMethod = null;
	private system.ATconnection selectedConnection = null;

	//MenuItems to be placed in popup menu
	private MenuItem componentAttr;
	private MenuItem componentAttrEdit;
	private MenuItem componentMethod;
	private MenuItem componentMethodEdit;
	private MenuItem componentName;
	private MenuItem componentRemove;
	private MenuItem attr, meth;
	private MenuItem Arrow1,Arrow2,ArrowBoth;
	private MenuItem changeInit, changeResp;
	private MenuItem connectionRemove;
	private MenuItem connReverse;

	//vectors of attributes and methods (respectively)
	private Vector allAttrs = new Vector();
	private Vector allMethods= new Vector();
	private int attLocation=0; //place in vector
	private int methLocation=0;

	//new connection to be added
	private ATconnection conn;

	//vector of open windows
	private Vector vectOpen = new Vector();

	//Dimension offDimension;
	//Image offImage;
	//Graphics offGraphics;

/**
 * This method was created in VisualAge.
 */
public AgentPanel(double v) {
	super(v);
	this.enableEvents(AWTEvent.MOUSE_EVENT_MASK);
	this.enableEvents(AWTEvent.MOUSE_MOTION_EVENT_MASK);
	popup = new PopupMenu();
	
	this.add(popup);

	//this.setAgent(a);

/*  Secondary Constructor that I removed in order to make changes to the AgentPanel
	-JAG
	
	public AgentPanel(double v){
		super(v);
		this.enableEvents(AWTEvent.MOUSE_EVENT_MASK);
		this.enableEvents(AWTEvent.MOUSE_MOTION_EVENT_MASK);
		popup = new PopupMenu();
		this.add(popup);
	}
*/
}
/**
 * This method was created in VisualAge.
 */
public void actionPerformed(java.awt.event.ActionEvent event)
{	
	system.ATagentComponentAttribute temp;
	system.ATagentComponentMethod tempMeth;
	String command = event.getActionCommand();
	String tempName = "";
	//change component's name
	if (command.equals("componentName"))
	{
		changeCompName();

		java.util.Enumeration conns = architecture.returnConnections();
		while(conns.hasMoreElements()){
			conn = (system.ATconnection)conns.nextElement();
			if(conn.getComponent1()==selectedComponent || conn.getComponent2()==selectedComponent) {
				conn.resize(selectedComponent);
				update(this.getGraphics());
			}
		}
		
	}
	else
		//remove component
		if (command.equals("componentRemove"))
		{
			deleteComponent();
		}
		//add component attribute
		else if (command.equals("componentAttr"))
		{
			addCompAttr();
		}
		//add component method
		else if (command.equals("componentMethod"))
		{
			addCompMethod();
		}
	/*	//for transitions - makes transition point to first component 
		else if(command.equals("Arrow1")){
			selectedConnection.setArrow("first");
		} */
		//makes transition point to second component
		else if(command.equals("Arrow2")){
			selectedConnection.setArrow("second");
		} 
		//makes transition point to both components
		else if(command.equals("BothArrows")){
			selectedConnection.setArrow("both");
		}
		else if (command.equals("connReverse")){
			reverseConn();
		}
		//change a transition's Initiator
		else if (command.equals("changeInit")){
		initOrResp = init;
		change = yes;
		sysMsg("select INITIAL State");
		}
		//change a transition's Responder
		else if (command.equals("changeResp")){
			initOrResp = resp;

			if(changeResp.getName() != selectedConnection.getComponent1Name())
			{
				change = yes;
				sysMsg("select RESPONDING State");
			}
			else
			{
				change = no;
				sysMsg("Illegal manipulation of connections!");
				sysMsg("Component cannot talk to itself!");
			}
			
			//change = yes;
			//sysMsg("select RESPONDING State");
		}

		
		//removes connection
		else if(command.equals("connectionRemove")){
			deleteConnection();
		}
	//edit attribute selected
	//- names are displayed to user and they choose which one they wish to edit
	for (int i = 0; i < allAttrs.size(); i++)
	{
		temp = (system.ATagentComponentAttribute) allAttrs.elementAt(i);
		tempName = temp.getName();
		if (command.equals(tempName))
		{
			editAttr = temp;
			attLocation = i;
			editAttribute();
		}
	}
	//edit method selected
	//- names for methods are displayed to user and they choose which one they wish to edit
	for (int i = 0; i < allMethods.size(); i++)
	{
		tempMeth = (system.ATagentComponentMethod) allMethods.elementAt(i);
		tempName = tempMeth.getName();
		if (command.equals(tempName))
		{
			editMethod = tempMeth;
			methLocation = i;
			editMethod();
		}
	}

	stopConnAdd();
	update(this.getGraphics());
}
public void addCompAttr()
{	//displays window to add an attribute
	ComponentAttributeDialog attrDialog = new ComponentAttributeDialog(sys.getNextKey());
	attrDialog.setComp(selectedComponent);
	attrDialog.requestFocus();
	attrDialog.show();
}
public void addCompMethod()
{
	//displays a window to add a method
	ComponentMethodDialog methodDialog = new ComponentMethodDialog(sys.getNextKey());
	methodDialog.setComp(selectedComponent);
	methodDialog.requestFocus();
	methodDialog.show();
}
/**
 * Insert the method's description here.
 * Creation date: (1/4/00 1:12:15 PM)
 */
public void addComponent(int num, String name) {
	stopConnAdd();
	
	//new component
	system.ATagentComponent c = new system.ATagentComponent(version,sys.getNextKey());
	//initialize
	
	//c.setName("Generic" + num);
	c.setName(name);
	c.setCoordinates(50 + ((num-1) % 10)* 75,50 + ((num-1) / 10)* 75,50,50);
	architecture.addComponent(c);
	stopConnAdd();
}
public void changeCompName()
{
	ComponentPropertiesDialog compDialog;
	//displays window to change component name
	compDialog = new ComponentPropertiesDialog(agent,selectedComponent);
	compDialog.requestFocus();
	compDialog.show();
	vectOpen.add(compDialog);
}
/**
 * This method was created in VisualAge.
 */
public void changeInit() {
	//delete the transition from it's states
	selectedConnection.deleteMe();
	//set the current state
	selectedConnection.setComponent1(first);
	//reset the coordinates for the transition
	selectedConnection.setCoordinates(selectedConnection.getComponent1(),selectedConnection.getComponent2());
}
/**
 * This method was created in VisualAge.
 */
public void changeResp() {
	//delete transition from its states
	selectedConnection.deleteMe();
	//set the next state
	selectedConnection.setComponent2(first);
	//reset the coordinates
	selectedConnection.setCoordinates(selectedConnection.getComponent1(),selectedConnection.getComponent2());
}
/**
 * Insert the method's description here.
 * Creation date: (2/1/00 9:35:31 AM)
 */
public void clear() {
	architecture.clear();
}
/**
 * Insert the method's description here.
 * Creation date: (1/27/00 12:53:07 PM)
 */
public void closeWindows() {
	java.util.Enumeration open = vectOpen.elements();
	JDialog win;
	while(open.hasMoreElements()){
		win = (JDialog)open.nextElement();
		win.dispose();
	}
	vectOpen.removeAllElements();
}
public void deleteComponent()
{	//if there are connectors connected to the selectedComponent,
	//the user must first remove those before they can delete the
	//selectedComponent
	if(selectedComponent.connectionCount() > 0){
		sysMsg("Remove connections first");
		sysMsg(selectedComponent.connectionCount() + " connection(s) left");
	} else {
		architecture.removeComponent(selectedComponent);
		sysMsg("Component deleted");
	}
}
public void deleteConnection()
{	//remove a connection and tell user that connection was removed	
	architecture.removeConnection(selectedConnection);
	sysMsg("Connection deleted");
}
public void editAttribute()
{
	//displays another window with the specifications of the attribute to be changed
	ComponentAttributeEditDialog editDialog = new ComponentAttributeEditDialog(allAttrs, attLocation);//.getName(), editAttr.getType(), editAttr.getIsUserDefined(), editAttr.getIsRunTimeDefined(), editAttr.getIsSet(), editAttr.getIsSequence(), editAttr.getIsBag());
	editDialog.setComp(selectedComponent);
	editDialog.requestFocus();
	editDialog.show();
}
public void editMethod()
{
	//displays an editDialog window with the specifications of the method to be edited
	ComponentMethodEditDialog editDialog = new ComponentMethodEditDialog(allMethods, methLocation);
	editDialog.setComp(selectedComponent);
	editDialog.requestFocus();
	editDialog.show();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public boolean findSelectedObject(int x, int y)
{	//gets lists of components and connections
	java.util.Enumeration components = architecture.returnComponents();
	java.util.Enumeration connections = architecture.returnConnections();
	system.ATconnection conn;
	system.ATagentComponent comp;
	boolean stateSel;
	selected = null;
	//checks components to see if one is selected
	while (components.hasMoreElements())
	{
		comp = (system.ATagentComponent) components.nextElement();
		if (comp.checkSelected(x, y) == true)
		{
			selected = "component";
			selectedComponent = comp;
			return true;
		}
	}
	//checks connections to see if one is selected
	while(connections.hasMoreElements()){
		conn = (system.ATconnection) connections.nextElement();
		if(conn.checkSelected(x,y) == false)
		{
			selected = "connection";
			selectedConnection = conn;
			return true;
		}
	}
	return false;
}
/**
 * Insert the method's description here.
 * Creation date: (2/2/01 4:20:02 PM)
 * @return java.awt.Image
 */
public Image formPrintImage() {
		java.util.Enumeration agents = architecture.returnComponents();
		java.util.Enumeration conns = architecture.returnConnections();
	
		Image i = createImage(c[3]+5, c[4]+5);//creates an image with the panel's width and height
		Graphics agentGraphics = i.getGraphics();

		agentGraphics.setColor(Color.white);
		agentGraphics.fillRect(0,0,c[3]+5, c[4]+5);
		agentGraphics.setColor(Color.black);
		agentGraphics.drawString("Agent Template Diagram", 10, 10);
		
		//draws all the roles/messages onto the graphics object g
		while(agents.hasMoreElements()) {
			ATagentComponent agent = (ATagentComponent) agents.nextElement();			
			agent.draw(agentGraphics);
	 	}
		
		while(conns.hasMoreElements()) {
			system.ATconnection conn = (ATconnection) conns.nextElement();
			conn.draw(agentGraphics);
		}
		return i;
}
/**
 * Insert the method's description here.
 * Creation date: (11/30/99 8:19:40 AM)
 * @return system.ATagent
 */
public ATagent getAgent() {
	//returns the agent that this panel describes
	return agent;
}
/**
 * Insert the method's description here.
 * Creation date: (1/18/01 3:06:35 PM)
 * @return int[]
 */
public int[] getPages() {
																	//c[0]-total pages in x-direction
																	//c[1]-total pages in y-direction
																	//c[2]-total number of pages
	int a=0, b=0;
	java.util.Enumeration agents = architecture.returnComponents();
	//pages across equals greatest x coordinate of any of the ATObject/PAGEWIDTH    visibile area of a standard 8.5"
	//pages down equals greatest y coordinate of any of the ATObject/PAGEHEIGHT     by 11" paper respectively w/ this method
	//																	  	     printed in landscape mode
	while(agents.hasMoreElements()) {
		ATagentComponent agent = (ATagentComponent) agents.nextElement();
		if(agent.getGrfx().x2() > a) {
				a = agent.getGrfx().x2();
			}
			if(agent.getGrfx().y2() > b) {
				b = agent.getGrfx().y2();
			}
	}

	c[0] = a/PAGEWIDTH + 1;
	c[1] = b/PAGEHEIGHT + 1;
	c[2] = c[0] * c[1];
	c[3] = a + 10;
	c[4] = b + 10;
	
	return c;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public ATobject getSelectedObject()
{	//returns the currently selected object
	//if currently selected is a component, returns selectedComponent
	if (selected.equals("component"))
	{
		return (ATobject) selectedComponent;
	}
	//if currently selected is a connector, returns selectedConnector
	else if (selected.equals("connector"))
	{
		return (ATobject) selectedConnection;
	}	
	return null;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getSelectedObjectName() {
	//returns selected object's name
	return selected;
}
public void initPanel(system.ATobject object) {
	//initialize everything to null
	first = null;
	selectedComponent = null;
	editAttr = null;
	editMethod = null;
	selectedConnection = null;	
	conn = null;
	closeWindows();

	//vectors of attributes and methods (respectively)
	allAttrs = new Vector();
	allMethods= new Vector();
	attLocation=0;
	methLocation=0;

	if (object instanceof system.ATagent) {
		
		agent = (system.ATagent)object;
		comp = null;
		architecture = agent.getArchitecture();
	} else if (object instanceof system.ATagentComponent) {
		agent = null;
		comp = (system.ATagentComponent)object;
		architecture = comp.getArchitecture();
	}

//	if (object.getClass().getName().equals("system.ATagent")) {
		
	//	agent = null;
//		linestatus = NORMAL;
//		newPt = 0;
		//selectedComponent = null;

//		agent = (system.ATagent)object;

//	}
}
public synchronized boolean mouseDown(int x, int y, system.ATsystem sys) {
	//get lists of components and connections
	java.util.Enumeration components = architecture.returnComponents();
	java.util.Enumeration connections = architecture.returnConnections();
	boolean stateSel;
	boolean sh2 = false;
	selected = null;
	int j = 0;
	x_pos = x;
	y_pos = y;
	system.ATagentComponent comp;
	if(connections!=null){
		while(connections.hasMoreElements()){
			conn=(system.ATconnection)connections.nextElement();
			conn.Selected = false;
		}
		connections = architecture.returnConnections();
	}
	if(change == yes){
		first = null;
		selected = null;
		//loop through states finding selected state
		while(components.hasMoreElements()){
			comp = (system.ATagentComponent)components.nextElement();
			if(comp.checkSelected(x,y) == true) {
				comp.Selected = false;
				first = comp;
			} 
		}
		//if a state has been selected, change the corrert end to the transition
		if(first != null){
			if(initOrResp == init){
				changeInit();
			} else { //InitOrResp == resp
				changeResp();
			}
			change = no;
			return true;
		}
		//otherwise, tell the user that they need to select a state 
		else {
			sysMsg("Select State");
			return true;
		}
			
	}
	//if a connection is NOT being added
	//look for a selected component/connection
	if(linestatus == NORMAL){
		//check components
		while(components.hasMoreElements()){
			comp = (system.ATagentComponent)components.nextElement();
			//find the last selected component and set selected component to it
			if(comp.checkSelected(x,y) == true) {
				selectedComponent = comp;
				selected = "component";
			}				
		}
		components = architecture.returnComponents();
		//set the selected component to selected and return
		if(selected == "component"){
			if(selectedComponent.Selected == false){
				selectedComponent.Selected = true;
				if(shift!=true){
					while(components.hasMoreElements()){
						comp = (ATagentComponent)components.nextElement();
						if(comp!=selectedComponent){
							comp.Selected = false;
						}
					}
				}
			} else {
				if(shift==true){
					selectedComponent.Selected = false;
				}
				if((shift==true)&&(selectedComponent.Selected == true)){
					selectedComponent.Selected = false;
				}
			}
			return true;
		} else {
			components = architecture.returnComponents();
			while(components.hasMoreElements()){
				comp = (ATagentComponent)components.nextElement();
				comp.Selected = false;
			}
		}
		
		components = architecture.returnComponents();
		while(connections.hasMoreElements()){
			conn = (system.ATconnection)connections.nextElement();
			conn.checkSelected(x,y);
			if(conn.Selected){
				selectedConnection = conn;
				selected = "conn";
				return true;
			}
		}	
	}
	if(linestatus == WAIT_FIRST_POINT){
		selected = null;
		while(connections.hasMoreElements()){
			conn = (system.ATconnection)connections.nextElement();
		}
		components = architecture.returnComponents();
		while(components.hasMoreElements()){
			comp = (system.ATagentComponent)components.nextElement();
			if(comp.checkSelected(x,y) == true) {
				first = comp;
				linestatus = WAIT_SECOND_POINT;
				sysMsg("  Select COMPONENT2");
				return true;
			}
		}
	}
	if(linestatus == WAIT_SECOND_POINT){
		while(connections.hasMoreElements()){
			conn = (system.ATconnection)connections.nextElement();
		}
		components = architecture.returnComponents();
		while(components.hasMoreElements()){
			comp = (system.ATagentComponent)components.nextElement();
			if(comp.checkSelected(x,y) == true) {
				conn.setCoordinates(first,comp);
				linestatus = NORMAL;
				selected = "connection";
				selectedConnection = conn;
				sysMsg("Connection Added");
				//architecture.addConnection(conn);
				update(this.getGraphics());
				return true;
			}
		}
	}
	selected = null;
	return true;
}
public synchronized boolean mouseDrag(int x, int y, system.ATsystem sys) {
	if((x>0)&&(y>0)){
		//get components and connections
		java.util.Enumeration components = null;
		if(architecture.getComponentCount()>0){
			components = architecture.returnComponents();
		}
		java.util.Enumeration connections = null;
		if(architecture.getConnectionCount()>0){
			connections = architecture.returnConnections();
		}
		//change in position of mouse
		x_pos = x;
		y_pos = y;

		system.ATagentComponent selComp = null;
		system.ATconnection selConn = null;
		//		
		while(components.hasMoreElements()){		//find which state is selected
			selComp = (system.ATagentComponent)components.nextElement();	
			if(selComp.Selected == true){
				selComp.move(x,y);	//if a comp is selected, move it.
			}
		}

		if(connections != null) {
			selConn = (system.ATconnection)connections.nextElement();
			while((connections.hasMoreElements())&&(!conn.Selected)){
				selConn = (system.ATconnection)connections.nextElement();
			}
			if(selConn.Selected){
				if(newPt == 0){
					selConn.addPoint(x,y);
					newPt = 1;
				}
				selConn.movePoint(x,y);
			}
		}
	}
	return true;
}
	public synchronized boolean mouseUp(int x, int y, system.ATsystem sys) {
		newPt = 0;
		//arrange points of selected transition
		if(selectedConnection.Selected){
			selectedConnection.arrange_pts();
		}

					
		return true;
	}
	/**
	 * Paint the previous frame (if any).
	 */
public void paint(Graphics g) {
	Dimension d = getSize();
	g.setColor(Color.white);
	g.fillRect(0, 0, d.width, d.height);
	g.setColor(Color.black);

	java.util.Enumeration components = architecture.returnComponents();
	java.util.Enumeration connections = architecture.returnConnections();
		
	//draw the components
	while (components.hasMoreElements()) {
		system.ATagentComponent comp = (system.ATagentComponent)components.nextElement();
		comp.draw(g);
	}
	//draw the connections
	while (connections.hasMoreElements()) {
		ATconnection conn = (ATconnection)connections.nextElement();
		conn.draw(g);
	}
		
/*	if (offImage != null) {
	    g.drawImage(offImage, 0, 0, null);
	}
*/
}
/**
 * Insert the method's description here.
 * Creation date: (2/10/00 10:05:01 AM)
 */
public void printPage(Graphics g, int pageIndex, Image i) {
	try {
		int xpage = pageIndex % c[0];
		int ypage = (pageIndex/c[0]) % c[1];
		
		if(fullsize) {
			g.drawImage(i, 72, 72, 540, 720,//<--destination rectangle
				    xpage*PAGEWIDTH, ypage*PAGEHEIGHT, xpage*PAGEWIDTH+PAGEWIDTH, ypage*PAGEHEIGHT+PAGEHEIGHT, null);
		}
		else {
			g.drawImage(i, 72, 72, 540, 72 + (c[4] * 468 / c[3]),//<--destination rectangle
					        0,  0, c[3], c[4], null);
//			g.drawImage(i, 72, 72, 540, 720,//<--destination rectangle
//	        0,  0, c[0]*PAGEWIDTH, c[1]*PAGEHEIGHT, null);
		}
	}
	 catch (Exception e) {
		System.out.println(e);
	 }
}
/**
 * This method was created in VisualAge.
 * @param e MouseEvent
 */
public synchronized void processMouseEvent(java.awt.event.MouseEvent e)
{
	//if the popup trigger has been hit (ie- the right mouse button)
	if (e.isPopupTrigger())
	{
		System.out.println("Popup");
		//get the position
		x_pos = e.getX();
		y_pos = e.getY();
		//find the object at that position
		if (findSelectedObject(x_pos, y_pos)){
			//remove all previous popup menu items
			
			if(selected != null) {
				popup.removeAll();
				
				//add correct menu items for component or connection
				if (selected.equals("component")) {
					setComponentPopup();
				} else if(selected.equals("connection")) {
					setConnectionPopup();
				}
				
				popup.show(this, e.getX(), e.getY());
	
			//show the popup menu
			// !!! If you don't add something to popup after doing a removeAll(),
			//  and then call show(), it will lock up the popup and you won't be
			//  able to use it again.  To fix this, I added the if(selected != null)
			//  ensure that we will always have an active popup.  -JAG 1-5-01
			}		
		}
	}
	else{
		super.processMouseEvent(e); // Pass other event types on.
	}
}
public void reverseConn() {
	//delete connection from current position - used for graphics
//	selectedConnection.deleteMe();
	//reset coordinates
//	selectedConnection.setCoordinates(selectedConnection.getComponent2(),
		//                              selectedConnection.getComponent1());
	//tell user connection was reversed
	selectedConnection.reverse();
	sysMsg("Connection Reversed");
}
/**
 * This method was created in VisualAge.
 * @param conv system.ATconversation
 */
public void setAgent(system.ATagent a)
{
	//set agent for this page and get its architecture
	//this.agent = a;
	//this.architecture = agent.getArchitecture();
	
	initPanel(a);
}
/**
 * This method was created in VisualAge.
 * @param conv system.ATconversation
 */
public void setComp(system.ATagentComponent a)
{	//set component for this page and get its architecture
	//comp = a;
	//architecture = comp.getArchitecture();

	initPanel(a);
}
/**
 * This method was created in VisualAge.
 */
public void setComponentPopup()
{
	//set component popup menu items
	//"Properties","Add Attribute", "Edit Attribute", "Add Method"
	//"Edit Method", and "Delete"
	//Also, the Edit Attribute & Edit Method are menus, 
	//so there menu items must be set
	allAttrs = selectedComponent.getAttributes();
	allMethods = selectedComponent.getMethods();
	
	componentName = new MenuItem("Properties");
	componentName.setActionCommand("componentName");
	componentName.addActionListener(this);
	popup.add(componentName);

	popup.addSeparator();
	
	componentAttr = new MenuItem("Add Attribute");
	componentAttr.setActionCommand("componentAttr");
	componentAttr.addActionListener(this);
	popup.add(componentAttr);
	
	Menu attrMenu = new Menu((String) "Edit Attribute");
	//set "Edit Attribute"'s menu items (all the atributes)
	for (int i = 0; i < allAttrs.size(); i++)
	{
		system.ATagentComponentAttribute temp = (system.ATagentComponentAttribute) allAttrs.elementAt(i);
		attr = new MenuItem(temp.getName());
		attr.setActionCommand(temp.getName());
		attr.addActionListener(this);
		attrMenu.add(attr);
	}
	componentAttrEdit = (MenuItem) attrMenu;
	popup.add(componentAttrEdit);
	
	componentMethod = new MenuItem("Add Method");
	componentMethod.setActionCommand("componentMethod");
	componentMethod.addActionListener(this);
	popup.add(componentMethod);
	
	
	Menu methMenu = new Menu((String) "Edit Method");
	//set "Edit Method"'s menu items (all the methods)
	for (int i = 0; i < allMethods.size(); i++)
	{
		system.ATagentComponentMethod temp = (system.ATagentComponentMethod) allMethods.elementAt(i);
		meth = new MenuItem(temp.getName());
		meth.setActionCommand(temp.getName());
		meth.addActionListener(this);
		methMenu.add(meth);
	}
	componentMethodEdit = (MenuItem) methMenu;
	popup.add(componentMethodEdit);
	
	popup.addSeparator();
	
	componentRemove = new MenuItem("Delete");
	componentRemove.setActionCommand("componentRemove");
	componentRemove.addActionListener(this);
	popup.add(componentRemove);

}
/**
 * This method was created in VisualAge.
 */
public void setConnectionPopup()
{
	//set menu items for connection popup menu
	//allows user to decide where the arrow will point
	sysMsg("Comp1 : " + selectedConnection.getComponent1Name());
	if(selectedConnection.getComponent2() == null)
		sysMsg("Comp2 : null");
	else {
		sysMsg("Comp2 : " + selectedConnection.getComponent2Name());
	}
	//gets rid of certain commands if the selected component is the green dotted arrow
	if(selectedConnection.getComponent2() != null)
	{
	/*	//get the first component's name and set it to arrow1
		Arrow1 = new MenuItem(selectedConnection.getComponent1Name());
		Arrow1.setActionCommand("Arrow1");
		Arrow1.addActionListener(this);
		popup.add(Arrow1);
		//if there's a second component, set it's name to arrow2
		//otherwise set arrow2 to "FrameWork"
		if(selectedConnection.getComponent2() != null){
			Arrow2 = new MenuItem(selectedConnection.getComponent2Name());
		} else {
			Arrow2 = new MenuItem("FrameWork");
		}
		Arrow2.setActionCommand("Arrow2");
		Arrow2.addActionListener(this);
		popup.add(Arrow2);
		popup.addSeparator();*/
		//add selection to have arrows to both arrow1 and arrow2
		ArrowBoth = new MenuItem("BothArrows");
		ArrowBoth.setActionCommand("BothArrows");
		ArrowBoth.addActionListener(this);
		popup.add(ArrowBoth);

		Arrow2 = new MenuItem("OneArrow");
		Arrow2.setActionCommand("Arrow2");
		Arrow2.addActionListener(this);
		popup.add(Arrow2);
		
		connReverse = new MenuItem("Reverse");
		connReverse.setActionCommand("connReverse");
		connReverse.addActionListener(this);
		popup.add(connReverse);

		changeInit = new MenuItem("Change Initiator");	
		changeInit.setActionCommand("changeInit");
		changeInit.addActionListener(this);
		popup.add(changeInit);
	}
		
	changeResp = new MenuItem("Change Responder");
	changeResp.setActionCommand("changeResp");
	changeResp.addActionListener(this);
	popup.add(changeResp);
	
	//add delete arrow selection
	popup.addSeparator();
	connectionRemove = new MenuItem("Delete");
	connectionRemove.setActionCommand("connectionRemove");
	connectionRemove.addActionListener(this);
	popup.add(connectionRemove);

}
/**
 * Insert the method's description here.
 * Creation date: (6/20/00 10:50:06 AM)
 * @param sys system.ATsystem
 */
public void setSystem(ATsystem sys) {
	this.sys = sys;
	}
/**
 * This method was created in VisualAge.
 */
public void startConnAdd(system.ATconnection c) {
	if(architecture.getComponentCount() >0){
		//set linestatus to wait for the first point
		linestatus = WAIT_FIRST_POINT;
		//add the connection to the architecture
		architecture.addConnection(c);
		//output a message to the user
		sysMsg("  Select COMPONENT1");
		conn=c;
	} else {
		//if there aren't any components, tell user they must
		//first add components
		sysMsg("  must first have components");
	}
			
}
/**
 * This method was created in VisualAge.
 */
public void stopConnAdd() {
	if(linestatus != NORMAL) {
		linestatus = NORMAL;
		sysMsg(" <cancel operation>");
	}
}
	//- - - - - - - - - - - - - - -
	// Draw objects on panel
	//- - - - - - - - - - - - - - -
public void update() {
	if(comp != null) {
		System.out.println("forced paint");
		repaint();
		//paint(this.getGraphics());
	}

/*	g = this.getGraphics();
	// Get size of panel
	Dimension d = getSize();
		//set the background color
	//	g.setColor(Color.white);
	//	g.fillRect(0,0,d.width,d.height);
	//get a list of components and connections

	if ((offGraphics == null)
	 || (d.width != offDimension.width)
	 || (d.height != offDimension.height)) {
		    offDimension = d;
		    offImage = super.createImage(d.width, d.height);
		    if(offImage == null) System.out.println("null Image");
		    offGraphics = offImage.getGraphics();
	}
	offGraphics.setColor(Color.white);
	offGraphics.fillRect(0, 0, d.width, d.height);
	offGraphics.setColor(Color.black);

	java.util.Enumeration components = architecture.returnComponents(); // return components
	java.util.Enumeration connections = architecture.returnConnections();
		
	//draw the components
	while (components.hasMoreElements()) {
		system.ATagentComponent comp = (system.ATagentComponent)components.nextElement();
		comp.draw(offGraphics);
	}
	//draw the connections
	while (connections.hasMoreElements()) {
		ATconnection conn = (ATconnection)connections.nextElement();
		conn.draw(offGraphics);
	}

	g.drawImage(offImage,0,0,null);
*/
	
}
}
