package Editor;

import system.*;
/**
 * This type was created in VisualAge.
 * This panel is used to difine all state tables.
 * Two for every conversation, one for each component,
 * and one for each task
  *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
 import java.awt.*;
public class ConversationPanel extends ATpanel {
	//conversation/component & statetable this panel represents
	private system.ATconversation conv = null;
	private system.ATagentComponent comp = null;
	private system.ATTask task = null;
	private system.ATstatetable table = null;

	//new transition that is being added to statetable
	private system.ATtransition newtran = null;

	//currently selected state and transition
	private system.ATtableElement selectedState = null;
	private system.ATtransition selectedTransition = null;

	//used to change initiator and responder of transition
	private system.ATtableElement first = null;
	
	//Menu Items for states
	private MenuItem statePref,
					 defineActions,
					 deleteState;

	//Menu Items for transitions
	private MenuItem transPref,
					 deleteTrans,
					 reverseTrans,
					 deleteError,
					 changeInit,
					 changeResp;

	//tells if this represents the initiator or respnder
	private int InitOrResp = 0;
/**
 * This method was created in VisualAge.
 */
public ConversationPanel(double v) {
	super(v);
	this.enableEvents(AWTEvent.MOUSE_EVENT_MASK);
	this.enableEvents(AWTEvent.MOUSE_MOTION_EVENT_MASK);
	popup = new PopupMenu();
	
	this.add(popup);
}
/**
 * This method was created in VisualAge.
 */
  public void actionPerformed(java.awt.event.ActionEvent event) {
	String command = event.getActionCommand();
	//change a state's prefrences
	if (command.equals("statePreferences")) {
		
		ObjName objN = new ObjName(selectedState);
		objN.show();

		String cname = selectedState.getName();
		String cnameL = cname;
		int i=2;

		//to prevent repeat names
		while(table.repeatName(cnameL)) {//if not unique
			cnameL = cname + "(" + Integer.toString(i) + ")";
			selectedState.setName(cnameL);
			i++;
		}

		java.util.Enumeration trans=table.returnTrans();
		while(trans.hasMoreElements()){
			selectedTransition = (system.ATtransition)trans.nextElement();
			if(selectedTransition.getCurrentState()==selectedState || selectedTransition.getNextState()==selectedState) {
				//paint(this.getGraphics());
				selectedTransition.resize((ATstate)selectedState);
			}
		}

		
	}
	//delete a state
	else if (command.equals("deleteState")){
		System.out.println("look : " +table.ownername);
		System.out.println("look : " +table.agentname);
		deleteState();
	}
	//define actions
	else if (command.equals("defineActions")){
		defineActions(1);
	}
	else if (command.equals("defineActions2")){
		defineActions(0);
	}
	//define a transitions prefrences
	else if (command.equals("transPreferences")){
		changeTransPrefs();
	}
	//delete a transition
	else if (command.equals("deleteTrans")){
		deleteTrans();
	}
	//reverse a transition
	else if (command.equals("reverseTrans")){
		reverseTrans();
	}
	else if (command.equals("startTrans")){
		selectedTransition.setStart(!selectedTransition.getStart());
	}
	else if (command.equals("endTrans")){
		selectedTransition.setEnd(!selectedTransition.getEnd());
	}
	//delete an Error
	else if (command.equals("deleteError")){
		deleteError(1);
	}
	//change a transition's Initiator
	else if (command.equals("changeInit")){
		initOrResp = init;
		change = yes;
		sysMsg("select INITIAL State");
	}
	//change a transition's Responder
	else if (command.equals("changeResp")){
		initOrResp = resp;
		change = yes;
		sysMsg("select RESPONDING State");
	}
	else if(command.equals("deleteError2")){
		deleteError(2);
	}

	stopTransAdd();
	//update(system.ATsystem sys, int InitOrResp, Graphics g)
	repaint();
	//paint(this.getGraphics());
}
/**
 * Insert the method's description here.
 * Creation date: (5/16/00 10:48:02 AM)
 * @param s system.ATstate
 */
public void addState(ATstate s) {
	stopTransAdd();
	table.addState(s);
}
/**
 * This method was created in VisualAge.
 */
public void changeInit() {
	//delete the transition from it's states
	selectedTransition.deleteMe();
	//set the current state
	selectedTransition.setCurrentState(first);
	//reset the coordinates for the transition
	selectedTransition.setCoordinates(selectedTransition.getCurrentState(),selectedTransition.getNextState());
}
/**
 * This method was created in VisualAge.
 */
public void changeResp() {
	//delete transition from its states
	selectedTransition.deleteMe();
	//set the next state
	selectedTransition.setNextState(first);
	//reset the coordinates
	selectedTransition.setCoordinates(selectedTransition.getCurrentState(),selectedTransition.getNextState());

}
/**
 * This method was created in VisualAge.
 */
public void changeTransPrefs() {
	//create new TransPropertiesDialog window
	TransPropertiesDialog prefDialog = 
		new TransPropertiesDialog(selectedTransition.getRecMessage(), 
							 selectedTransition.getGuardCondition(),
							 selectedTransition.getTransMessage());//,
		//					 selectedTransition.getAction());
	//set the transition for the TransPropertiesDialog window
	prefDialog.setTrans(selectedTransition);
	//request focus and show window
	prefDialog.requestFocus();
	prefDialog.show();		
}
/**
 * Insert the method's description here.
 * Creation date: (2/1/00 9:35:31 AM)
 */
public void clear() {
	//clear the table
	table.clear();
}
/**
 * Insert the method's description here.
 * Creation date: (2/24/00 9:10:19 AM)
 */
public void defineActions(int StateOrTran) {
	ActionPanel actionP = new ActionPanel();
	//	actionP.setlist(selectedState.getActions());
	if(StateOrTran == 1){
		actionP.setState(selectedState);
	} else {
		actionP.setTran(selectedTransition);
	}
	actionP.requestFocus();
	actionP.show();
}
/**
 * This method was created in VisualAge.
 */
public void deleteError(int j) {
	//set errorSelected in transition to false
	//(so it won't draw the error)
	if (j==1){
		selectedTransition.errorSelected = false;
	} else if (j==2){
		selectedState.errorSelected = false;
	}
	//tell user Error was deleted
	sysMsg("Error Deleted");

}
public void deleteState() {
	//if the selectedState is a system.ATstate
	//(if it's not then it's the START or END state)
	if (selectedState instanceof system.ATstate) {
		//check to make sure no transitions are attached to it
		if (((system.ATstate)selectedState).transitionCount() < 1) {
			//if there are no transitions, delete the state
			table.removeState(selectedState);
			sysMsg("State deleted");
		} else {
			//if there are transitions, tell user to remove them first
			sysMsg("Remove transitions first");
		}
	} else {
		//if START or END state, tell user they can not delete them 
		sysMsg("Cannot delete START or END");
	}
}
public void deleteTrans() {
	//delete transition from the table
	table.removeTransition(selectedTransition);
	sysMsg("Transition deleted");
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public boolean findSelectedObject(int x, int y) {
	//get lists of the states and transitions in the table
	java.util.Enumeration states = table.returnStates();
	java.util.Enumeration trans  = table.returnTrans();
	
	//set selected to null
	selected = null;
	//two variables to work through state and transtion lists
	system.ATtableElement state;
	system.ATtransition tran;
	
	//states = table.returnStates();
	//trans = table.returnTrans();

	//loop through states checking to find last one that is selected
	//because that will be that state that is on top (in case one
	//is on another, we don't want the user to try and change the
	//visible state and accidentally change the hidden state)
	while(states.hasMoreElements()){
		state = (system.ATtableElement)states.nextElement();
		if(state.checkSelected(x,y) == false) {
			selected = "state";
			selectedState = state;
		}
	}
	//if a state was selected, delete the last selected state
	if(selected == "state"){
		return true;
	}
		
	//loop through transitions checking to see if one is selected	
	while(trans.hasMoreElements()){
		tran = (system.ATtransition)trans.nextElement();
		if(tran.checkSelected(x,y) == false) {
			selected = "trans";
			selectedTransition = tran;
			return true;
		}
	}
	return false;
}
/**
 * Insert the method's description here.
 * Creation date: (2/2/01 4:18:40 PM)
 * @return java.awt.Image
 */
public Image formPrintImage() {
		java.util.Enumeration states = table.returnStates();
		java.util.Enumeration trans = table.returnTrans();

		Image i = createImage(c[3]+5, c[4]+5);//creates an image with the panel's width and height
		Graphics convGraphics = i.getGraphics();

		convGraphics.setColor(Color.white);
		convGraphics.fillRect(0,0,c[3]+5, c[4]+5);
		convGraphics.setColor(Color.black);

		if(conv!=null){
			if(InitOrResp==init){
				convGraphics.drawString(conv.getName() + " Initiator", 10,10);
			} else {
				convGraphics.drawString(conv.getName() + " Responder", 10,10);
			}
		} else if(task!=null) {
			convGraphics.drawString(task.getName(), 10,10);
		} else {
			convGraphics.drawString(comp.getName(), 10,10);
		}
	
		convGraphics.drawString(table.ownername, 10, 10);
		
		while(states.hasMoreElements()) {
			system.ATtableElement state = (ATtableElement) states.nextElement();
			state.draw(convGraphics);
		}
		while(trans.hasMoreElements()) {
			system.ATtransition tran = (ATtransition) trans.nextElement();
			tran.draw(convGraphics);
		}
		return i;
}
/**
 * Insert the method's description here.
 * Creation date: (1/19/01 4:11:46 PM)
 * @return int[]
 */
public int[] getPages() {
																	//c[0]-total pages in x-direction
																	//c[1]-total pages in y-direction
																	//c[2]-total number of pages
	int a=0, b=0;
	ATendState fin = table.getEndClone();
	ATstartState begin = table.getStartClone();
	java.util.Enumeration states = table.returnStates();
	//pages across equals greatest x coordinate of any of the ATObject/PAGEWIDTH    visibile area of a standard 8.5"
	//pages down equals greatest y coordinate of any of the ATObject/PAGEHEIGHT     by 11" paper respectively w/ this method
	//																				printed in landscape mode
	while(states.hasMoreElements()) {
		ATtableElement state = (ATtableElement) states.nextElement();
		if(state.getGrfx().x2() > a) {
			a = state.getGrfx().x2();
		}
		if(state.getGrfx().y2() > b) {
			b = state.getGrfx().y2();
		}
	}
	int z[];
	z=fin.getGrfx().getCoords();
	if(z[4]+z[2] > a) {
		a = z[4]+z[2];
	}
	if(z[5]+z[3] > b) {
		b = z[5]+z[3];
	}
	z=begin.getGrfx().getCoords();
	if(z[4]+z[2] > a) {
		a = z[4]+z[2];
	}
	if(z[5]+z[3] > b) {
		b = z[5]+z[3];
	}
	c[0] = a/PAGEWIDTH + 1;
	c[1] = b/PAGEHEIGHT + 1;
	c[2] = c[0] * c[1];
	c[3] = a + 10;
	c[4] = b + 10;
	
	return c;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public ATobject getSelectedObject() {
	//return the selected object
	//if the selected object is a state, return selectedState
	if (selected.equals("state"))
	{
		return selectedState;
	}
	//if the selected object is a line, return selectedTransition
	if (selected.equals("line"))
	{
		return selectedTransition;
	}
	//if neither are selected, return null
	return null;	

}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getSelectedObjectName() {
	return selected;
}
/**
 * Insert the method's description here.
 * Creation date: (1/19/01 1:46:58 PM)
 * @return int
 */
public int getStateCount() {
	return table.getStateCount();
}
public void initPanel(system.ATobject object) {
	//make sure input is a statetable
	if (object instanceof system.ATstatetable) {
		//initialize everything to null
	
		system.ATtransition tran;
		newtran = null;
		selectedState = null;
		selectedTransition = null;
		first = null;	
		linestatus = NORMAL;
		newPt = 0;

		//get the statetable
		table = (system.ATstatetable)object;

		//get lists of states and transitions
		java.util.Enumeration states = table.returnStates();
		java.util.Enumeration trans  = table.returnTrans();
		system.ATtableElement state;
		
		//if there are states, loop through them and set them to be
		//not selected
		if (states != null){
			while(states.hasMoreElements()){
				state = (system.ATtableElement)states.nextElement();
				state.Selected = false;
			//	state.corner = false;
			}
		}
		
		//if there are transitions set all of them to be not selected
		if (trans != null){
			while(trans.hasMoreElements()){
				tran = (system.ATtransition)trans.nextElement();
				tran.Selected = false;
			}
		}
	} else {
		System.out.println("Error, attempt to initialize Conversation Panel to invalid ATstatetable");
	}
}
public synchronized boolean mouseDown(int x, int y, system.ATsystem sys) {
	//get lists of the states and transitions
	java.util.Enumeration states = table.returnStates();
	java.util.Enumeration trans  = table.returnTrans();
	
	//true if a state is selected
	boolean stateSel;
	boolean sh2 = false;//shift 2 was used
	
	//set selected to null
	selected = null;

	//position of mouse at mouse down
	x_pos = x;
	y_pos = y;

	//state and transition used to go through lists
	system.ATtableElement state;
	system.ATtransition tran = null;

	if(trans!=null){
		while(trans.hasMoreElements()){
			tran = (system.ATtransition)trans.nextElement();
			tran.Selected = false;
		}
	}
	trans = table.returnTrans();
	//if a transitions initiator or responder is going to be changed
	if(change == yes){
		first = null;
		selected = null;
		//loop through states finding selected state
		while(states.hasMoreElements()){
			state = (system.ATtableElement)states.nextElement();
			if(state.checkSelected(x,y) == false) {
				state.Selected = false;
				first = state;
			} 
		}
		//if a state has been selected, change the corrert end to the transition
		if(first != null){
			if(initOrResp == init){
				changeInit();
			} else { //InitOrResp == resp
				changeResp();
			}
			change = no;
			return true;
		}
		//otherwise, tell the user that they need to select a state 
		else {
			sysMsg("Select State");
			return true;
		}
			
	}
	//if nothing is being added or changed
	if(linestatus == NORMAL){
		while(states.hasMoreElements()){
			state = (system.ATtableElement)states.nextElement();
			//find the last selected agent
			if(state.checkSelected(x,y) == false) {
				selectedState= state;
				selected = "state";
			}
		}
		states = table.returnStates();
		//if there's a selected agent, set to selected and return
		if(selected == "state"){
			if(!selectedState.Selected){
				selectedState.Selected = true;
				if(shift!= true){
					while(states.hasMoreElements()){
						state = (system.ATtableElement)states.nextElement();
						if(state!=selectedState){
							state.Selected = false;
						}
					}
			//		shift2 = false;
				} else {
			//		shift2 = true;
				}
			}
			else {
				if(shift==true){
					selectedState.Selected = false;
			//		shift2 = true;
				}
				else {
			//		shift2 = false;
				}
				if((shift == true)&&(selectedState.Selected)){
					selectedState.Selected = false;
				}
			}
			
			return true;
		} else {
			states = table.returnStates();
			while(states.hasMoreElements()){
				state = (system.ATtableElement)states.nextElement();
				state.Selected = false;
			//	state.corner = false;
			}
		}
		
		states = table.returnStates();
		while(states.hasMoreElements()){
			state = (system.ATtableElement)states.nextElement();
		//	state.checkCorners(x,y);
		/*	if(state.corner == true) {
				selected = "state";
				selectedState = state;
				return true;
			}*/
		}
		
		while(trans.hasMoreElements()){
			tran = (system.ATtransition)trans.nextElement();
			tran.checkSelected(x,y);
			if(tran.Selected) {
				selected = "trans";
				selectedTransition = tran;
				return true;
			}
		}
		if(tran != null){
			if(tran.Selected) {return true;}
		}

	}
	
	if(linestatus == WAIT_FIRST_POINT){
		selected = null;
		//tran = new system.ATtransition(version);
		states = table.returnStates();
		while(states.hasMoreElements()){
			state = (system.ATtableElement)states.nextElement();
			if(state.checkSelected(x,y) == false) {
				state.Selected = false;
				first = state;
				newtran.setCurrentState(first);
				linestatus = WAIT_SECOND_POINT;
				sysMsg("  select NEXT State");
			 	return true;
			}
		}
	}
	if(linestatus == WAIT_SECOND_POINT){
		states = table.returnStates();
		while(states.hasMoreElements()){
			state = (system.ATtableElement)states.nextElement();
			if(state.checkSelected(x,y) == false) {
				if(first==state){
					
					if(first instanceof system.ATstartState ||
						first instanceof system.ATendState ){
							sysMsg("select State");
							return true;
					}
				}
				state.Selected = false;
				newtran.setNextState(state);
				newtran.setCoordinates(first,state);
				linestatus = NORMAL;
				table.addTransition(newtran);
				sysMsg("Transition Added");					
				return true;
			}
		}
	}
	selected = null;
	return true;
}
public synchronized boolean mouseDrag(int x, int y, system.ATsystem sys) {
	if((x>0)&&(y>0)){

		java.util.Enumeration states = table.returnStates();

		if (states == null) {return true;}
		
		java.util.Enumeration trans  = table.returnTrans();
		x_pos = x;
		y_pos = y;

		system.ATtableElement state = null;
		system.ATtransition tran = null;
		
		//find which state is selected
		while(states.hasMoreElements()){
			state = (system.ATtableElement)states.nextElement();	
			if(state.Selected == true){	
				//if a state is selected, move it
				state.move(x,y);	
				if (trans != null) {
					boolean connected;
					while(trans.hasMoreElements()){
						tran = (system.ATtransition)trans.nextElement();
						connected = tran.checkState(state);
					}
				}
			}
		}

		trans = table.returnTrans();
		//if there are no transitions, return
		if (trans == null) {return true;}		
		//get next transition
		tran = (system.ATtransition)trans.nextElement();
		while((trans.hasMoreElements())&&(!tran.Selected)) {
			tran = (system.ATtransition)trans.nextElement();
		}
		//if selected tran is null, return
		if (tran == null) {return true;}
		//if tran is selected
		if(tran.Selected) {
			//add a new point is it hasn't already been added
			if(newPt == 0){
				tran.addPoint(x,y);
				newPt = 1;
			}
			//move the new point
			tran.movePoint(x,y);
		}
	}
	return true;
}
public synchronized boolean mouseUp(int x, int y, system.ATsystem sys) {
	//set new point to zero
		newPt = 0;
		//arrange points of selected transition
		if(selectedTransition.Selected){
			selectedTransition.arrange_pts();
		}
				
		return true;
	}
/**
 * Insert the method's description here.
 * Creation date: (1/8/01 11:38:28 AM)
 * @param g java.awt.Graphics
 */
public void paint(Graphics g) {
	Dimension d = getSize();
	g.setColor(Color.white);
	g.fillRect(0, 0, d.width, d.height);
	g.setColor(Color.black);

	//if item that this panel represents is a conversation,
	//draw the conversation's components
	
	if(conv != null){
		conv.draw(g,InitOrResp);
	} else if(task != null){
		task.drawDiag(g);
	} else if(comp != null){
		comp.drawDiag(g);
	} 
			
}
/**
 * Insert the method's description here.
 * Creation date: (2/10/00 10:05:01 AM)
 */
public void printPage(Graphics g,int pageIndex, Image i) {
	try {
		int xpage = pageIndex % c[0];
		int ypage = (pageIndex/c[0]) % c[1];
		if(fullsize) {
			g.drawImage(i, 72, 72, 540, 720,//<--destination rectangle
				    xpage*PAGEWIDTH, ypage*PAGEHEIGHT, xpage*PAGEWIDTH+PAGEWIDTH, ypage*PAGEHEIGHT+PAGEHEIGHT, null);
		}
		else {
			g.drawImage(i, 72, 72, 540, 72 + (c[4] * 468 / c[3]),//<--destination rectangle
					        0,  0, c[3], c[4], null);
//			g.drawImage(i, 72, 72, 540, 720,//<--destination rectangle
//	        0,  0, c[0]*PAGEWIDTH, c[1]*PAGEHEIGHT, null);
		}
	}
	catch (Exception e) {
		System.out.println(e);
	}
}
/**
 * This method was created in VisualAge.
 * @param e MouseEvent
 */
public synchronized void processMouseEvent(java.awt.event.MouseEvent e) {
	//if mouse event it right mouse button
	if(e.isPopupTrigger()) {
		//get position of mouse
		x_pos = e.getX();
		y_pos = e.getY();
		//find the selected object
		if(findSelectedObject(x_pos,y_pos)){
			//get rid of old popup menu items
			if(selected != null) {
				popup.removeAll();
				
				//add correct menu items for component or connection
				if(selected.equals("state")){
					setStatePopup();
				} else if(selected.equals("trans")){
					setTransPopup();
				}
			
				popup.show(this, e.getX(), e.getY());
	
			//show the popup menu
			
			// !!! If you don't add something to popup after doing a removeAll(),
			//  and then call show(), it will lock up the popup and you won't be
			//  able to use it again.  To fix this, I added the if(selected != null)
			//  ensure that we will always have an active popup.  -JAG 1-5-01
			}
		}
	}
	//handle other mouse events
	else super.processMouseEvent(e);  // Pass other event types on.
}
public void reverseTrans() {
	//reverse transition and notify
	//user that the transition was reversed
	selectedTransition.reverse();
	sysMsg("Transition Reversed");
}
/**
 * This method was created in VisualAge.
 * @param conv system.ATconversation
 */
public void setComponent(system.ATagentComponent comp) {
	//set the panel's component
	this.comp = comp;
	conv = null;
	task = null;
	//initialize the panel using the table
	initPanel(comp.getStateTable());
}
/**
 * This method was created in VisualAge.
 * @param conv system.ATconversation
 */
public void setConversation(system.ATconversation conv, int InitOrResp) {
	//set the panel's conversation
	this.conv = conv;
	this.InitOrResp = InitOrResp;
	comp = null;
	task = null;
	//initialize the panel
	initPanel(conv.getStateTable(InitOrResp));
}
/**
 * Insert the method's description here.
 * Creation date: (11/28/00 3:20:35 PM)
 * @param x int
 */
public void setInitOrResp(int x) {
	InitOrResp = x;
}
/**
 * This method was created in VisualAge.
 */
public void setStatePopup() {
	if(selectedState instanceof ATstartState || selectedState instanceof ATendState) {
		//statePref = new MenuItem("Properties");
		//statePref.setActionCommand("statePreferences");
		//statePref.addActionListener(this);
		//popup.add(statePref);
	
		//popup.addSeparator();
		deleteError = new MenuItem("DeleteError");
		deleteError.setActionCommand("deleteError2");
		deleteError.addActionListener(this);
		popup.add(deleteError);
	
		//deleteState = new MenuItem("Delete");
		//deleteState.setActionCommand("deleteState");
		//deleteState.addActionListener(this);
		//popup.add(deleteState);
	}
	else {
		statePref = new MenuItem("Properties");
		statePref.setActionCommand("statePreferences");
		statePref.addActionListener(this);
		popup.add(statePref);

	
		defineActions = new MenuItem("Define Actions");
		defineActions.setActionCommand("defineActions");
		defineActions.addActionListener(this);
		popup.add(defineActions);
	
		popup.addSeparator();
		deleteError = new MenuItem("DeleteError");
		deleteError.setActionCommand("deleteError2");
		deleteError.addActionListener(this);
		popup.add(deleteError);
	
		deleteState = new MenuItem("Delete");
		deleteState.setActionCommand("deleteState");
		deleteState.addActionListener(this);
		popup.add(deleteState);
	}
}
/**
 * This method was created in VisualAge.
 * @param conv system.ATconversation
 */
public void setTask(system.ATTask task) {
	//set the panel's component
	this.task = task;
	conv = null;
	comp = null;
	//initialize the panel using the table
	initPanel(task.getStateTable());
}
/**
 * This method was created in VisualAge.
 */
public void setTransPopup() {
	transPref = new MenuItem("Properties");
	transPref.setActionCommand("transPreferences");
	transPref.addActionListener(this);
	popup.add(transPref);

	defineActions = new MenuItem("Define Actions");
	defineActions.setActionCommand("defineActions2");
	defineActions.addActionListener(this);
	popup.add(defineActions);
	
	popup.addSeparator();
	

	reverseTrans = new MenuItem("Reverse");
	reverseTrans.setActionCommand("reverseTrans");
	reverseTrans.addActionListener(this);
	popup.add(reverseTrans);

	
	changeInit = new MenuItem("Change Initiator");
	changeInit.setActionCommand("changeInit");
	changeInit.addActionListener(this);
	popup.add(changeInit);

	changeResp = new MenuItem("Change Responder");
	changeResp.setActionCommand("changeResp");
	changeResp.addActionListener(this);
	popup.add(changeResp);
	
	popup.addSeparator();
	
	String temp = (selectedTransition.getStart()) ? "Start Trans : Off" : "Start Trans : On";
	changeResp = new MenuItem(temp);
	changeResp.setActionCommand("startTrans");
	changeResp.addActionListener(this);
	popup.add(changeResp);
	
	temp = (selectedTransition.getEnd()) ? "End Trans : Off" : "End Trans : On";
	changeResp = new MenuItem(temp);
	changeResp.setActionCommand("endTrans");
	changeResp.addActionListener(this);
	popup.add(changeResp);
	
	popup.addSeparator();

	deleteError = new MenuItem("DeleteError");
	deleteError.setActionCommand("deleteError");
	deleteError.addActionListener(this);
	popup.add(deleteError);

	
	deleteTrans = new MenuItem("Delete");
	deleteTrans.setActionCommand("deleteTrans");
	deleteTrans.addActionListener(this);
	popup.add(deleteTrans);
	
}
/**
 * This method was created in VisualAge.
 */
public void startTransAdd(system.ATtransition t) {
	//start transition add
	//set linestatus to wait for the first state
	linestatus = WAIT_FIRST_POINT;
	//set new transition to t
	newtran = t;
	//tell user to select current state
	sysMsg("  select CURRENT State");
}
/**
 * Insert the method's description here.
 * Creation date: (11/2/00 2:39:28 PM)
 */
public void stopTransAdd() {
	if(linestatus != NORMAL) {
		linestatus = NORMAL;
		sysMsg(" <cancel operation>");
	}
}
	//- - - - - - - - - - - - - - -
	// Draw objects on panel
	//- - - - - - - - - - - - - - -
	public void update() {
		/*
		g = this.getGraphics();
		Dimension d = getSize();
		//offGraphics and offImage are used to eliminate flashing
		if ((offGraphics == null)
		 || (d.width != offDimension.width)
		 || (d.height != offDimension.height)) {
			    offDimension = d;
			    offImage = createImage(d.width, d.height);
			    if(offImage == null) System.out.println("null Image");
			    offGraphics = offImage.getGraphics();
		}
		offGraphics.setColor(Color.white);
		offGraphics.fillRect(0, 0, d.width, d.height);
		offGraphics.setColor(Color.black);

		//if item that this panel represents is a conversation,
		//draw the conversation's components
		if(conv != null){
			conv.draw(offGraphics,InitOrResp);
		}
		//if item that this panel represents is a component,
		//draw the component's components
		if(comp != null){
			comp.drawDiag(offGraphics);
		}

		if(task != null){
			task.drawDiag(offGraphics);
		}
		g.drawImage(offImage,0,0,null);
		*/
}
}
