package Editor;

import javax.swing.*;
/**
 * This type was created in VisualAge.
 * Panel used to display deployment of agents
  *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
import system.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
public class DeploymentPanel extends ATpanel
{
	//MenuItems for popup menus
	private MenuItem agentName;
	private MenuItem sysName;
	private MenuItem delete;
	private MenuItem description;
	
	//currently selected objects
	ATagent2 selectedAgent = null;
	ATconversation2 selectedConv = null;
	ATsys selectedSys = null;

	//used for adding agents and systems
	int AddingAgent = 3;
	int AddingSystem = 4;

	//first agent to be connected to another agent
	ATagent2 first;

	//system to be added
	ATsys newSystem = null;

	//where the mouse was put down
	int hold_x,hold_y;

/**
 * This method was created in VisualAge.
 */
public DeploymentPanel(double v)
{
	super(v);
	this.enableEvents(AWTEvent.MOUSE_EVENT_MASK);
	this.enableEvents(AWTEvent.MOUSE_MOTION_EVENT_MASK);
	popup = new PopupMenu();
	this.add(popup);
}
/**
 * This method was created in VisualAge.
 */
  public void actionPerformed(java.awt.event.ActionEvent event) {
	String command = event.getActionCommand();
	ObjectProperties oP;
	
	
	//all these commands come from the popup menu.
	//they are pretty self-explanitory
	if(command.equals("name")){
		if(selected.equals("agent")){
			ObjName objN = new ObjName(selectedAgent);
			objN.show();

			java.util.Enumeration convs = sys.returnAgentConns();
			while(convs.hasMoreElements()){
				selectedConv = (system.ATconversation2)convs.nextElement();
				if(selectedConv.getInitiator()==selectedAgent || selectedConv.getResponder()==selectedAgent) {
					//paint(this.getGraphics());
					selectedConv.resize(selectedAgent);
				}	
			}
			
		} else {
			ObjName objN = new ObjName(selectedSys);
			objN.show();
		}
	} else if(command.equals("delete")){
		if(selected.equals("agent")){
			if(selectedAgent.conversationCount() == 0){
				sys.deleteAgentInstance(selectedAgent);
			} else {
				sysMsg("must remove conv first");
			}
		} else if(selected.equals("conv")){
			sys.deleteAgentConn(selectedConv);
		} else {
			sys.deleteSystem(selectedSys);
		}
	} else if(command.equals("description")){
		if(selected.equals("agent")){
			oP = new ObjectProperties(selectedAgent);
			oP.show();
		} else if(selected.equals("system")){
			oP = new ObjectProperties(selectedSys);
			oP.show();
		}
	}
	repaint();
	//paint(this.getGraphics());
}
/**
 * Insert the method's description here.
 * Creation date: (6/29/00 2:50:31 PM)
 */
public void addConv() {
	ATconversation c = null;
	//check to see if two abstract agent classes are connected in 
	//agent Diagram- first's agent and selectedAgent's agent
	if
	(first.getAgent().isConnectedTo(selectedAgent.getAgent(),c)){
		//if so, create new conversation
		ATconversation2 conv = new ATconversation2(first,selectedAgent, version, sys.getNextKey());
		//add to system
		sys.addAgentConn(conv);
		linestatus = NORMAL;
		sysMsg("Conversation Added");
	} else {
		// if they aren't tell user that a connection must exist in
		// agentDiagram
		sysMsg("must have existing conversation to connect agents");
	}
	//set linestatus to normal so other things can be done
	linestatus = NORMAL;
	
}
/**
 * Insert the method's description here.
 * Creation date: (7/13/00 4:02:35 PM)
 * @param system system.ATsys
 */
public void addSystem(ATsys system) {
	//begin to add a new system
	linestatus = AddingSystem;
	newSystem = system;
	}
/**
 * Insert the method's description here.
 * Creation date: (6/29/00 3:39:59 PM)
 */
public void beginAddConv() {
	linestatus = WAIT_FIRST_POINT;
	sysMsg("  Select first agent");
	}
/**
 * Insert the method's description here.
 * Creation date: (2/1/00 9:35:31 AM)
 */
public void clear() {
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public boolean findSelectedObject(int x, int y) {
	//finds the selected object.
	java.util.Enumeration agents = sys.returnAgentInstances();
	java.util.Enumeration conns = sys.returnAgentConns();
	java.util.Enumeration systems = sys.returnSystems();
	//set selected to null
	selected = "";

	//three variables used to search for the selected object
	ATconversation2 conv;
	ATsys system;
	ATagent2 agent;
	
	//checks to see if any of the agents are selected.
	while(agents.hasMoreElements()){
		agent = (system.ATagent2)agents.nextElement();
		agent.checkSelected(x,y);
		if(agent.Selected) {
			selected = "agent";
			selectedAgent = agent;
		}
	}
	//if one's selected, return true
	if(selected == "agent"){
		return true;
	}

	//checks to see if any of the connections are selected
	while(conns.hasMoreElements()){
		conv = (ATconversation2)conns.nextElement();
		conv.checkSelected(x,y);
		if(conv.Selected){
			selected = "conv";
			selectedConv = conv;
		}
	}
	//if one is selected, returns true
	if(selected == "conv"){
		return true;
	}

	//checks to see if any of the systems are selected
	while(systems.hasMoreElements()){
		system = (ATsys)systems.nextElement();
		system.checkSelected(x,y);
		if(system.Selected){
			selected = "system";
			selectedSys = system;
		}
	}
	//if so, returns true
	if(selected == "system"){
		return true;
	}
	//if we've made it this far, nothing has been selected, so we
	//return false
	return false;
}
/**
 * Insert the method's description here.
 * Creation date: (2/2/01 4:17:11 PM)
 * @return java.awt.Image
 */
public Image formPrintImage() {
		java.util.Enumeration agents = sys.returnAgentInstances();
		java.util.Enumeration systems = sys.returnSystems();
		java.util.Enumeration convs = sys.returnAgentConns();
	
		Image i = createImage(c[3]+5, c[4]+5);//creates an image with the panel's width and height
		Graphics agentGraphics = i.getGraphics();	

		agentGraphics.setColor(Color.white);
		agentGraphics.fillRect(0,0,c[3]+5, c[4]+5);
		agentGraphics.setColor(Color.black);
		agentGraphics.drawString("Deployment Diagram", 10, 10);
		
		while(agents.hasMoreElements()) {
			ATagent2 agent = (ATagent2) agents.nextElement();			
			agent.draw(agentGraphics);
	 	}
		while(convs.hasMoreElements()) {
			ATconversation2 conv = (ATconversation2) convs.nextElement();
			conv.draw(agentGraphics);
		}
		while(systems.hasMoreElements()) {
			ATsys sys = (ATsys) systems.nextElement();
			sys.draw(agentGraphics);
		}
		return i;
}
/**
 * Insert the method's description here.
 * Creation date: (1/26/01 2:52:20 PM)
 * @return int[]
 */
public int[] getPages() {
																	//c[0]-total pages in x-direction
																	//c[1]-total pages in y-direction
																	//c[2]-total number of pages
	int a=0, b=0;
	java.util.Enumeration agents = sys.returnAgentInstances();
	java.util.Enumeration systems = sys.returnSystems();
	//pages across equals greatest x coordinate of any of the ATObject/PAGEWIDTH    visibile area of a standard 8.5"
	//pages down equals greatest y coordinate of any of the ATObject/PAGEHEIGHT     by 11" paper respectively w/ this method
	//																	  	     printed in landscape mode
	while(agents.hasMoreElements()) {
		ATagent2 agent = (ATagent2) agents.nextElement();
		if(agent.getGrfx().x2() > a) {
			a = agent.getGrfx().x2();
		}
		if(agent.getGrfx().y2() > b) {
			b = agent.getGrfx().y2();
		}
	}
	while(systems.hasMoreElements()) {
		ATsys sys = (ATsys) systems.nextElement();
		if(sys.getGrfx().x2() > a) {
			a = sys.getGrfx().x2();
		}
		if(sys.getGrfx().y2() > b) {
			b = sys.getGrfx().y2();
		}
		
	}
	
	c[0] = a/PAGEWIDTH + 1;
	c[1] = b/PAGEHEIGHT + 1;
	c[2] = c[0] * c[1];
	c[3] = a+10;
	c[4] = b+10;
	
	return c;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public ATobject getSelectedObject()
{	//returns the currently selected object
		
	if(selected == "agent"){
		return selectedAgent;
	} else if(selected == "conv"){
		return selectedConv;
	} else if(selected == "sys"){
		return selectedSys;
	} else {
		return null;
	}
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getSelectedObjectName() {
	//returns selected object's name
	if(selected == "agent"){
		return selectedAgent.getName();
	} else if(selected == "conv"){
		return selectedConv.getName();
	} else if(selected == "sys"){
		return selectedSys.getName();
	} else {
		return null;
	}}
public void initPanel(system.ATobject object) {
	if (object instanceof system.ATsystem) {
		sys = (system.ATsystem)object;
	}		
}
	//- - - - - - - - - - - - - - - - - - - - - - - - 
	// Start to move a box, draw a line or arrow
	//- - - - - - - - - - - - - - - - - - - - - - - -
	public synchronized boolean mouseDown(int x, int y, system.ATsystem sys) {
		int j = 0;
		this.sys = sys;
		x_pos = x;
		y_pos = y;
		//lists of agents and conversations
		java.util.Enumeration agents = sys.returnAgentInstances();
		java.util.Enumeration convs  = sys.returnAgentConns();
		java.util.Enumeration systems = sys.returnSystems();
		
		ATconversation2 conv;
		boolean agentSel;
		selected = "";
		system.ATagent2 agent = new system.ATagent2(version,0,0);
		system.ATsys currentSys;

		
	
		//if the a conversation isn't being added	
		if(linestatus == NORMAL){

			selected = "";
			boolean newAgent = false;
			boolean newConv = false;

			//check conversations to see if they are selected
			while(convs.hasMoreElements()){
				conv = (system.ATconversation2)convs.nextElement();
				conv.checkSelected(x,y);
				if(conv.Selected) {
					//if a conversation is selected
					newConv = true;
					selected = "line";
					selectedConv = conv;
				}
			}

			// check for selected agents
			while(agents.hasMoreElements()) {
				agent = (system.ATagent2)agents.nextElement();
				if(!newConv && agent.checkSelected(x,y)) {
					if(shift) agent.Selected = !agent.Selected;
					else agent.Selected = true;
					
					newAgent = true;
					selected = "agent";
					selectedAgent = agent;
				} else {
					if(!shift) agent.Selected = false;
				}
			}

			// if we have not selected an agent, we check the background to see
			// if a system has been selected, otherwise we set all systems to selected
			// state false.  If a system is fully contained by another system,
			// then the smaller one is selected.  It is viewed as being "on top"
			// of the larger one.
			while(systems.hasMoreElements()) {
				currentSys = (system.ATsys)systems.nextElement();
				if(!newAgent && !newConv && currentSys.checkSelected(x,y)){
					if(shift) currentSys.Selected = !currentSys.Selected;
					else currentSys.Selected = true;
					
					selectedSys = currentSys;
					selected = "sys";

					// nested pass to check for contained systems.
					if(selectedSys.Selected) {
						java.util.Enumeration systems2 = sys.returnSystems();
						while(systems2.hasMoreElements()) {
							currentSys = (system.ATsys)systems2.nextElement();
							if(currentSys.Selected) {
								if(currentSys.checkContained(selectedSys)) {
									selectedSys.Selected = false;
								} else if(selectedSys.checkContained(currentSys)) {
									currentSys.Selected = false;
								}
							} 
						}
					}
				} else {
					if(!shift) currentSys.Selected = false;
				}
			}

			
			// second pass to collect agents contained within selected systems.
			systems = sys.returnSystems();
			while(systems.hasMoreElements()) {
				currentSys = (system.ATsys)systems.nextElement();
				if(currentSys.Selected) {
					agents = sys.returnAgentInstances();
					while(agents.hasMoreElements()) {
						agent = (system.ATagent2)agents.nextElement();
						if(agent.checkContained(currentSys)) {
							agent.Selected = true;
						} else {
							agent.Selected = false;
						}
					}
				}
			}

			// third pass to collect systems contained within selected systems (those
			// not directly selected by arrow)
			systems = sys.returnSystems();
			while(systems.hasMoreElements()) {
				system.ATsys currentSys2 = (system.ATsys)systems.nextElement();
				if(currentSys2.Selected) {
					java.util.Enumeration systems2 = sys.returnSystems();
					while(systems2.hasMoreElements()) {
						currentSys = (system.ATsys)systems2.nextElement();
						if(currentSys.checkContained(currentSys2)) {
							currentSys.Selected = true;	
						}
					}
				}
			}
			
		}

		
		//a conversation is going to be added
		if(linestatus == WAIT_FIRST_POINT){
			//set selected to null
			selected = "";
			first = null;
			//loop through agents to find uppermost selected agent
			while(agents.hasMoreElements()){
				agent = (system.ATagent2)agents.nextElement();
				if(agent.checkSelected(x,y) == true) {
					first = agent;
					linestatus = WAIT_SECOND_POINT;
					sysMsg("  Select second agent");
					return true;
				}
			}
		}

		
		//the second agent is going to be added to the component
		else if(linestatus == WAIT_SECOND_POINT){
			agents = sys.returnAgentInstances();
			while(agents.hasMoreElements()){
				agent = (system.ATagent2)agents.nextElement();
				//check to see if agent is selected
				if(agent.checkSelected(x,y) == true) {
					selectedAgent = agent;
					linestatus = NORMAL;
					addConv();
				}
			}
		}
		
		
		else if(linestatus == AddingSystem){
			agents = sys.returnAgentInstances();
			while(agents.hasMoreElements()){
				agent = (ATagent2)agents.nextElement();
				agent.Selected = false;
			}
			newSystem.setCoordinates(x,y,2,2);
			sys.addSystem(newSystem);
			hold_x = x;
			hold_y = y;
		}
		return true;
	}
	//- - - - - - - - - - - -
	// Moving rectangle and attached lines
	//- - - - - - - - - - - -
public synchronized boolean mouseDrag(int x, int y, system.ATsystem sys) {
	if((x>0)&&(y>0)){
		if(linestatus == AddingSystem){
			newSystem.setCoordinates(hold_x,hold_y,x-hold_x,y-hold_y);
		}
		java.util.Enumeration agents = null;
		java.util.Enumeration convs  = null;
		java.util.Enumeration systems = null;
		//get list of agents, systems, and conversations
			agents = sys.returnAgentInstances();
			systems = sys.returnSystems();
			convs = sys.returnAgentConns();

			ATsys selSys = null;
			ATagent2 selAgent = null;
			ATconversation2 selConv = null;
	
		//reset x_pos and y_pos
		int dx = x - x_pos;
		int dy = y - y_pos;
		
		x_pos = x;
		y_pos = y;
		//variable agent

		//go throught systems
		while(systems.hasMoreElements()){
			selSys = (ATsys)systems.nextElement();
			//if the system is selected, move it
			if(selSys.Selected == true){
				selSys.move(dx,dy,Square.DELTA_MODE);
			//if the corner is selected, move that
			} else if(selSys.cornerSelected == true){
				selSys.moveCorner(x,y);
			} else if(selSys.edgeSelected == true){
				selSys.moveEdge(x,y);
			}
		}
		//find which agent is selected
		while(agents.hasMoreElements()){
			selAgent = (system.ATagent2)agents.nextElement();
			if(selAgent.Selected == true){
				selAgent.move(dx,dy,Square.DELTA_MODE);
				//if an agent is selected, move it.
			}
		}
		
		//add a point if it is selected and one hasn't already been added this go-around
		while(convs.hasMoreElements()){
			selConv = (ATconversation2)convs.nextElement();
			if(selConv.Selected) {
				if(newPt == 0){
					selConv.addPoint(x,y);
					newPt = 1;
				}
				//if a points already been added this time, move that point
				selConv.movePoint(x,y);
			}
		}
		
	}
	return true;
}
	public synchronized boolean mouseUp(int x, int y, system.ATsystem sys) {
		newPt = 0;
		//arrange points of selected transition
		if(selectedConv!=null){
			if(selectedConv.Selected){
				selectedConv.arrange_pts();
			}
		}

		//if we just added a system, reset the coordinates and find the
		//agents in the system
		if(linestatus == AddingSystem){
			newSystem.setCoordinates(hold_x,hold_y,x-hold_x,y-hold_y);
			linestatus = NORMAL;
			newSystem.findAgents(sys.returnAgentInstances());
		}

		//if we just moved a system, find the Agents in the system
		if(selectedSys!=null){
			if(selectedSys.Selected || selectedSys.cornerSelected){
				selectedSys.findAgents(sys.returnAgentInstances());
			}
		}
		return true;
	}
/**
 * Insert the method's description here.
 * Creation date: (1/8/01 11:37:13 AM)
 * @param g java.awt.Graphics
 */
public void paint(Graphics g) {
	Dimension d = getSize();
	g.setColor(Color.white);
	g.fillRect(0, 0, d.width, d.height);
	g.setColor(Color.black);

	if(sys != null) {
		//get lists of agents and conversations		
		java.util.Enumeration agents = sys.returnAgentInstances();
		java.util.Enumeration convs  = sys.returnAgentConns();
		java.util.Enumeration systems = sys.returnSystems();

		//variables used
		ATsys system;
		ATagent2 agent;
		ATconversation2 conv;

		//draw the systems first so agents and conversations go on top
		while(systems.hasMoreElements()){
			system = (ATsys)systems.nextElement();
			system.draw(g);
		}	
		//draw the agents
		while (agents.hasMoreElements()) {
			agent = (system.ATagent2)agents.nextElement();
			agent.draw(g);
		}
		//draw the conversations
		while (convs.hasMoreElements()) {
			conv = (system.ATconversation2)convs.nextElement();
			conv.draw(g);
		}
	}
}
/**
 * Insert the method's description here.
 * Creation date: (2/10/00 10:05:01 AM)
 */
public void printPage(Graphics g, int pageIndex, Image i) {
	try {
		int xpage = pageIndex % c[0];
		int ypage = (pageIndex/c[0]) % c[1];
		
		if(fullsize) {
			g.drawImage(i, 72, 72, 540, 720,//<--destination rectangle
				    xpage*PAGEWIDTH, ypage*PAGEHEIGHT, xpage*PAGEWIDTH+PAGEWIDTH, ypage*PAGEHEIGHT+PAGEHEIGHT, null);
		}
		else {
			g.drawImage(i, 72, 72, 540, 72 + (c[4] * 468 / c[3]),//<--destination rectangle
					        0,  0, c[3], c[4], null);
//			g.drawImage(i, 72, 72, 540, 720,//<--destination rectangle
//	        0,  0, c[0]*PAGEWIDTH, c[1]*PAGEHEIGHT,  null);
		}
	 }   
	 catch (Exception e) {
		System.out.println(e);
	 }
}
/**
 * This method was created in VisualAge.
 * @param e MouseEvent
 */
public synchronized void processMouseEvent(java.awt.event.MouseEvent e) {
	//if right mouse button is pushed
	if(e.isPopupTrigger()) {
		//get x,y position
		x_pos = e.getX();
		y_pos = e.getY();
		//find selected object at that point
		if(findSelectedObject(x_pos,y_pos)){
			if(selected != null) {
				popup.removeAll();
				
				//add correct menu items for component or connection
				if(selected.equals("agent")){
					setAgentPopup();
				} else  if (selected.equals("conv")){
					setConvPopup();
				} else if (selected.equals("system")){
					setSysPopup();
				}
			
			//show the popup menu
				popup.show(this, e.getX(), e.getY());
	
			// !!! If you don't add something to popup after doing a removeAll(),
			//  and then call show(), it will lock up the popup and you won't be
			//  able to use it again.  To fix this, I added the if(selected != null)
			//  ensure that we will always have an active popup.  -JAG 1-5-01
			}
		}
	}
	//if not popup, pass on event
	else {
		super.processMouseEvent(e);
	}
}
/**
 * This method was created in VisualAge.
 */
public void setAgentPopup() {
	//the popup for an agent contains a name, description, 
	//and delete option
	agentName = new MenuItem("Name");
	agentName.setActionCommand("name");
	agentName.addActionListener(this);
	popup.add(agentName);

	description = new MenuItem("Description");
	description.setActionCommand("description");
	description.addActionListener(this);
	popup.add(description);

	popup.addSeparator();
	
	delete = new MenuItem("Delete");
	delete.setActionCommand("delete");
	delete.addActionListener(this);
	popup.add(delete);
}
/**
 * This method was created in VisualAge.
 */
public void setConvPopup() {
	//the conversation popup only has a delete option
	delete = new MenuItem("Delete");
	delete.setActionCommand("delete");
	delete.addActionListener(this);
	popup.add(delete);
}
public void setSys(ATsystem sys) {
	this.sys = sys;
	repaint();
	//paint(this.getGraphics());
}
/**
 * This method was created in VisualAge.
 */
public void setSysPopup() {
	//the system popup contains a name, description,
	//and delete option
	agentName = new MenuItem("Name");
	agentName.setActionCommand("name");
	agentName.addActionListener(this);
	popup.add(agentName);

	description = new MenuItem("Description");
	description.setActionCommand("description");
	description.addActionListener(this);
	popup.add(description);

	popup.addSeparator();
	
	delete = new MenuItem("Delete");
	delete.setActionCommand("delete");
	delete.addActionListener(this);
	popup.add(delete);

	
}
//- - - - - - - - - - - - - - -
// Draw objects on panel
//- - - - - - - - - - - - - - -
public void update() {
	
	/*try {
		//get graphics position for this panel
		g = this.getGraphics();
		Dimension d = getSize();
		//having the offGraphics and offImage is what gets rid of
		//the flashing
		if ((offGraphics == null)
		 || (d.width != offDimension.width)
		 || (d.height != offDimension.height)) {
			    offDimension = d;
			    offImage = createImage(d.width, d.height);
			    offGraphics = offImage.getGraphics();
		}
		offGraphics.setColor(Color.white);
		offGraphics.fillRect(0, 0, d.width, d.height);
		offGraphics.setColor(Color.black);

		//get lists of agents and conversations		
		java.util.Enumeration agents = sys.returnAgentInstances();
		java.util.Enumeration convs  = sys.returnAgentConns();
		java.util.Enumeration systems = sys.returnSystems();

		//variables used
		ATsys system;
		ATagent2 agent;
		ATconversation2 conv;

		//draw the systems first so agents and conversations go on top
		while(systems.hasMoreElements()){
			system = (ATsys)systems.nextElement();
			system.draw(offGraphics);
		}	
		//draw the agents
		while (agents.hasMoreElements()) {
			agent = (system.ATagent2)agents.nextElement();
			agent.draw(offGraphics);
		}
		//draw the conversations
		while (convs.hasMoreElements()) {
			conv = (system.ATconversation2)convs.nextElement();
			conv.draw(offGraphics);
		}
		//place the image on the panel
		g.drawImage(offImage,0,0,null);
	
	} catch (java.lang.NullPointerException e) {
	}
	*/
}
}
