package Editor;

import javax.swing.*;
/**
 * This type was created in VisualAge.
 * displays drawing of goals.
 * @author: Jennifer Mifflin
  *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
import system.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
public class GoalPanel extends ATpanel
{
	//MenuItems for popup menus
	private MenuItem goalName;
	private MenuItem delete;
	private MenuItem reparent;
	private MenuItem addSP;
	private MenuItem remSP;
	private MenuItem Partition;
	private MenuItem snap;
	private MenuItem arrange;
	private MenuItem undome;
	private MenuItem decGoal;
	private MenuItem incGoal;
	private boolean dragging = false;
	private boolean snapped = true;
	private boolean undo = false;
	private int parent = 0;

	private String undoMAML = "";
	
	ATGoal selectedGoal = null;
	ATGoal selectedGoal2 = null;
	
	int AddingGoal = 3;

	ATGoal goal;
	int GoalNum;
	public static final String GOAL = "Goal";

/**
 * This method was created in VisualAge.
 */
public GoalPanel(double v)
{
	super(v);
	
	this.enableEvents(AWTEvent.MOUSE_EVENT_MASK);
	this.enableEvents(AWTEvent.MOUSE_MOTION_EVENT_MASK);

	popup = new PopupMenu();
	this.add(popup);
}
/**
 * This method was created in VisualAge.
 */
  public void actionPerformed(java.awt.event.ActionEvent event) {
	String command = event.getActionCommand();
	ObjectProperties gProp;
	
	//all these commands come from the popup menu.
	//they are pretty self-explanitory
	if(command.equals("arrange")) {
		
		undo = true;
		undoMAML = "";
		java.util.Enumeration goals = sys.returnGoals();
		ATGoal tempgoal;
		while(goals.hasMoreElements()){
			tempgoal = (ATGoal)goals.nextElement();
			undoMAML += tempgoal.getMAML();
		}
		
		arrangeGoals();
		parent = 0;
		
	}
	else if(command.equals("snap")) {
		parent = 0;
		snapped = !snapped;
	}
	else if(command.equals("undoarrange")) {
		String[] tokens = ATtokenOps.parseLine(undoMAML);
		int loc = 0;
		for(int i=loc;i<tokens.length;++i){
			if(tokens[i].equals("goal") && tokens[i-1].equals("<")){
				loc=ATtokenOps.findnextinstanceof("/goal",tokens, i);
				
				String[] subtokens = ATtokenOps.subTokens(tokens,(i-1),(loc+1));
				int loc2 = ATtokenOps.findnextinstanceof("num",subtokens, 0);
				
				java.util.Enumeration goals = sys.returnGoals();
				ATGoal tempgoal;
				while(goals.hasMoreElements()){
					tempgoal = (ATGoal)goals.nextElement();
					if(tempgoal.getNum().equals(subtokens[loc2+3])){
						tempgoal.reconstruct(subtokens,sys);
						break;
					}
				}
				i = loc;
			}
		}
		
		setPreferredSize(new Dimension(psx,psy));
		setSize(new Dimension(psx,psy));
	
		parent = 0;
		undo = false;
		undoMAML = "";
  	}
	else if(command.equals("goalName"))
	{
		gProp = new ObjectProperties(selectedGoal);
		gProp.show();
		parent = 0;
		
	}
	else if(command.equals("delete"))
	{
		if(selectedGoal.subGoals()!=0) {
			sysMsg("  You must remove subgoals before this goal can be deleted");
		} else {
			if(selectedGoal.hasRole()) {
				sysMsg("  This goal is assigned to a role.  It cannot be deleted until its role assignment is removed.");
			} else {
				if(selectedGoal.isSP(sys)) {
					sysMsg("  This goal is a secondary parent.  It cannot be deleted until that link is removed.");
				} else {
					
					selectedGoal.leaveParent();
					sys.deleteGoal(selectedGoal);
					if(selectedGoal.getNum().equals("1"))
					{
						GoalNum = 0;
					}
					parent = 0;
					undo = false;
				}
			}
		}
	}
	else if(command.equals("partition"))
	{
		if(!selectedGoal.getPartition() && selectedGoal.hasRole()) {
			sysMsg("  Selected goal is already assigned to a Role.  You must unassign it before you can partition the goal.");
		} else {
			boolean prt = selectedGoal.getPartition();
			selectedGoal.setPartition(!prt);
		}
		
		parent = 0;
		
	}

	else if(command.equals("reparent"))	{
		sysMsg("  Select a goal to set as the new parent of this goal");
		selectedGoal2 = selectedGoal;
		
		parent = 1;
		undo = false;
	}
	else if(command.equals("addSP"))	{
		sysMsg("  Select a goal to add as a secondary parent of this goal");
		selectedGoal2 = selectedGoal;
		
		parent = 2;
		undo = false;
	}
	else if(command.equals("remSP"))	{
		sysMsg("  Select the secondary parent you want to remove");
		selectedGoal2 = selectedGoal;
		
		parent = 3;
		undo = false;
	}
	
	else if(command.equals("decGoal"))	{
		// decrement Goal number
		selectedGoal.decGoal();
		selectedGoal.getGoal().setNum(selectedGoal.getGoal().getNum());
	}
	else if(command.equals("incGoal"))	{
		// increment Goal number
		selectedGoal.incGoal();
		selectedGoal.getGoal().setNum(selectedGoal.getGoal().getNum());
	}
	
/*	for(int i=0; i>=GoalNum; i++) {
		if(goal != null ) {
			goal.getGrfx().drawObject(this.getGraphics());
		}
		goal = (system.ATGoal)sys.returnGoals().nextElement();
	}
*/
	cancelAddGoal();
	repaint();
	//paint(this.getGraphics());
  }    
/**
 * Insert the method's description here.
 * Creation date: (5/2/00 1:28:25 PM)
 * @param t system.ATTask
 */
public void addGoal(ATGoal goal, ATsystem sys){
	//if a goal has not yet been added, then this is 
	//the first goal
	if(sys.getGoalNum() ==0){
		sys.addGoal(goal);
		GoalNum++;
		goal.setDescription("Main Goal");
		goal.setNum("1");
	} else {
	//otherwise, a parent goal needs to be specified
		sysMsg("Select Goal to place goal under");
		linestatus = AddingGoal;
		GoalNum = GoalNum++;
		this.goal = goal;
	}
}
/**
 * Insert the method's description here.
 * Creation date: (11/16/00 2:53:01 PM)
 */
public void arrangeGoals() {
	java.util.Enumeration goals = sys.returnGoals();
	int max_height = 0;
	int max_width = 0;
	
	sysMsg("  Auto-Arrange...updating goal versions...");
	
	while(goals.hasMoreElements()){
		goal = (ATGoal)goals.nextElement();
		if(goal.getVersion() < ATeditor.version)
			goal.setVersion(ATeditor.version);
		(goal.getGrfx()).autosize(this.getGraphics());
		//int height = goal.getGrfx().h();
		//if(height > max_height) max_height = height;
	}

	ATGoal root = goal.root();
	root.setVPos(50);
	Vector temp = new Vector();
	java.util.Enumeration pass1 = root.getChildren();
	while(pass1.hasMoreElements()) {
		temp.add(pass1.nextElement());
	}
	max_height = snapHeights(temp,root.getGrfx().y2() + 50);
	
	if(root != null) {
		max_width = root.snap(10).x;
	} else {
		sysMsg("Cannot find root!!  Unable to auto-arrange.");
	}

	autoSize(new Dimension(max_width+100,max_height+100));
	repaint();
	//paint(this.getGraphics());
}
/**
 * Insert the method's description here.
 * Creation date: (11/2/00 2:10:53 PM)
 */
public void cancelAddGoal() {
	if(linestatus != NORMAL) {
		linestatus = NORMAL;
		sysMsg(" <cancel operation>");
	}
}
/**
 * Insert the method's description here.
 * Creation date: (2/1/00 9:35:31 AM)
 */
public void clear() {
}
/**
 * Insert the method's description here.
 * Creation date: (2/1/00 9:35:31 AM)
 */
public void clear(ATsystem sys) {
	sys.removeAllGoals();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public boolean findSelectedObject(int x, int y) {
	//finds the selected goal.
	java.util.Enumeration goals = sys.returnGoals();
	
	selected = null;
	system.ATGoal goal;
	
	//checks to see if any of the Goals are selected.
	while(goals.hasMoreElements()){
		goal = (system.ATGoal)goals.nextElement();
		goal.checkSelected(x,y);
		if(goal.Selected) {
			selected = GOAL;
			selectedGoal = goal;
		}
	}
	if(selected == GOAL){
		return true;
	}

	return false;
}
/**
 * Insert the method's description here.
 * Creation date: (2/2/01 3:30:33 PM)
 * @return java.awt.Image
 */
public Image formPrintImage() {
	java.util.Enumeration goals = sys.returnGoals();
	Image i = createImage(c[3]+5, c[4]+5);//creates an image with the panel's width and height
	Graphics g = i.getGraphics();

	g.setColor(Color.white);
	g.fillRect(0,0,c[3]+5, c[4]+5);
	g.setColor(Color.black);
	g.drawString("Goal Diagram", 10, 10);
	//draws all the goals/connectors onto the graphics object goalGraphics
	while(goals.hasMoreElements()) {
		system.ATGoal goal = (ATGoal) goals.nextElement();
		goal.draw(g);
	}
	return i;
}
/**
 * Insert the method's description here.
 * Creation date: (1/11/01 9:48:32 AM)
 * @return int
 */
public int[] getPages() {
																	//c[0]-total pages in x-direction
																	//c[1]-total pages in y-direction
																	//c[2]-total number of pages
	int maxwidth=0, maxheight=0;
	java.util.Enumeration goals = sys.returnGoals();
	
	//pages across equals greatest x coordinate of any of the goals/WIDTH   visibile area of a standard 8.5"
	//pages down equals greatest y coordinate of any of the goals/HEIGHT     by 11" paper respectively 
	while(goals.hasMoreElements()) {
		//this while loop will get the extreme boundaries of the panel
		ATGoal goal = (ATGoal) goals.nextElement();
		if(goal.getGrfx().x2() > maxwidth) {
			maxwidth = goal.getGrfx().x2();
		}
		if(goal.getGrfx().y2() > maxheight) {
			maxheight = goal.getGrfx().y2();
		}
	}

	c[0] = maxwidth/PAGEWIDTH + 1;
	c[1] = maxheight/PAGEHEIGHT + 1;
	c[2] = c[0] * c[1];
	c[3] = maxwidth + 10;
	c[4] = maxheight + 10;
	
	return c;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public ATobject getSelectedObject()
{	//returns the currently selected object
	if(selected == GOAL){
		return selectedGoal;
	} else {
		return null;
	}
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getSelectedObjectName() {
	//returns selected object's name
	if(selected == GOAL){
		return selectedGoal.getNum();
	} else {
		return null;
	}
}
public void initPanel(system.ATobject object) {
	if (object instanceof system.ATsystem) {
		sys = null;
		sys = (system.ATsystem)object;
	}		
}
	//- - - - - - - - - - - - - - - - - - - - - - - - 
	// Start to move a box, draw a line or arrow
	//- - - - - - - - - - - - - - - - - - - - - - - -
	public synchronized boolean mouseDown(int x, int y, system.ATsystem sys) {
		//record the position
		x_pos = x;
		y_pos = y;
		//get the list of goals
		java.util.Enumeration Goals = sys.returnGoals();
		//variable goal
		ATGoal Goal1;
		
		
		if(linestatus == NORMAL){
			selected = NOTHING;
			boolean shiftselect = false;
			while(Goals.hasMoreElements()){
				Goal1 = (ATGoal)Goals.nextElement();
				if(Goal1.checkSelected(x,y) == true){
					selectedGoal = Goal1;
					selected = GOAL;
					shiftselect = selectedGoal.Selected;
				}
				Goal1.Selected = false;
			}
			if(selected == GOAL) {
				selectedGoal.Selected = (shift) ?  !shiftselect : true;
			}

			if(parent == 1) {  // if assigning a new parent to the goal
				if(selectedGoal2.getGoal() == null) {
					sysMsg("  Error!!!  Root goal cannot be a child!");
				} else {
					if(selectedGoal == selectedGoal2) {
						sysMsg("  Warning, cannot assign a goal as its own parent!");
					} else {
						if(selectedGoal != selectedGoal2.getGoal()) {
							// if we are not assigning it back to its own parent...
							
							if(selectedGoal2.isDescendant(selectedGoal)) {
									sysMsg("  Warning, cannot assign a descendent goal as a parent");
							} else {
								if(selectedGoal2.hasSP(selectedGoal)) {
									selectedGoal2.removeSecondaryParent(selectedGoal);
									selectedGoal2.addSecondaryParent(selectedGoal2.getGoal());
								}
								selectedGoal2.setGoal(selectedGoal);
								sys.renumberGoals();
							}
						}
					}
				}
				parent = 0;
			}

			if(parent == 2) {	// add Secondary Parent
				if(selectedGoal2.getGoal() == null) {
					sysMsg("  Error!!!  Root goal cannot be a child!");
				} else {
					if(selectedGoal == selectedGoal2) {
						sysMsg("  Warning, cannot assign a goal as its own parent!");
					} else {
						if(selectedGoal != selectedGoal2.getGoal()) {
							// if we are not assigning it back to its own parent...

							if(!selectedGoal2.hasSP(selectedGoal)) {
								
								if(selectedGoal2.isDescendant(selectedGoal)) {
									sysMsg("  Warning, cannot assign a descendent goal as a parent");
								} else {
									selectedGoal2.addSecondaryParent(selectedGoal);
								}
							} 
							
						}
					}
				}
				parent = 0;
			}
			
			if(parent == 3) {	// remove Secondary Parent
				selectedGoal2.removeSecondaryParent(selectedGoal);
				parent = 0;
			}
		}

				//adding a goal-	
		else if (linestatus == AddingGoal){
			while(Goals.hasMoreElements()){
				//proceed through the goal to find which one is selected
				Goal1 = (system.ATGoal)Goals.nextElement();
				if(Goal1.checkSelected(x,y)){
					//if a goal is selected, make it not highlighted and
					//store it in selectedGoal and set linestatus to NORMAL
					Goal1.Selected = false;
					linestatus = NORMAL;
					selectedGoal = Goal1;
				}
			}
			//a goal has been selected, so we may set the parent goal for "goal"
			if(linestatus == NORMAL){
				sys.addGoal(goal);
				goal.setGoal(selectedGoal);
				//selectedGoal.setNum(selectedGoal.getNum());
				undo = false;
			} else {
				sysMsg("Must select a Goal\n");
			}
		} 	
		return true;

}
public synchronized boolean mouseDrag(int x, int y, system.ATsystem sys) {
	ATGoal Goal;
	if((x>0)&&(y>0)){
		//reset x_pos and y_pos
		x_pos = x;
		y_pos = y;
		
		java.util.Enumeration Goals = sys.returnGoals();
		
		//move those goals which are selected
		while(Goals.hasMoreElements()){
			Goal = (ATGoal)Goals.nextElement();
			if(Goal.Selected){
				Goal.move(x,y,snapped);
			}
		}
	}
	return true;
}
	public synchronized boolean mouseUp(int x, int y, system.ATsystem sys) {
		newPt = 0;
		//arrange points of selected transition
		dragging = false;
		return true;
	}
/**
 * Insert the method's description here.
 * Creation date: (1/8/01 11:13:54 AM)
 * @param g java.awt.Graphics
 */
public void paint(Graphics g) {
	Dimension d = getSize();
	g.setColor(Color.white);
	g.fillRect(0, 0, d.width, d.height);
	g.setColor(Color.black);

	if(sys != null) {
		// get and draw the goals
		java.util.Enumeration goals = sys.returnGoals();
		while (goals.hasMoreElements()) {
			ATGoal goal = (ATGoal)goals.nextElement();
			goal.draw(g);
		}
	}

}
/**
 * Insert the method's description here.
 * Creation date: (2/10/00 10:05:01 AM)
 */
public void printPage(Graphics g, int pageIndex, Image i) {
	try {
		int xpage = pageIndex % c[0];
		int ypage = (pageIndex/c[0]) % c[1];
		if(fullsize) {
			g.drawImage(i, 72, 72, 540, 720,//<--destination rectangle
				    xpage*PAGEWIDTH, ypage*PAGEHEIGHT, xpage*PAGEWIDTH+PAGEWIDTH, ypage*PAGEHEIGHT+PAGEHEIGHT, null);
		}
		else {
			g.drawImage(i, 72, 72, 540, 72 + (c[4] * 468 / c[3]),//<--destination rectangle
					        0,  0, c[3], c[4], null);
		//	g.drawImage(i, 72, 72, 540, 720,//<--destination rectangle
		//			        0,  0, c[0]*PAGEWIDTH, c[1]*PAGEHEIGHT, null);
		}
	}
	catch (Exception e) { System.out.println(e); }
}
/**
 * This method was created in VisualAge.
 * @param e MouseEvent
 */
public synchronized void processMouseEvent(java.awt.event.MouseEvent e) {
	//if right mouse button is pushed
	if(e.isPopupTrigger()) {
		//get x,y position
		x_pos = e.getX();
		y_pos = e.getY();
		//find selected object at that point
		findSelectedObject(x_pos,y_pos);
			popup.removeAll();
			//set popup menu according to what has been selected
			
			setGoalPopup();
			//show popup
			popup.show(this,x_pos, y_pos);
	}
	//if not popup, pass on event
	else {
		super.processMouseEvent(e);
	}
}
/**
 * This method was created in VisualAge.
 */
public void setGoalPopup() {
	popup.removeAll();
	
	if(selected == "Goal"){
		goalName = new MenuItem("Description");
		goalName.setActionCommand("goalName");
		goalName.addActionListener(this);
		popup.add(goalName);

		delete = new MenuItem("Delete");
		delete.setActionCommand("delete");
		delete.addActionListener(this);
		popup.add(delete);

		if(selectedGoal.getPartition()) {
			Partition = new MenuItem("Remove Partitioning");
		} else {
			Partition = new MenuItem("Set Partitioned");
		}
		Partition.setActionCommand("partition");
		Partition.addActionListener(this);
		popup.add(Partition);

		if(selectedGoal.getGoal() != null) {
			popup.addSeparator();
		
			reparent = new MenuItem("Change Parent");
			reparent.setActionCommand("reparent");
			reparent.addActionListener(this);
			popup.add(reparent);
		
			addSP = new MenuItem("Add Secondary Parent");
			addSP.setActionCommand("addSP");
			addSP.addActionListener(this);
			popup.add(addSP);
		
			if(selectedGoal.spCount() > 0) {
				remSP = new MenuItem("Remove Secondary Parent");
				remSP.setActionCommand("remSP");
				remSP.addActionListener(this);
				popup.add(remSP);
			}
		
			popup.addSeparator();
		
			decGoal = new MenuItem("<--");
			decGoal.setActionCommand("decGoal");
			decGoal.addActionListener(this);
			popup.add(decGoal);
		
			incGoal = new MenuItem("-->");
			incGoal.setActionCommand("incGoal");
			incGoal.addActionListener(this);
			popup.add(incGoal);
		
		}
		
	} else {
		snap = new MenuItem((snapped) ? "Deactivate Level Snap":"Activate Level Snap");
		snap.setActionCommand("snap");
		snap.addActionListener(this);
		popup.add(snap);
	
		arrange = new MenuItem("Auto-Arrange");
		arrange.setActionCommand("arrange");
		arrange.addActionListener(this);
		popup.add(arrange);

		if(undo) {
			popup.addSeparator();
			undome = new MenuItem("Undo Auto-Arrange");
			undome.setActionCommand("undoarrange");
			undome.addActionListener(this);
			popup.add(undome);
		}
	}
	
}
/**
 * Insert the method's description here.
 * Creation date: (6/9/00 10:07:41 AM)
 * @param sys system.ATsystem
 */
public void setSys(ATsystem sys) {
	this.sys = sys;

	java.util.Enumeration goals = sys.returnGoals();
	int max_height = 0;
	int max_width = 0;
	
	while(goals.hasMoreElements()){
		goal = (ATGoal)goals.nextElement();
		
		int height = goal.getGrfx().y2();
		int width = goal.getGrfx().x2();
		
		if(height > max_height) max_height = height;
		if(width > max_width) max_width = width;
	}

	autoSize(new Dimension(max_width+50,max_height+50));
	repaint();
	//paint(this.getGraphics());
}
/**
 * Insert the method's description here.
 * Creation date: (2/9/01 3:49:37 PM)
 * @param level java.util.Vector
 * @param height int
 */
public int snapHeights(Vector level, int height) {
	int max_height = height;
	int nextHeight = height;
		
	if(!level.isEmpty()) {
		Vector nextLevel = new Vector();
		for(int i=0; i<level.size(); i++) {
			goal = (ATGoal)level.elementAt(i);
			goal.setVPos(height);
			if(goal.getGrfx().y2() > nextHeight) nextHeight = goal.getGrfx().y2();
			
			java.util.Enumeration pass = goal.getChildren();
			while(pass.hasMoreElements()) {
				nextLevel.add(pass.nextElement());
			}
		}

		max_height = snapHeights(nextLevel, nextHeight + 50);
	}
	
	return max_height;	
}
//- - - - - - - - - - - - - - -
// Draw objects on panel
//- - - - - - - - - - - - - - -
public void update() {
	//dragging = !dragging;


	/*try {
		
		g = this.getGraphics();
		
		Dimension d = getSize();
		//uses offGraphics and offImage to get rid of flashing
		if ((offGraphics == null)
		 || (d.width != offDimension.width)
		 || (d.height != offDimension.height)) {
			    offDimension = d;
			    offImage = createImage(d.width, d.height);
			    offGraphics = offImage.getGraphics();
		}
		offGraphics.setColor(Color.white);
		offGraphics.fillRect(0, 0, d.width, d.height);
		offGraphics.setColor(Color.black);

		//get lists of agents and conversations		
		java.util.Enumeration goals = sys.returnGoals();
		//java.util.Enumeration connections = architecture.returnConnections();
		
		//draw the goals
		while (goals.hasMoreElements()) {
			ATGoal goal = (ATGoal)goals.nextElement();
			goal.draw(offGraphics);
		}
*/		//draw the connections
	/*	while (connections.hasMoreElements()) {
			ATconnection conn = (ATconnection)connections.nextElement();
			conn.draw(offGraphics);
		}*/
		
/*
		g.drawImage(offImage,0,0,null);
		
	} catch (java.lang.NullPointerException e) {
	}
	*/
}
}
