package Editor;

/**
 * Insert the type's description here.
 * Creation date: (6/16/00 8:41:09 AM)
 * Used to Sequence Diagrams to add roles.  User may
 * select a role that already exists or may create a
 * new role
 * @author: Jennifer Mifflin 
  *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
 import java.util.*;
 import system.*;
public class SelectRole extends javax.swing.JDialog {
	
	IvjEventHandler ivjEventHandler = new IvjEventHandler();
	
	private javax.swing.JButton ivjCancelButton = null;
	private javax.swing.JButton ivjCreateButton = null;
	
	private javax.swing.JPanel ivjJFrameContentPane = null;
	
	private javax.swing.JScrollPane ivjJScrollPane1 = null;
	
	private javax.swing.JLabel ivjRoleLabel = null;
	
	private javax.swing.JList ivjRoleList = null;
	
	private javax.swing.JButton ivjSelectButton = null;
	
	private Vector roles;
	
	private SeqDiagPanel seqDiagPanel;
	
	ATsystem sys;

	ATRole2 role2;

	int mode;
	
	double version;


	class IvjEventHandler implements java.awt.event.ActionListener {
		public void actionPerformed(java.awt.event.ActionEvent e) {
			if (e.getSource() == SelectRole.this.getSelectButton()) 
				connEtoC1();
			if (e.getSource() == SelectRole.this.getCreateButton()) 
				connEtoC2();
			if (e.getSource() == SelectRole.this.getCancelButton()) 
				connEtoC3();
		};
	};
/**
 * SelectRole constructor comment.
 */
public SelectRole(SeqDiagPanel seqDiagPanel, ATsystem sys, double v) {
	super((java.awt.Frame)null,true);
	mode = 0;
	this.sys = sys;
	this.roles = sys.returnRolesVector();
	this.seqDiagPanel = seqDiagPanel;
	version = v;
	initialize();
	Enumeration r = roles.elements();
	ATRole role;
	Vector names = new Vector();
	while(r.hasMoreElements()){
		role = (ATRole)r.nextElement();
		names.addElement(role.getName());
	}
		
	getRoleList().setListData(names);
}
/**
 * Insert the method's description here.
 * Creation date: (1/19/01 2:04:46 PM)
 * @param role2 system.ATRole2
 * @param sys system.ATsystem
 */
public SelectRole(ATRole2 role2, ATsystem sys) {
	super((java.awt.Frame)null,true);
	mode = 1;
	this.sys = sys;
	this.roles = sys.returnRolesVector();
	this.role2 = role2;
	
	initialize();
	Enumeration r = roles.elements();
	ATRole role;
	Vector names = new Vector();
	while(r.hasMoreElements()){
		role = (ATRole)r.nextElement();
		names.addElement(role.getName());
	}
		
	getRoleList().setListData(names);	
}
/**
 * Comment
 */
public void cancelButton_ActionEvents() {
	System.out.println("Cancel");
	this.dispose();
	return;
}
/**
 * connEtoC1:  (SelectButton.action. --> SelectRole.selectButton_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC1() {
	try {
		// user code begin {1}
		// user code end
		this.selectButton_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC2:  (CreateButton.action. --> SelectRole.createButton_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC2() {
	try {
		// user code begin {1}
		// user code end
		this.createButton_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC3:  (CancelButton.action. --> SelectRole.cancelButton_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC3() {
	try {
		// user code begin {1}
		// user code end
		this.cancelButton_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * Comment
 */
public void createButton_ActionEvents() {
	if(mode == 0) {
		ATRole role = new ATRole(version, sys.getNextKey());
		int rolenum = sys.getRoleCount() + 1;
		role.setName("Role" + rolenum);
		role.setCoordinates(50 + ((rolenum-1) % 10)* 75,50 + ((rolenum-1) / 10)* 75,50,50);
		sys.addRole(role);
		rolenum = seqDiagPanel.getRole2Count() + 1;
		ATRole2 role2 = new ATRole2(version, sys.getNextKey(), rolenum);
		role2.setRole(role);
		role2.setCoordinates(50 + ((rolenum-1) % 20)* 75 + ((rolenum-1) / 20)* 10,50,50,50);
		seqDiagPanel.addRole(role2);
		this.dispose();
	}
}
/**
 * Return the CancelButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getCancelButton() {
	if (ivjCancelButton == null) {
		try {
			ivjCancelButton = new javax.swing.JButton();
			ivjCancelButton.setName("CancelButton");
			ivjCancelButton.setText("Cancel");
			ivjCancelButton.setBounds(250, 142, 100, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjCancelButton;
}
/**
 * Return the CreateButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getCreateButton() {
	if (ivjCreateButton == null) {
		try {
			ivjCreateButton = new javax.swing.JButton();
			ivjCreateButton.setName("CreateButton");
			ivjCreateButton.setText("Create New");
			ivjCreateButton.setBounds(250, 94, 100, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjCreateButton;
	
}
/**
 * Return the JFrameContentPane property value.
 * @return javax.swing.JPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JPanel getJFrameContentPane() {
	if (ivjJFrameContentPane == null) {
		try {
			ivjJFrameContentPane = new javax.swing.JPanel();
			ivjJFrameContentPane.setName("JFrameContentPane");
			ivjJFrameContentPane.setLayout(null);
			getJFrameContentPane().add(getJScrollPane1(), getJScrollPane1().getName());
			getJFrameContentPane().add(getRoleLabel(), getRoleLabel().getName());
			getJFrameContentPane().add(getSelectButton(), getSelectButton().getName());
			if(mode == 0) getJFrameContentPane().add(getCreateButton(), getCreateButton().getName());
			getJFrameContentPane().add(getCancelButton(), getCancelButton().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJFrameContentPane;
}
/**
 * Return the JScrollPane1 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JScrollPane getJScrollPane1() {
	if (ivjJScrollPane1 == null) {
		try {
			ivjJScrollPane1 = new javax.swing.JScrollPane();
			ivjJScrollPane1.setName("JScrollPane1");
			ivjJScrollPane1.setBounds(22, 39, 186, 181);
			getJScrollPane1().setViewportView(getRoleList());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJScrollPane1;
}
/**
 * Return the RoleLabel property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JLabel getRoleLabel() {
	if (ivjRoleLabel == null) {
		try {
			ivjRoleLabel = new javax.swing.JLabel();
			ivjRoleLabel.setName("RoleLabel");
			ivjRoleLabel.setText("Roles");
			ivjRoleLabel.setBounds(24, 22, 44, 17);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjRoleLabel;
}
/**
 * Return the RoleList property value.
 * @return javax.swing.JList
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JList getRoleList() {
	if (ivjRoleList == null) {
		try {
			ivjRoleList = new javax.swing.JList();
			ivjRoleList.setName("RoleList");
			ivjRoleList.setBounds(0, 0, 181, 132);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjRoleList;
}
/**
 * Return the SelectButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getSelectButton() {
	if (ivjSelectButton == null) {
		try {
			ivjSelectButton = new javax.swing.JButton();
			ivjSelectButton.setName("SelectButton");
			ivjSelectButton.setText("Select");
			ivjSelectButton.setBounds(250, 46, 100, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjSelectButton;
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(java.lang.Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
}
/**
 * Initializes connections
 * @exception java.lang.Exception The exception description.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initConnections() throws java.lang.Exception {
	// user code begin {1}
	// user code end
	getSelectButton().addActionListener(ivjEventHandler);
	if(mode == 0) getCreateButton().addActionListener(ivjEventHandler);
	getCancelButton().addActionListener(ivjEventHandler);
}
/**
 * Initialize the class.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initialize() {
	try {
		// user code begin {1}
		// user code end
		setName("SelectRole");
		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		setSize(390, 275);
		setContentPane(getJFrameContentPane());
		initConnections();
	} catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	}
	// user code begin {2}
	// user code end
}
/**
 * Comment
 */
public void selectButton_ActionEvents() {
	if(mode == 0) {
		int index = getRoleList().getSelectedIndex();
		int rolenum = seqDiagPanel.getRole2Count() + 1;
		if(index > -1){
			ATRole nextRole = (ATRole)roles.elementAt(index);
			role2 = new ATRole2(version, sys.getNextKey(), rolenum);
			role2.setCoordinates(50 + ((rolenum-1) % 20)* 75 + ((rolenum-1) / 20)* 10,50,50,50);
			role2.setRole(nextRole);
			seqDiagPanel.addRole(role2);
			this.dispose();
		}
	} else if (mode == 1) {
		int index = getRoleList().getSelectedIndex();
		if(index > -1){
			ATRole nextRole = (ATRole)roles.elementAt(index);
			role2.setRole(nextRole);
			//role2.refresh();
			this.dispose();
		}
	}
}
}
