package Editor;

import javax.swing.*;
/**
 * Insert the type's description here.
 * Creation date: (6/7/00 5:34:48 PM)
 * displys use cases and their sequence diagrams
 * @author: Jennifer Mifflin
  *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
 import system.*;
 import java.awt.*;
 import java.awt.event.*;
 import java.util.*;
public class UseCasePanel extends ATpanel implements ActionListener, MouseListener, MouseMotionListener {
	
	private javax.swing.JButton ivjAddSDButton = null;
	private javax.swing.JButton ivjDeleteSDButton = null;
	
	private javax.swing.JLabel ivjDescriptionLabel = null;
	private javax.swing.JLabel ivjJLabel1 = null;
	private javax.swing.JLabel ivjSeqDiagLabel = null;
	
	private javax.swing.JTextArea ivjDescriptionText = null;
	
	private javax.swing.JList ivjJList1 = null;
	private javax.swing.JList ivjJList2 = null;
	
	private javax.swing.JScrollPane ivjJScrollPane1 = null;
	private javax.swing.JScrollPane ivjJScrollPane2 = null;
	private javax.swing.JScrollPane ivjJScrollPane3 = null;
	
	private Vector UseCases = new Vector();
	
	private static SingleSelectionModel selectionModel;
	private static SingleSelectionModel selectionModel2;
	
	private SeqDiagPanel seqDiagPanel;
	
	//popup menu
	PopupMenu popup;
	
	private MenuItem NameMenuItem = null;
	private MenuItem Description = null;

	class IvjEventHandler implements java.awt.event.ActionListener {
		public void actionPerformed(java.awt.event.ActionEvent e) {
			if (e.getSource() == UseCasePanel.this.getAddSDButton()) 
				connEtoC1();
			if (e.getSource() == UseCasePanel.this.getDeleteSDButton()) 
				connEtoC2();
		};
	};
	class PopupListener1 extends MouseAdapter {
		public void mousePressed(MouseEvent e) {
		//	maybeShowPopup(e);
		}

		public void mouseReleased(MouseEvent e) {
			maybeShowPopup(e);
		}

		private void maybeShowPopup(MouseEvent e) {
			int index = getJList1().getSelectedIndex();
		
			int x = e.getX();
			int y = e.getY();
			if (e.isPopupTrigger() && index> -1) {
				popup.removeAll();
				setUCpopup();
				popup.show(e.getComponent(), x,y);
			}
		}
	}
	class PopupListener2 extends MouseAdapter {
		public void mousePressed(MouseEvent e){
			maybeShowPopup(e);
		}
		public void mouseReleased(MouseEvent e){
			maybeShowPopup(e);
		}
		private void maybeShowPopup(MouseEvent e){
			int index = getJList2().getSelectedIndex();
		
			int x = e.getX();
			int y = e.getY();
			if(e.isPopupTrigger() && index>-1){
				popup.removeAll();
				setSDpopup();
				popup.show(e.getComponent(),x,y);
			}
		}
	}
	class FocusListener1 extends FocusAdapter{
		public void focusGained(FocusEvent e){
			repaint();			
		}
		public void focusLost(FocusEvent e){
			int index = getJList1().getSelectedIndex();
			Vector list = UseCases;
			ATuseCase current = (ATuseCase)(list.elementAt(index));
			String description = getDescriptionText().getText();
			current.setDescription(description);
		}
	}
	IvjEventHandler ivjEventHandler = new IvjEventHandler();
/**
 * UseCasePanel constructor comment.
 */
public UseCasePanel(SeqDiagPanel seqDP, double v){
	super(v);
	seqDiagPanel = seqDP;
	popup = new PopupMenu();
	this.add(popup);

	initialize();
}
/**
 * UseCasePanel constructor comment.
 * @param layout java.awt.LayoutManager
 */
public UseCasePanel(java.awt.LayoutManager layout, double v) {
	super(layout, v);
}
/**
 * UseCasePanel constructor comment.
 * @param layout java.awt.LayoutManager
 * @param isDoubleBuffered boolean
 */
public UseCasePanel(java.awt.LayoutManager layout, boolean isDoubleBuffered, double v) {
	super(layout, isDoubleBuffered, v);
}
/**
 * UseCasePanel constructor comment.
 * @param isDoubleBuffered boolean
 */
public UseCasePanel(boolean isDoubleBuffered, double v) {
	super(isDoubleBuffered, v);
}
/**
 * Method to handle events for the ActionListener interface.
 * @param e java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public void actionPerformed(java.awt.event.ActionEvent e)
{
	String command = e.getActionCommand();
	
	if (command.equals("ucName")){
		int index = getJList1().getSelectedIndex();
		ATuseCase useCase = (ATuseCase)UseCases.elementAt(index);
		SDorUCProperties uCP = new SDorUCProperties(useCase, this);
		uCP.show();
	
	//	UseCaseProperties uCP = new UseCaseProperties(useCase, this);
	//	uCP.show();
	} else if(command.equals("sdName")){
		int i = getJList1().getSelectedIndex();
		ATuseCase useCase = (ATuseCase)UseCases.elementAt(i);
		int index = getJList2().getSelectedIndex();
		ATseqDiag seqDiag = (ATseqDiag)(useCase.getSeqDiags().elementAt(index));
		SDorUCProperties sDP = new SDorUCProperties(seqDiag, this);
		sDP.show();
	//	objName objN = new objName(seqDiag);
	//	objN.show();
		
	} else if(command.equals("Description")){
		int i = getJList1().getSelectedIndex();
		ATuseCase useCase = (ATuseCase)UseCases.elementAt(i);
		int index = getJList2().getSelectedIndex();
		ATseqDiag seqDiag = (ATseqDiag)(useCase.getSeqDiags().elementAt(index));
		ObjectProperties oP = new ObjectProperties(seqDiag);
		oP.show();
	}
}
/**
 * Comment
 */
public void addSDButton_ActionEvents() {
	//check to make sure a use case has been selected
	int index = getJList1().getSelectedIndex();
	if(index>-1){
		//get the use case that was selected and add a new
		//sequence diagram to it
		Vector list = UseCases;
		ATuseCase current = (ATuseCase)(list.elementAt(index));
		ATseqDiag sD = new ATseqDiag(version,sys.getNextKey());
		int sDnum = current.getSeqDiagCount() + 1;
		sD.setName("seq Diag " + sDnum);
		current.addSeqDiag(sD);
		//reset the list
		setList2(current);
	} else{
		sysMsg("must select Use Case");
	}
}
/**
 * Insert the method's description here.
 * Creation date: (6/14/00 9:30:09 AM)
 * @param uC system.ATuseCase
 */
public void addUseCase(ATuseCase uC) {
	//add use case and reset list 1
	UseCases.add(uC);
	setList1();
	}
/**
 * Insert the method's description here.
 * Creation date: (2/1/00 9:34:52 AM)
 */
public void clear(){
/*	java.util.Enumeration UCases = UseCases.elements();
	while(UCases.hasMoreElements()) {
		ATuseCase bla = (ATuseCase)UCases.nextElement();
		UseCases.remove(bla);
		//reset both lists
		setList1();
		setList2Empty();
		System.out.println("called");
		//deleteUseCase(bla);
	}	
	*/
}
/**
 * connEtoC1:  (AddSDButton.action. --> UseCasePanel.addSDButton_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC1() {
	try {
		// user code begin {1}
		// user code end
		this.addSDButton_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC2:  (DeleteSDButton.action. --> UseCasePanel.deleteSDButton_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC2() {
	try {
		// user code begin {1}
		// user code end
		this.deleteSDButton_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * Comment
 */
public void deleteSDButton_ActionEvents() {
	//get index of current use case
	int index = getJList1().getSelectedIndex();
	//get the use case
	ATuseCase useCase = (ATuseCase)UseCases.elementAt(index);
	//get index of seqDiag to be deleted
	index = getJList2().getSelectedIndex();
	//delete the seq Diag
	useCase.deleteSeqDiag(index);
	//reset seqDiag list
	setList2(useCase);
	return;
}
/**
 * Insert the method's description here.
 * Creation date: (6/14/00 9:30:09 AM)
 * @param uC system.ATuseCase
 */
public void deleteUseCase(ATuseCase uC) {
	//delete use case from vector
	UseCases.remove(uC);
	//reset both lists
	setList1();
	setList2Empty();
	}
/**
 * Insert the method's description here.
 * Creation date: (2/2/01 5:39:34 PM)
 * @return java.awt.Image
 */
public Image formPrintImage() {
	return null;
}
/**
 * Return the AddSDButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getAddSDButton() {
	if (ivjAddSDButton == null) {
		try {
			ivjAddSDButton = new javax.swing.JButton();
			ivjAddSDButton.setName("AddSDButton");
			ivjAddSDButton.setFont(new java.awt.Font("dialog.bold", 1, 12));
			ivjAddSDButton.setText("Add");
			ivjAddSDButton.setBounds(41, 351, 78, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjAddSDButton;
}
/**
 * Return the DeleteSDButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getDeleteSDButton() {
	if (ivjDeleteSDButton == null) {
		try {
			ivjDeleteSDButton = new javax.swing.JButton();
			ivjDeleteSDButton.setName("DeleteSDButton");
			ivjDeleteSDButton.setFont(new java.awt.Font("dialog.bold", 1, 12));
			ivjDeleteSDButton.setText("Delete");
			ivjDeleteSDButton.setBounds(143, 352, 85, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjDeleteSDButton;
}
/**
 * Return the DescriptionLabel property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JLabel getDescriptionLabel() {
	if (ivjDescriptionLabel == null) {
		try {
			ivjDescriptionLabel = new javax.swing.JLabel();
			ivjDescriptionLabel.setName("DescriptionLabel");
			ivjDescriptionLabel.setText("Description");
			ivjDescriptionLabel.setBounds(276, 22, 84, 17);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjDescriptionLabel;
}
/**
 * Return the DescriptionText property value.
 * @return javax.swing.JTextArea
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JTextArea getDescriptionText() {
	if (ivjDescriptionText == null) {
		try {
			ivjDescriptionText = new javax.swing.JTextArea();
			ivjDescriptionText.setName("DescriptionText");
			ivjDescriptionText.setBounds(0, 0, 260, 280);
			ivjDescriptionText.setLineWrap(true);
			
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjDescriptionText;
}
/**
 * Return the JLabel1 property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JLabel getJLabel1() {
	if (ivjJLabel1 == null) {
		try {
			ivjJLabel1 = new javax.swing.JLabel();
			ivjJLabel1.setName("JLabel1");
			ivjJLabel1.setText("Use Cases");
			ivjJLabel1.setBounds(32, 21, 70, 17);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJLabel1;
}
/**
 * Return the JList2 property value.
 * @return javax.swing.JList
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public javax.swing.JList getJList1() {
	if (ivjJList1 == null) {
		try {
			ivjJList1 = new javax.swing.JList();
			ivjJList1.setName("JList1");
			ivjJList1.setBounds(0, 0, 214, 127);
			setList1();
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJList1;
}
/**
 * Return the JList2 property value.
 * @return javax.swing.JList
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JList getJList2() {
	if (ivjJList2 == null) {
		try {
			ivjJList2 = new javax.swing.JList();
			ivjJList2.setName("JList2");
			ivjJList2.setBounds(0, 0, 214, 127);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJList2;
}
/**
 * Return the JScrollPane1 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JScrollPane getJScrollPane1() {
	if (ivjJScrollPane1 == null) {
		try {
			ivjJScrollPane1 = new javax.swing.JScrollPane();
			ivjJScrollPane1.setName("JScrollPane1");
			ivjJScrollPane1.setBounds(28, 37, 217, 140);
			getJScrollPane1().setViewportView(getJList1());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJScrollPane1;
}
/**
 * Return the JScrollPane2 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JScrollPane getJScrollPane2() {
	if (ivjJScrollPane2 == null) {
		try {
			ivjJScrollPane2 = new javax.swing.JScrollPane();
			ivjJScrollPane2.setName("JScrollPane2");
			ivjJScrollPane2.setBounds(28, 218, 217, 120);
			getJScrollPane2().setViewportView(getJList2());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJScrollPane2;
}
/**
 * Return the JScrollPane3 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JScrollPane getJScrollPane3() {
	if (ivjJScrollPane3 == null) {
		try {
			ivjJScrollPane3 = new javax.swing.JScrollPane();
			ivjJScrollPane3.setName("JScrollPane3");
			ivjJScrollPane3.setBounds(273, 38, 260, 299);
			ivjJScrollPane3.setHorizontalScrollBarPolicy(ivjJScrollPane3.HORIZONTAL_SCROLLBAR_NEVER);
			getJScrollPane3().setViewportView(getDescriptionText());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJScrollPane3;
}
/**
 * Insert the method's description here.
 * Creation date: (1/19/01 4:10:20 PM)
 * @return int[]
 */
public int[] getPages() {
	return null;
}
//will clear panel and objects in it
public ATobject getSelectedObject(){
	return null;
}
//returns currently selected object
public String getSelectedObjectName(){
	return null;
}
/**
 * Return the SeqDiagLabel property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JLabel getSeqDiagLabel() {
	if (ivjSeqDiagLabel == null) {
		try {
			ivjSeqDiagLabel = new javax.swing.JLabel();
			ivjSeqDiagLabel.setName("SeqDiagLabel");
			ivjSeqDiagLabel.setText("Sequence Diagrams");
			ivjSeqDiagLabel.setBounds(31, 202, 123, 17);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjSeqDiagLabel;
}
/**
 * Insert the method's description here.
 * Creation date: (6/14/00 9:59:38 AM)
 * @return java.util.Vector
 */
public Vector getUseCases() {
	return UseCases;
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(java.lang.Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
}
/**
 * Initializes connections
 * @exception java.lang.Exception The exception description.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initConnections() throws java.lang.Exception {
	// user code begin {1}
	// user code end
	selectionModel = new SingleSelectionModel() {
	    public void updateSingleSelection(int oldIndex, int newIndex) {
			int index = getJList1().getSelectedIndex();
			ATuseCase current = (ATuseCase)(UseCases.elementAt(index));
			setList2(current);
			getDescriptionText().setText(current.getDescription());
			ATseqDiag sD = null;
			seqDiagPanel.setSeqDiag(sD);
			repaint();
	    }
	};
	selectionModel2 = new SingleSelectionModel() {
		public void updateSingleSelection(int oldIndex, int newIndex) {
			int num = getJList1().getSelectedIndex();
			ATuseCase uC = (ATuseCase)(UseCases.elementAt(num));
			int index = getJList2().getSelectedIndex();
			ATseqDiag current = (ATseqDiag)(uC.getSeqDiags().elementAt(index));
			seqDiagPanel.setSeqDiag(current);
		}
	};
	getAddSDButton().addActionListener(ivjEventHandler);
	getDeleteSDButton().addActionListener(ivjEventHandler);
	MouseListener popupListener1 = new PopupListener1();
	getJList1().addMouseListener(popupListener1);
	MouseListener popupListener2 = new PopupListener2();
	getJList2().addMouseListener(popupListener2);
	FocusAdapter fA = new FocusListener1();
	getDescriptionText().addFocusListener(fA);
	getJList1().setSelectionModel(selectionModel);
	getJList2().setSelectionModel(selectionModel2);
}
/**
 * Initialize the class.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initialize() {
	try {
		// user code begin {1}
		// user code end
		setName("UseCasePanel");
		setLayout(null);
		setSize(581, 431);
		add(getJScrollPane1(), getJScrollPane1().getName());
		add(getSeqDiagLabel(), getSeqDiagLabel().getName());
		add(getJScrollPane2(), getJScrollPane2().getName());
		add(getJScrollPane3(), getJScrollPane3().getName());
		add(getDescriptionLabel(), getDescriptionLabel().getName());
		add(getAddSDButton(), getAddSDButton().getName());
		add(getDeleteSDButton(), getDeleteSDButton().getName());
		add(getJLabel1(), getJLabel1().getName());
		initConnections();
	} catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	}
	// user code begin {2}
	// user code end
}
//returns selected objects name
/**
 * This method was created in VisualAge.
 */
public void initPanel(system.ATobject object){
}
/**
 * Comment
 */
public void jList1_AncestorAdded(javax.swing.event.AncestorEvent ancestorEvent) {
	return;
}
public void mouseClicked(java.awt.event.MouseEvent e) {
}
//initialize the panel
public boolean mouseDown(int x, int y, system.ATsystem sys){
	return true;
}
//method for handeling mouseDown action
public boolean mouseDrag(int x, int y, system.ATsystem sys){
	return true;
}
/**
 * This method was created in VisualAge.
 */
public void mouseDragged(java.awt.event.MouseEvent e) {
	
}
public void mouseEntered(java.awt.event.MouseEvent e) {
}
public void mouseExited(java.awt.event.MouseEvent e) {
}
public void mouseMoved(java.awt.event.MouseEvent e) {
}
/**
 * Method to handle events for the MouseListener interface.
 * @param e java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public synchronized void mousePressed(java.awt.event.MouseEvent e) {
	if (e.isPopupTrigger())
	{
		//get the position
		int x_pos = e.getX();
		int y_pos = e.getY();
		popup.removeAll();
		setUCpopup();
		//find the object at that position
		/*if (findSelectedObject(x_pos, y_pos))
		{
			//remove all previous popup menu items
			popup.removeAll();
			//add correct menu items for component or connection
		/*	if (selected == "component")
			{
				setComponentPopup();
			}else if(selected == "connection")
			{
				setConnectionPopup();
			}*/
			//show the popup menu
			popup.show(this, e.getX(), e.getY());
		//}
	}
	// user code begin {1}
}
/**
 * Method to handle events for the MouseListener interface.
 * @param e java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public synchronized void mouseReleased(java.awt.event.MouseEvent e) {
}
//method for handling mouseDrag action
public boolean mouseUp(int x, int y, system.ATsystem sys){
	return true;
}
/**
 * Insert the method's description here.
 * Creation date: (3/7/00 2:26:28 PM)
 */
public void printPage(Graphics g, int pageIndex, Image i){
}
/**
 * This method was created in VisualAge.
 * @param e MouseEvent
 */
public synchronized void processMouseEvent(java.awt.event.MouseEvent e)
{
	//if the popup trigger has been hit (ie- the right mouse button)
	if (e.isPopupTrigger())
	{
		//get the position
		int x_pos = e.getX();
		int y_pos = e.getY();
		popup.removeAll();
		setUCpopup();
		popup.show(this, e.getX(), e.getY());
	}
	else{
		super.processMouseEvent(e); // Pass other event types on.
	}
}
/**
 * Insert the method's description here.
 * Creation date: (6/12/00 2:59:43 PM)
 */
public void setList1() {
	Enumeration uC = UseCases.elements();
	Vector names = new Vector();
	ATuseCase useCase;
	//get the names of the use cases and make them the list to choose from
	while(uC.hasMoreElements()){
		useCase = (ATuseCase)uC.nextElement();
		String n = useCase.getName();
		names.add(n);
	}
			
	ivjJList1.setListData(names);
}
/**
 * Insert the method's description here.
 * Creation date: (6/12/00 2:59:43 PM)
 */
public void setList2() {
	//get the names of the sequence diagrams for the selected
	//use case and make them the second list
	int i = getJList1().getSelectedIndex();
	if(i>-1){
		ATuseCase uC = (ATuseCase)UseCases.elementAt(i);
		
		Enumeration seqDiags = (uC.getSeqDiags()).elements();
		Vector names = new Vector();
		ATseqDiag seqDiag;
		while(seqDiags.hasMoreElements()){
			seqDiag = (ATseqDiag)seqDiags.nextElement();
			String n = seqDiag.getName();
			names.add(n);
		}		
		ivjJList2.setListData(names);
	} else {
		Vector v = new Vector();
		ivjJList2.setListData(v);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (6/12/00 2:59:43 PM)
 */
public void setList2(ATuseCase uC) {
	//get the names of the sequence diagrams for uC and make
	//them list2
	Enumeration seqDiags = (uC.getSeqDiags()).elements();
	Vector names = new Vector();
	ATseqDiag seqDiag;
	while(seqDiags.hasMoreElements()){
		seqDiag = (ATseqDiag)seqDiags.nextElement();
		String n = seqDiag.getName();
		names.add(n);
	}		
	ivjJList2.setListData(names);
}
/**
 * Insert the method's description here.
 * Creation date: (6/12/00 2:59:43 PM)
 */
public void setList2Empty() {
	//set List2 as empty
	ATseqDiag sD = null;
	seqDiagPanel.setSeqDiag(sD);
	    
	Vector names = new Vector();
		
	ivjJList2.setListData(names);
}
/**
 * Insert the method's description here.
 * Creation date: (6/14/00 10:46:47 AM)
 */
public void setSDpopup() {
	
	NameMenuItem = new MenuItem("Name");
	NameMenuItem.setActionCommand("sdName");
	NameMenuItem.addActionListener(this);
	popup.add(NameMenuItem);

	Description = new MenuItem("Description");
	Description.setActionCommand("Description");
	Description.addActionListener(this);
	popup.add(Description);
	}
/**
 * Insert the method's description here.
 * Creation date: (6/14/00 10:46:47 AM)
 */
public void setUCpopup() {
	
	NameMenuItem = new MenuItem("Name");
	NameMenuItem.setActionCommand("ucName");
	NameMenuItem.addActionListener(this);
	popup.add(NameMenuItem);
	}
/**
 * Insert the method's description here.
 * Creation date: (6/22/00 12:57:50 PM)
 * @param useCases java.util.Vector
 */
public void setUseCases(Vector useCases) {
	this.UseCases = useCases;
	setList1();
	setList2Empty();
	}
}
