package KBFile;

import java.io.*;
/*
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 */
public class RecordReader {
  
  String key;
  byte[] data;
  ByteArrayInputStream in;
  ObjectInputStream objIn;

  public RecordReader(String key, byte[] data) {
	this.key = key;
	this.data = data;
	in = new ByteArrayInputStream(data);
  }  
  public byte[] getData() {
	return data;
  }  
  public InputStream getInputStream() throws IOException {
	return in;
  }  
  public String getKey() {
	return key;
  }  
  public ObjectInputStream getObjectInputStream() throws IOException {
	if (objIn == null) {
	  objIn = new ObjectInputStream(in);
	}
	return objIn;
  }  
  /**
   * Reads the next object in the record using an ObjectInputStream.
   */
  public Object readObject() throws IOException, OptionalDataException, ClassNotFoundException {
	return getObjectInputStream().readObject();
  }  
}
