package Transforms;

/**
 * Data structure used to store data about an agent, one of its components, 
 * the component's state table, and a transition in the state table
 *
 * This data structure is used when matching up conversation halves in phase2
 *
 * Creation date: (12/4/00 11:59:36 AM)
 * @author: Clint Sparkman
 *
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
public class AgentCompTrans {
	private Agent 		agent = null;
	private Component 	component = null;
	private StateTable 	stateTable = null;
	private Transition 	transition = null;
	private SendEvent	se = null;
	private ReceiveEvent re = null;
/**
 * AgentCompTrans constructor comment.
 */
public AgentCompTrans() {
	super();
}
/**
 * AgentCompTrans constructor comment.
 */
public AgentCompTrans(Agent a, Component c, StateTable st, Transition t) {
	agent = a;
	component = c;
	stateTable = st;
	transition = t;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:10:31 PM)
 * @return Transforms.Agent
 */
public Agent getAgent() {
	return agent;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:10:31 PM)
 * @return Transforms.Component
 */
public Component getComponent() {
	return component;
}
/**
 * Insert the method's description here.
 * Creation date: (12/8/00 3:06:50 PM)
 * @return Transforms.ReceiveEvent
 */
public ReceiveEvent getRe() {
	return re;
}
/**
 * Insert the method's description here.
 * Creation date: (12/8/00 3:06:50 PM)
 * @return Transforms.SendEvent
 */
public SendEvent getSe() {
	return se;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:10:31 PM)
 * @return Transforms.StateTable
 */
public StateTable getStateTable() {
	return stateTable;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:10:31 PM)
 * @return Transforms.Transition
 */
public Transition getTransition() {
	return transition;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:10:31 PM)
 * @param newAgent Transforms.Agent
 */
public void setAgent(Agent newAgent) {
	agent = newAgent;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:10:31 PM)
 * @param newComponent Transforms.Component
 */
public void setComponent(Component newComponent) {
	component = newComponent;
}
/**
 * Insert the method's description here.
 * Creation date: (12/8/00 3:06:50 PM)
 * @param newRe Transforms.ReceiveEvent
 */
public void setRe(ReceiveEvent newRe) {
	re = newRe;
}
/**
 * Insert the method's description here.
 * Creation date: (12/8/00 3:06:50 PM)
 * @param newSe Transforms.SendEvent
 */
public void setSe(SendEvent newSe) {
	se = newSe;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:10:31 PM)
 * @param newStateTable Transforms.StateTable
 */
public void setStateTable(StateTable newStateTable) {
	stateTable = newStateTable;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:10:31 PM)
 * @param newTransition Transforms.Transition
 */
public void setTransition(Transition newTransition) {
	transition = newTransition;
}
}
