package Transforms;

/**
 * Insert the type's description here.
 * Creation date: (1/2/01)
 * Window to allow states to be selected for receive
 * moveReq messages
 * @author: Athie Self
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
 
import java.util.Vector;
import javax.swing.*;
 
public class CMStateWindow extends javax.swing.JDialog {
			
	private javax.swing.JButton 	ivjAddStateButton = null;
	private javax.swing.JButton 	ivjDeleteStateButton = null;
	private javax.swing.JButton 	ivjFinishButton = null;
	
	private javax.swing.JList 		ivjSelectedStates = null;
	
	private javax.swing.JPanel 		ivjJFrameContentPane = null;
	
	private javax.swing.JLabel 		ivjJLabel1 = null;
	private javax.swing.JLabel 		ivjJLabel2 = null;
	private javax.swing.JLabel		ivjJLabel3 = null;
	private javax.swing.JLabel		ivjJLabel4 = null;
		
	private javax.swing.JScrollPane ivjJScrollPane1 = null;
	private javax.swing.JScrollPane ivjJScrollPane2 = null;
	
	private javax.swing.JList 		ivjStates = null;
	
	private java.util.Vector 		list1 = null;
	private java.util.Vector 		list2 = null;
	
	IvjEventHandler 				ivjEventHandler = new IvjEventHandler();
	
	CMTransform10ComponentSelection	cmt10cs = null;
	
	private boolean 				done = false;

	class IvjEventHandler implements java.awt.event.ActionListener {
		public void actionPerformed(java.awt.event.ActionEvent e) {
			if (e.getSource() == CMStateWindow.this.getAddStateButton()) 
				connEtoC1();
			if (e.getSource() == CMStateWindow.this.getDeleteStateButton()) 
				connEtoC2();
			if (e.getSource() == CMStateWindow.this.getFinishButton()) 
				connEtoC3();
		};
	};
/**
 * Insert the method's description here.
 * Creation date: (6/6/00 12:07:58 PM)
 */
public CMStateWindow(Vector cStates) {
	super((java.awt.Frame)null,false);
	//super((java.awt.Frame)null, true);
	list1 = new Vector();
	list2 = new Vector();
	setlist1(cStates);
	setlist2(list2);

	initialize();
}
/**
 * Insert the method's description here.
 * Creation date: (6/6/00 12:07:58 PM)
 */
public CMStateWindow(Vector cStates, Vector vecSS) {
	super((java.awt.Frame)null,false);
	//super((java.awt.Frame)null, true);
	//vecSelected = (Vector)vecSS.clone();
	list1 = new Vector();
	list2 = new Vector();
	setlist1(cStates);
	setlist2(vecSS);

	initialize();
}
/**
 * Insert the method's description here.
 * Creation date: (6/6/00 12:07:58 PM)
 */
public CMStateWindow(CMTransform10ComponentSelection cmt10CSelection) {
	super((java.awt.Frame)null,false);
	//super((java.awt.Frame)null, true);
	cmt10cs = cmt10CSelection;
	list1 = new Vector();
	list2 = new Vector();
	setlist1(cmt10cs.candidateStates);
	setlist2(cmt10cs.vecSelectedStates);

	initialize();
}
/**
 * Comment
 */
public void addStateButton_ActionEvents() {
	int index = ivjStates.getSelectedIndex();
	if(index < 0)
		return;
			
	list2.add(list1.elementAt(index));
	list1.removeElementAt(index);
	updateLists();
}
/**
 * connEtoC1:  (AddRoleButton.action. --> RoleWindow.addRoleButton_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC1() {
	try {
		// user code begin {1}
		// user code end
		this.addStateButton_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC2:  (DeleteRoleButton.action. --> RoleWindow.deleteRoleButton_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC2() {
	try {
		// user code begin {1}
		// user code end
		this.deleteStateButton_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC3:  (FinishButton.action. --> RoleWindow.finishButton_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC3() {
	try {
		// user code begin {1}
		// user code end
		this.finishButton_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * Comment
 */
public void deleteStateButton_ActionEvents() {
	int index = getSelectedStates().getSelectedIndex();
	if(index < 0)
		return;
	
	list1.add(list2.elementAt(index));
	list2.removeElementAt(index);
	updateLists();
}
/**
 * Comment
 */
public void finishButton_ActionEvents() {
	if((list2 != null) && (list2.size() > 0)) {

		cmt10cs.vecSelectedStates = (Vector)list2.clone();
		done = true;
		this.dispose();
	}
	else{
		String msg = "Every component must have one state that receives a moveReq message!";
		Object[] options = { "OK"};
		JOptionPane.showOptionDialog(null, msg, "Warning", 
			JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE,
			null, options, options[0]);
	}
}
/**
 * Return the AddRoleButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getAddStateButton() {
	if (ivjAddStateButton == null) {
		try {
			ivjAddStateButton = new javax.swing.JButton();
			ivjAddStateButton.setName("AddStateButton");
			ivjAddStateButton.setText("=> Add  =>");
			ivjAddStateButton.setBounds(210, 153, 97, 27);
			ivjAddStateButton.setActionCommand("AddState");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjAddStateButton;
}
/**
 * Return the DeleteRoleButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getDeleteStateButton() {
	if (ivjDeleteStateButton == null) {
		try {
			ivjDeleteStateButton = new javax.swing.JButton();
			ivjDeleteStateButton.setName("DeleteProtocolButton");
			ivjDeleteStateButton.setText("<= Delete <=");
			ivjDeleteStateButton.setBounds(210, 205, 97, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjDeleteStateButton;
}
/**
 * Return the FinishButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getFinishButton() {
	if (ivjFinishButton == null) {
		try {
			ivjFinishButton = new javax.swing.JButton();
			ivjFinishButton.setName("FinishButton");
			ivjFinishButton.setText("Finish");
			ivjFinishButton.setBounds(210, 353, 97, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjFinishButton;
}
/**
 * Return the JFrameContentPane property value.
 * @return javax.swing.JPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JPanel getJFrameContentPane() {
	if (ivjJFrameContentPane == null) {
		try {
			ivjJFrameContentPane = new javax.swing.JPanel();
			ivjJFrameContentPane.setName("JFrameContentPane");
			ivjJFrameContentPane.setLayout(null);
			getJFrameContentPane().add(getJScrollPane1(), getJScrollPane1().getName());
			getJFrameContentPane().add(getJScrollPane2(), getJScrollPane2().getName());
			getJFrameContentPane().add(getAddStateButton(), getAddStateButton().getName());
			getJFrameContentPane().add(getJLabel1(), getJLabel1().getName());
			getJFrameContentPane().add(getJLabel2(), getJLabel2().getName());
			getJFrameContentPane().add(getJLabel3(), getJLabel3().getName());
			getJFrameContentPane().add(getJLabel4(), getJLabel4().getName());
			getJFrameContentPane().add(getDeleteStateButton(), getDeleteStateButton().getName());
			getJFrameContentPane().add(getFinishButton(), getFinishButton().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJFrameContentPane;
}
/**
 * Return the JLabel1 property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JLabel getJLabel1() {
	if (ivjJLabel1 == null) {
		try {
			ivjJLabel1 = new javax.swing.JLabel();
			ivjJLabel1.setName("JLabel1");
			ivjJLabel1.setText("States");
			ivjJLabel1.setBounds(34, 80, 146, 17);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJLabel1;
}
/**
 * Return the JLabel2 property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JLabel getJLabel2() {
	if (ivjJLabel2 == null) {
		try {
			ivjJLabel2 = new javax.swing.JLabel();
			ivjJLabel2.setName("JLabel2");
			ivjJLabel2.setText("Selected States");
			ivjJLabel2.setBounds(327, 80, 104, 17);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJLabel2;
}
/**
 * Return the JLabel1 property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JLabel getJLabel3() {
	String text = "";
	if (ivjJLabel3 == null) {
		try {
			ivjJLabel3 = new javax.swing.JLabel();
			ivjJLabel3.setName("JLabel3");
			ivjJLabel3.setText(text);
			ivjJLabel3.setBounds(25, 10, 475, 20);
			ivjJLabel3.setHorizontalAlignment(JLabel.CENTER);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJLabel3;
}
/**
 * Return the JLabel1 property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JLabel getJLabel4() {
	String text = "";
	if (ivjJLabel4 == null) {
		try {
			ivjJLabel4 = new javax.swing.JLabel();
			ivjJLabel4.setName("JLabel4");
			ivjJLabel4.setText(text);
			ivjJLabel4.setBounds(25, 30, 475, 20);
			ivjJLabel4.setHorizontalAlignment(JLabel.CENTER);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJLabel4;
}
/**
 * Return the JScrollPane1 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JScrollPane getJScrollPane1() {
	if (ivjJScrollPane1 == null) {
		try {
			ivjJScrollPane1 = new javax.swing.JScrollPane();
			ivjJScrollPane1.setName("JScrollPane1");
			ivjJScrollPane1.setBounds(33, 105, 160, 275);
			ivjJScrollPane1.setViewportView(getStates());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJScrollPane1;
}
/**
 * Return the JScrollPane2 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JScrollPane getJScrollPane2() {
	if (ivjJScrollPane2 == null) {
		try {
			ivjJScrollPane2 = new javax.swing.JScrollPane();
			ivjJScrollPane2.setName("JScrollPane2");
			ivjJScrollPane2.setBounds(325, 105, 160, 275);
			ivjJScrollPane2.setViewportView(getSelectedStates());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJScrollPane2;
}
/**
 * Return the AgentsRoles property value.
 * @return javax.swing.JList
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JList getSelectedStates() {
	if (ivjSelectedStates == null) {
		try {
			ivjSelectedStates = new javax.swing.JList();
			ivjSelectedStates.setName("Selected States");
			ivjSelectedStates.setBounds(0, 0, 160, 120);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjSelectedStates;
}
/**
 * Return the Roles property value.
 * @return javax.swing.JList
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JList getStates() {
	if (ivjStates == null) {
		try {
			ivjStates = new javax.swing.JList();
			ivjStates.setName("States");
			ivjStates.setBounds(0, 0, 157, 272);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjStates;
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(java.lang.Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
}
/**
 * Initializes connections
 * @exception java.lang.Exception The exception description.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initConnections() throws java.lang.Exception {
	// user code begin {1}
	// user code end
	getAddStateButton().addActionListener(ivjEventHandler);
	getDeleteStateButton().addActionListener(ivjEventHandler);
	getFinishButton().addActionListener(ivjEventHandler);
}
/**
 * Initialize the class.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initialize() {
	try {
		// user code begin {1}
		// user code end
		setName("StateWindow");
		setTitle("Select States For Receiving Calls to Move");
		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		setSize(525, 435);
		setContentPane(getJFrameContentPane());
		initConnections();
		
	} catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	}
	// user code begin {2}
	// user code end
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 12:18:08 PM)
 * @return boolean
 */
public boolean isDone() {
	return done;
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 12:18:08 PM)
 * @param newDone boolean
 */
public void setDone(boolean newDone) {
	done = newDone;
}
/**
 * Set the list to a new value.
 * @param newValue java.util.Vector
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public void setlist1(java.util.Vector newValue) {
	try {
	//	list1 = newValue;
		java.util.Enumeration temp = newValue.elements();
		Vector list = new Vector();
		while(temp.hasMoreElements()){
			State s = (State)temp.nextElement();
			list1.add(s);
			list.add(s.getName());
		}
		getStates().setListData(list);
		// user code begin {1}
			// user code end
	} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
		handleException(ivjExc);
	}
	// user code begin {3}
	// user code end
}
/**
 * Set the list to a new value.
 * @param newValue java.util.Vector
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public void setlist2(java.util.Vector newValue) {
	try {
		list2 = (Vector)newValue.clone();
		java.util.Enumeration temp = list2.elements();
		Vector list = new Vector();
		while(temp.hasMoreElements()){
			State s = (State)temp.nextElement();
			list2.add(s);
			list.add(s.getName());
		}
	//	java.util.Vector oldValue = getlist();
		getSelectedStates().setListData(list);
		// user code begin {1}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {2}
		// user code end
		handleException(ivjExc);
	}
	// user code begin {3}
	// user code end
}
/**
 * Insert the method's description here.
 * Creation date: (11/7/00 12:35:41 PM)
 */
public void updateLists() {
	java.util.Enumeration temp = list1.elements();
	Vector list = new Vector();
	while(temp.hasMoreElements()){
		State s = (State)temp.nextElement();
		list.add(s.getName());
	}
	getStates().setListData(list);
	
	temp = list2.elements();
	list = new Vector();
	while(temp.hasMoreElements()){
		State s = (State)temp.nextElement();
		list.add(s.getName());
	}
	getSelectedStates().setListData(list);
}
}
