package Transforms;

/**
 * This class is used to represent one half of a conversation.
 * ConversationHalfs belong to agent components, but their state tables
 * make up the state tables for conversations.
 *
 * Creation date: (11/3/00 10:50:21 AM)
 * @author: Clint Sparkman
 *
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */

import java.util.Vector;
import java.util.Enumeration;
import system.ATstatetable;
import system.ATtableElement;
 
public class ConversationHalf {
	private StateTable	stateTable;			
	private String		convID;
/**
 * Insert the method's description here.
 * Creation date: (12/2/00 6:24:20 PM)
 */
public ConversationHalf(String n, TSystem tSys) {
	convID = n;
	ATstatetable st = new ATstatetable(tSys.version, tSys.atSys.getNextKey());
	Enumeration e = st.returnStates();
	Vector states = new Vector();
	while(e.hasMoreElements()){
		ATtableElement te = (ATtableElement)e.nextElement();
		states.add(new State(te, null, tSys));
	}
	stateTable = new StateTable(st, states, null, tSys);
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:36:42 PM)
 * @return java.lang.String
 */
public java.lang.String getConvID() {
	return convID;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:36:42 PM)
 * @return Transforms.StateTable
 */
public StateTable getStateTable() {
	return stateTable;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:36:42 PM)
 * @param newConvID java.lang.String
 */
public void setConvID(java.lang.String newConvID) {
	convID = newConvID;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:36:42 PM)
 * @param newStateTable Transforms.StateTable
 */
public void setStateTable(StateTable newStateTable) {
	stateTable = newStateTable;
}
}
