package Transforms;

/**
 * This class is used to query the user to determine if external events
 * match up as the start of conversations.
 *
 * Creation date: (12/8/00 9:26:04 AM)
 * @author: 
 *
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import system.ATstatetable;
import system.ATtransition;
import Editor.ConversationPanel;
import Editor.RolePanel;

public class ConversationWindow extends javax.swing.JDialog {
	Agent a1 = null, a2 = null; 
	Component c1 = null, c2 = null; 
	Transition t1 = null, t2 = null;
	SendEvent se = null;
	ReceiveEvent re = null;
	TSystem s = null;

	
	JScrollPane			scrollPane1;
	JScrollPane			scrollPane2;
	JScrollPane			scrollPane3;
	JPanel				panel1;
	JPanel				panel2;
	JPanel				panel3;
	JPanel				panel4;
	JPanel				buttonPanel;
	JPanel				msgPanel;
	JLabel				label1;
	JLabel				label2;
	JLabel				label3;
	JLabel				label4;
	JTextPane			textPane1;
	ConversationPanel 	convPanel1;
	ConversationPanel 	convPanel2;
	RolePanel			rolePanel;
	JButton				yesButton;
	JButton				noButton;
	int 				value = 0;
	JLabel				msg1;
	JLabel				msg2;
	JLabel				msg3;
/**
 * Constructor that initializes the dialog.  Nothing will be displayed yet.
 *
 * Creation date: (12/8/00 9:30:49 AM)
 */
public ConversationWindow(double v) {
	convPanel1 = new ConversationPanel(v);
	convPanel2 = new ConversationPanel(v);
	rolePanel = new RolePanel(v);

	// set up the scroll panes	
	scrollPane1 = new JScrollPane(convPanel1);
	scrollPane1.setPreferredSize(new Dimension(500, 320));
	scrollPane2 = new JScrollPane(rolePanel);
	scrollPane2.setPreferredSize(new Dimension(500, 320));
	scrollPane3 = new JScrollPane(convPanel2);
	scrollPane3.setPreferredSize(new Dimension(500, 320));

	// set up the labels
	label1 = new JLabel();
	label1.setPreferredSize(new Dimension(500, 30));
	label1.setHorizontalAlignment(JLabel.CENTER);
	
	label2 = new JLabel("Role Model");
	label2.setPreferredSize(new Dimension(500, 30));
	label2.setHorizontalAlignment(JLabel.CENTER);

	label3 = new JLabel();
	label3.setPreferredSize(new Dimension(500, 30));
	label3.setHorizontalAlignment(JLabel.CENTER);

	label4 = new JLabel();
	label4.setPreferredSize(new Dimension(500, 100));
	
	panel1 = new JPanel();
	panel1.setPreferredSize(new Dimension(500, 350));
	panel1.setLayout(new BorderLayout());
	panel1.add(label1, BorderLayout.NORTH);
	panel1.add(scrollPane1, BorderLayout.SOUTH);

	panel2 = new JPanel();
	panel2.setPreferredSize(new Dimension(500, 350));
	panel2.setLayout(new BorderLayout());
	panel2.add(label2, BorderLayout.NORTH);
	panel2.add(scrollPane2, BorderLayout.SOUTH);

	panel3 = new JPanel();
	panel3.setPreferredSize(new Dimension(500, 350));
	panel3.setLayout(new BorderLayout());
	panel3.add(label3, BorderLayout.NORTH);
	panel3.add(scrollPane3, BorderLayout.SOUTH);


	msg1 = new JLabel();
	msg1.setHorizontalAlignment(JLabel.CENTER);
	msg1.setPreferredSize(new Dimension(500, 50));
	msg2 = new JLabel();
	msg2.setHorizontalAlignment(JLabel.CENTER);	
	msg2.setPreferredSize(new Dimension(500, 50));
	msg3 = new JLabel();
	msg3.setHorizontalAlignment(JLabel.CENTER);
	msg3.setPreferredSize(new Dimension(500, 50));
	
	msgPanel = new JPanel();
	msgPanel.setPreferredSize(new Dimension(500, 250));
	msgPanel.setLayout(new GridLayout(4,0));
	msgPanel.add(label4);
	msgPanel.add(msg1);
	msgPanel.add(msg2);
	msgPanel.add(msg3);
	
	ActionListener act1 = new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
 			value = 1;
 			setVisible(false);
		}
  	};

	ActionListener act2 = new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
 			value = 2;
 			setVisible(false);
		}
  	};
	
	// create the buttons
	yesButton = new JButton("YES");
	yesButton.addActionListener(act1);
	//yesButton.setPreferredSize(new Dimension(100, 40));
	noButton = new JButton("NO");
	noButton.addActionListener(act2);
	//noButton.setPreferredSize(new Dimension(100, 40));

	buttonPanel = new JPanel();
	buttonPanel.setPreferredSize(new Dimension(500, 100));
	buttonPanel.add(yesButton);
	buttonPanel.add(noButton);	
		
	panel4 = new JPanel();
	panel4.setPreferredSize(new Dimension(500, 350));
	panel4.setLayout(new BorderLayout());
	panel4.add(msgPanel, BorderLayout.NORTH);
	panel4.add(buttonPanel, BorderLayout.SOUTH);

	getContentPane().setLayout(new GridLayout(2,2));
	getContentPane().add(panel1);
	getContentPane().add(panel2);
	getContentPane().add(panel3);
	getContentPane().add(panel4);	
}
/**
 * Waits until the value has been set and then returns it
 *
 * Creation date: (12/8/00 9:50:39 AM)
 */

public int getValue() {
	while(value == 0)
	try{
		Thread.sleep(10);
	}catch(Exception e){}
	
	return value;
}
/**
 * This is the method that loads the visual information into the window
 *
 * Creation date: (12/8/00 9:50:39 AM)
 */
public void loadWindow(Agent agent1, Agent agent2, Component comp1, Component comp2, Transition trans1, Transition trans2, SendEvent sendEvent, ReceiveEvent receiveEvent, TSystem sys) {
	// reset value to 0
	value = 0;
	
	a1 = agent1;
	a2 = agent2;
	c1 = comp1;
	c2 = comp2;
	t1 = trans1;
	t2 = trans2;
	se = sendEvent;
	re = receiveEvent;
	s = sys;
	
	convPanel1.setComponent(c1.getAtComponent());
	convPanel2.setComponent(c2.getAtComponent());
	rolePanel.initPanel(sys.atSys);

	label1.setText("Agent: " + a1.getName() + ", Component: " + c1.getName());
	label3.setText("Agent: " + a2.getName() + ", Component: " + c2.getName());

	String m1 = "Does the SendEvent: " + se + " in Component: " + c1.getName();
	msg1.setText(m1);
	String m2 = "correspond the ReceiveEvent: " + re + " in Component: " + c2.getName() + "?";	
	msg2.setText(m2);
	String m3 = "If YES, the transitions will represent the start of a conversation.";
	msg3.setText(m3);	

	t1.getAtTransition().Selected = true;
	t2.getAtTransition().Selected = true;
	
	pack();
	
	update(this.getGraphics());
	setVisible(true);
}
/**
 * This method calls the other panels' update methods to redraw the graphics
 *
 * Creation date: (12/8/00 9:50:39 AM)
 */
public synchronized void update(Graphics g) {
	try{
		convPanel1.update(g);
		convPanel2.update(g);
		//rolePanel.update(s.atSys, g);
		rolePanel.update(g);
		scrollPane1.update(g);
		scrollPane2.update(g);
		scrollPane3.update(g);
		super.update(g);
	}catch(Exception e){}
}
}
