package Transforms;

/**
 * This class represents the tasks that roles have in the role model
 *
 * Creation date: (11/3/00 10:50:21 AM)
 * @author: Clint Sparkman
 *
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */

import java.util.Vector;
import system.ATTask;
 
public class Task {
	private ATTask		atTask = null;
	private String 		name = null;			// name of the task
	private StateTable 	stateTable = null;		// task's state table
/**
 * Insert the method's description here.
 * Creation date: (11/3/00 3:42:37 PM)
 */
public Task(ATTask t, StateTable st) {
	name = t.getName();
	stateTable = st;
	atTask = t;
}
/**
 * Method used to determine if two tasks are equivalent
 *
 * Creation date: (11/24/00 1:30:17 PM)
 */
public boolean equals(Task t){
	if(t.name.equals(name) && (t.stateTable == stateTable))
		return true;
	else
		return false;
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 9:32:35 AM)
 * @return system.ATTask
 */
public system.ATTask getAtTask() {
	return atTask;
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 9:32:35 AM)
 * @return java.lang.String
 */
public java.lang.String getName() {
	return name;
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 9:32:35 AM)
 * @return Transforms.StateTable
 */
public StateTable getStateTable() {
	return stateTable;
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 9:32:35 AM)
 * @param newAtTask system.ATTask
 */
public void setAtTask(system.ATTask newAtTask) {
	atTask = newAtTask;
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 9:32:35 AM)
 * @param newName java.lang.String
 */
public void setName(java.lang.String newName) {
	name = newName;
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 9:32:35 AM)
 * @param newStateTable Transforms.StateTable
 */
public void setStateTable(StateTable newStateTable) {
	stateTable = newStateTable;
}
/**
 * Show method used for debugging
 *
 * Creation date: (11/6/00 1:08:01 PM)
 */
public void show() {
	System.out.println("Task: " + name);
	stateTable.show();
	
}
/**
 * Returns a string representation of the task
 *
 * Creation date: (11/6/00 1:08:01 PM)
 */
public String toString() {
	String t = "Task: " + name + "\n";
	t = t + stateTable.toString();
	return t;
	
}
}
