package Verify;

/**
 * A Class for getting error messages from an error file, <tt>error</tt>, that is
 * created when Spin analyzes the Promela source code.
 * @version 1.0 6 Oct 1999
 * @author Capt Tim Lacey
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
import java.util.*;
class ErrorTable
{
	String errorMessage = null;
/**
 * Constructor that reads a line of the error file, <tt>error</tt>
 * @param line the error text
 * @return nothing
 * @throws nothing
 */
public ErrorTable(String line)
{
	// Use the newline terminator as a token to get only one line of the error
	// message at a time.
	StringTokenizer t = new StringTokenizer(line, "\n");
	// Keep getting lines while more exist
	while (t.hasMoreTokens())
	{
		errorMessage = t.nextToken();
	}
}
/**
 * Get the value of <tt>errorMessage</tt>
 * @param nothing
 * @return the line of error Message
 * @throws nothing
 */
public String getErrorMessage()
{
	return errorMessage;
}
}
