package Verify;

/**
 * A Class for getting lines of code from the verify file, <tt>verify</tt>
 * @version 1.0 6 Oct 1999
 * @author Capt Tim Lacey
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
import java.util.*;
class VerifyTable
{
	String lineOfCode = null;
/**
 * Constructor that reads a line of code from the file, <tt>verify</tt>,
 * @param line the line of code from the verify file
 * @return nothing
 * @throws nothing
 */
public VerifyTable(String line)
{
	// read an entire line of code
	StringTokenizer t = new StringTokenizer(line, "\n");
	while (t.hasMoreTokens())
	{
		lineOfCode = t.nextToken();
	}
}
/**
 * Get the line of code from the verify file
 * @param nothing
 * @return the line of code
 * @throws nothing
 */
public String getLineOfCode()
{
	return lineOfCode;
}
}
