package afit.mom;

/**
 * AFIT agentMom - version 1.0
 *
 * 4 October 1999
 *
 * agentMom Sorry conversation definition.
 *
 * It defines a general purpose conversation to reply "Sorry"
 * to any unknown type of conversation.
 *
 */

import java.net.*;
import java.io.*;
public class Sorry extends Conversation {
	protected Agent parent; // override parent
/**
 * Server_Register constructor comment.
 */
public Sorry(Socket s, ObjectInputStream i, ObjectOutputStream o, Agent a, Message m1) {
	super(a);
	parent = a;
	connection = s;
	input = i;
	output = o;
	m = m1;
}
/**
 * This method was created in VisualAge.
 */
public void run() {
	int state = 0;
	boolean notDone = true;

	//set up conversation
	try {
		while (notDone) {
			switch (state) {
				case 0 :
					m.setPerformative("sorry");
					m.setContent("unknown conversation request");
					sendMessage(m, output);
					notDone = false;
					break;
			}
		}
		input.close();
		output.close();
		connection.close();
	} catch (UnknownHostException e) {
		System.out.println(" ** Unknown Host exception.");
	} catch (EOFException oef) {
		System.out.println(" ** Server terminated connection.");
	} catch (IOException e) {
		System.out.println(" ** IO Exception.");
		e.printStackTrace();
	}
}
}
