package agentBase;

/**
 * This type was created in VisualAge.
 *
 * It defines a general purpose conversation to reply "Sorry"
 * to any unknown type of conversation.
 *
 */
import java.net.*;
import java.io.*;
import afit.mom.*;
import javax.swing.*;

public class CAStoreObject extends Conversation
{
	protected ConnectionAgent parent; // override parent
	public    JFrame CG;
	private   ATKB_Object object = null;
	StoreGUI  gui = null;
/**
 * Server_Register constructor comment.
 */
public CAStoreObject(ConnectionAgent a, String destinationName, int destinationPort, ATKB_Object o, JFrame graphical)
{
	super(a, destinationName, destinationPort);
	parent = a;
 	object = o;
	gui =  (StoreGUI) graphical;
}
/**
 * This method was created in VisualAge.
 */
public void run()
{
	int state = 0;
	boolean notDone = true;
	Message m= new Message();
	gui.setFeedback("");
	
	//set up conversation
	try
	{
		System.out.println(" ** Creating Socket.");
		connection = new Socket(connectionHost, connectionPort);
		System.out.println(" ** Establishing output stream.");
		output = new ObjectOutputStream(connection.getOutputStream());
		output.flush();
		input = new ObjectInputStream(connection.getInputStream());
		String s = null;
		while (notDone)
		{
			switch (state)
			{
				case 0 :
					System.out.println(" ** Building message.");
					m.setContent(object);
					m.setPerformative("store");
					System.out.println(" ** Sending message.");
					//wait??
					sendMessage(m, output);
					state = 1;
					break;
				case 1 :
					System.out.println(" ** Waiting for response message.");
					m = readMessage(input);
					if (m.performative.equals("storeerror")){
						System.out.println(" ** Received error response message.");
						s ="This key is in use, choose another.  If you have updated a file and are trying to overwrite the old version, you can click the update button and the file will be stored with a new version number in the key.";
						gui.toggleButtons(true);
					}
					else {
						System.out.println(" ** Received success response message.");
						s = "ATobject spec successfully stored.  You may close this window.";
					}
					gui.setFeedback(s);	
					notDone = false;
					break;
			}
		}
		input.close();
		output.close();
		connection.close();
	}
	catch (UnknownHostException e)
	{
		System.out.println(" ** Unknown Host exception.");
	}
	catch (EOFException oef)
	{
		System.out.println(" ** Server terminated connection.");
	}
	catch (IOException e)
	{
		System.out.println(" ** IO Exception.");
		e.printStackTrace();
	}
}
}
