package agentBase;

/**
 * This type was created in VisualAge.
 *
 * It defines a general purpose conversation to reply "Sorry"
 * to any unknown type of conversation.
 *
 */
import java.net.*;
import java.io.*;
import afit.mom.*;
import KBFile.*;

public class KBList extends Conversation
{
	protected KBAdministrator parent; // override parent
/**
 * Server_Register constructor comment.
 */
public KBList(Socket s, ObjectInputStream i, ObjectOutputStream o, Agent a, Message m1)
{
	super(a);
	parent = (KBAdministrator)a;
	connection = s;
	input  = i;
	output = o;
	m = m1;
	
}
/**
 * This method was created in VisualAge.
 */
public void run()
{
	int state = 0;
	boolean notDone = true;
	System.out.println(" ** Receiving message content.");
	m.setPerformative("listerror");
	String type  = (String) m.getContent();
	
	//set up conversation
	try
	{
		while (notDone)
		{
			switch (state)
			{
			  case 0 :
			  
				System.out.println(" ** Building List of type " + type);
				m.setContent(parent.list(type));
				m.setPerformative("listretrieved");
				System.out.println(" ** Returning a " + m.getContent().getClass().getName());
				state=1;
				break;

			  case 1 :
			   	notDone = false;
			   	System.out.println(" ** Sending list **");
			   	sendMessage(m, output);
				break;
			}
		}
		input.close();
		output.close();
		connection.close();
	}
	catch (UnknownHostException e)
	{
		System.out.println(" ** Unknown Host exception.");
	}
	catch (EOFException oef)
	{
		System.out.println(" ** Server terminated connection.");
	}
	catch (IOException e)
	{
		System.out.println(" ** IO Exception.");
		e.printStackTrace();
	}
}
}
