package agentBase;

/**
 * This type was created in VisualAge.
 *
 * It defines a general purpose conversation to reply "Sorry"
 * to any unknown type of conversation.
 *
 */
import java.net.*;
import java.io.*;
import afit.mom.*;
import KBFile.*;

public class KBLoadObject extends Conversation
{
	protected KBAdministrator parent; // override parent
/**
 * Server_Register constructor comment.
 */
public KBLoadObject(Socket s, ObjectInputStream i, ObjectOutputStream o, Agent a, Message m1)
{
	super(a);
	parent = (KBAdministrator)a;
	connection = s;
	input  = i;
	output = o;
	m = m1;
	
}
/**
 * This method was created in VisualAge.
 */
public void run()
{
	int state = 0;
	boolean notDone = true;
	System.out.println(" ** Receiving message content.");
	m.setPerformative("loaderror");
	ATKB_Object c = (ATKB_Object)m.getContent();
	String key  = c.getkey();
	String type = c.getotype();
	//set up conversation
	try
	{
		while (notDone)
		{
			switch (state)
			{
			  case 0 :
				System.out.println(" ** Searching for key " + key);
				if (type.equals("system.ATconversation")) {
				   if (parent.cLibrary.recordExists(key)) {
					  m.setContent(parent.load(c));
					  m.setPerformative("objectretrieved");
				   }
				   state=1;
				   break;
				}
				
				else if   (type.equals("system.ATagent")) {
				   if (parent.aLibrary.recordExists(key)) {
				      m.setContent(parent.load(c));
				      m.setPerformative("objectretrieved");
				   }
				   state = 1;
				   break;
				}
 				else if  (type.equals("system.ATsystem")) {
				   if (parent.sLibrary.recordExists(key)) {
				      m.setContent(parent.load(c));
				      m.setPerformative("objectretrieved");
 				   }
				   state = 1;
				   break;
				}
				if (type.equals("system.ATagentComponent")) {
				   if (parent.cmptLibrary.recordExists(key)) {
					  m.setContent(parent.load(c));
					  m.setPerformative("objectretrieved");
				   }
				   state=1;
				   break;
				}
				
				else if   (type.equals("system.ATarchitecture")) {
				   if (parent.archLibrary.recordExists(key)) {
				      m.setContent(parent.load(c));
				      m.setPerformative("objectretrieved");
				   }
				   state = 1;
				   break;
				}
 				else if  (type.equals("system.ATframework")) {
				   if (parent.fLibrary.recordExists(key)) {
				      m.setContent(parent.load(c));
				      m.setPerformative("objectretrieved");
 				   }
				   state = 1;
				   break;
				}
 				else if  (type.equals("system.ATrole")) {
				   if (parent.rLibrary.recordExists(key)) {
				      m.setContent(parent.load(c));
				      m.setPerformative("objectretrieved");
 				   }
				   state = 1;
				   break;
				}				
 				else {
	 			   System.out.println(" ** Key not found ** ");
				   state = 1;
 				}
			  case 1 :
			   	notDone = false;
			   	System.out.println(" ** Sending located object ** ");
			   	sendMessage(m, output);
				break;
			}
		}
		input.close();
		output.close();
		connection.close();
	}
	catch (UnknownHostException e)
	{
		System.out.println(" ** Unknown Host exception.");
	}
	catch (EOFException oef)
	{
		System.out.println(" ** Server terminated connection.");
	}
	catch (IOException e)
	{
		System.out.println(" ** IO Exception.");
		e.printStackTrace();
	}
}
}
