package agentBase;

/**
 * This type was created in VisualAge.
 *
 * It defines a general purpose conversation to reply "Sorry"
 * to any unknown type of conversation.
 *
 */
import java.net.*;
import java.io.*;
import afit.mom.*;
import KBFile.*;

public class KBStoreObject extends Conversation
{
	protected KBAdministrator parent; // override parent
/**
 * Server_Register constructor comment.
 */
public KBStoreObject(Socket s, ObjectInputStream i, ObjectOutputStream o, Agent a, Message m1)
{
	super(a);
	parent = (KBAdministrator)a;
	connection = s;
	input  = i;
	output = o;
	m = m1;
	
}
/**
 * This method was created in VisualAge.
 */
public void run()
{
	int state = 0;
	boolean notDone = true;
	System.out.println(" ** Receiving message content.");
	ATKB_Object kbObj = (ATKB_Object)m.content;
	m.setPerformative("storeerror");
	String c = kbObj.getotype();
	String key = kbObj.getkey();
	//ATObjectFile workLibrary = null;

	//set up conversation
	try
	{
		while (notDone)
		{
			switch (state)
			{
			  case 0 :
				System.out.println(" ** Searching for key " + key);
				if (parent.keyTest(c, key)) {
				     System.out.println(" ** Key in use **");
				     m.setContent("Key chosen identifies an existing agentTool component. Please choose anotehr and STORE again.");
				}
			    else m.setPerformative("acknowledgestore");
				state = 1;
				break;
				
			  case 1 :
				System.out.println(" ** Building response message.");
				if (m.getPerformative() == "acknowledgestore") 
				    parent.store(kbObj);
				System.out.println(" ** Replying to Store request.");	
				sendMessage(m, output);
				notDone = false;
				break;
			}
		}
		input.close();
		output.close();
		connection.close();
	}
	catch (UnknownHostException e)
	{
		System.out.println(" ** Unknown Host exception.");
	}
	catch (EOFException oef)
	{
		System.out.println(" ** Server terminated connection.");
	}
	catch (IOException e)
	{
		System.out.println(" ** IO Exception.");
		e.printStackTrace();
	}
}
}
