package system;

/**
 * protocol between two tasks in role diagram
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
 import java.util.*;
public class ATProtocol extends ATobject {
	private ATTask currentState;
	private ATTask nextState;
	// graphics info
	private ATProtocolGRFX grfxObj;
	private ATProtocolGRFX grfxObj2;
	public boolean Selected;
	public boolean taskShown;
	private static final String ukh = "prot@";
//	private ATtableElement first;
//	private ATtableElement second;
/**
 * ATtransition constructor comment.
 */
public ATProtocol(double ver, String[] tokens, ATsystem sys) {
	super(ver);
	grfxObj    = new ATProtocolGRFX();
	grfxObj2   = new ATProtocolGRFX();
	currentState = null;
	nextState = null;
	int loc2 = 6;
	
	int loc = ATtokenOps.findnextinstanceof("version",tokens,0);
	double v=Double.parseDouble(tokens[loc+3]);
	//setVersion(v);
	
	loc = ATtokenOps.findnextinstanceof("name", tokens, loc);
	if(loc>0){
		setName(tokens[loc+3]);
	}

	boolean keybased = false;
	
	loc  = ATtokenOps.findnextinstanceof("key", tokens, loc);
	if(loc != -1) {
		setKey(tokens[loc+3]);
		keybased = true;
	} else {
		setKey(ukh + sys.getNextKey());
	}
	
	loc = ATtokenOps.findnextinstanceof("c1", tokens, loc);
	loc2 = ATtokenOps.findnextinstanceof("c2", tokens, loc);
	ATTask t1,t2;
	Enumeration tasks = sys.returnTasks();
	while(tasks.hasMoreElements()){
		t1 = (ATTask)tasks.nextElement();
		if(keybased) {
			if(t1.getKey().equals(tokens[loc+3])){currentState = t1;}
			if(t1.getKey().equals(tokens[loc2+3])){nextState = t1;}
		} else {
			if(t1.getName().equals(tokens[loc+3])){currentState = t1;}
			if(t1.getName().equals(tokens[loc2+3])){nextState = t1;}
		}
	}
	
	loc = ATtokenOps.findnextinstanceof("view",tokens,loc+2);
	int j = 0;
	if(loc>0){
		j = Integer.parseInt(tokens[loc+5]);
		loc+=5;
	}
	
	if(currentState == null) {
		System.out.println("Error!!!  Protocol start task not found.");
	} else if(nextState == null) {
		System.out.println("Error!!!  Protocol end task not found.");
	} else {
		setCoordinates(currentState,nextState);
	}
	
/*	for(int i=0; i<j; i++){
		int k = Integer.parseInt(tokens[loc+6]);
		loc+=6;
		int l = Integer.parseInt(tokens[loc+6]);
		loc+=6;
		grfxObj.Xs[i]=k;
		grfxObj.Ys[i]=l;
	}
	grfxObj.n_pts = j;
*/

	int[] xpos = new int[j];
	int[] ypos = new int[j];
		
	for(int i=0; i<j; i++){
		loc+=12;
		xpos[i] = Integer.parseInt(tokens[loc-6]);
		ypos[i] = Integer.parseInt(tokens[loc]);
	}
	grfxObj.initializePoints(xpos,ypos);
	
	loc = ATtokenOps.findnextinstanceof("linetype",tokens,loc);
	grfxObj.setType(tokens[loc+4]);

	loc = ATtokenOps.findnextinstanceof("ext",tokens,loc+4);
	if(loc != -1) grfxObj.setExternal(tokens[loc+4].equalsIgnoreCase("t"));
		// Sends the boolean result of this String test to setExternal
	
	//if(loc != -1) {
	//	grfxObj.setExternal(tokens[loc+4] == "f");
	//}
	
	grfxObj.Arrow();
	
/*	for(int i=0; i<j; i++){
		int k = Integer.parseInt(tokens[loc+6]);
		loc+=6;
		int l = Integer.parseInt(tokens[loc+6]);
		loc+=6;
		grfxObj2.Xs[i] = k;
		grfxObj2.Ys[i] = l;
	}
	grfxObj2.n_pts=j;
*/
	j=0;
	loc = ATtokenOps.findnextinstanceof("n_pts2",tokens,loc+4);
	if(loc>0){
		j = Integer.parseInt(tokens[loc+3]);
		loc+=3;
	}
	
	xpos = new int[j];
	ypos = new int[j];
		
	for(int i=0; i<j; i++){
		loc+=12;
		xpos[i] = Integer.parseInt(tokens[loc-6]);
		ypos[i] = Integer.parseInt(tokens[loc]);
	}
	grfxObj2.initializePoints(xpos,ypos);
	
	grfxObj2.Arrow();
}
//	private ATtableElement first;
//	private ATtableElement second;
/**
 * ATtransition constructor comment.
 */
public ATProtocol(double v, int keynum) {
	super(v);
	setKey(ukh + keynum);
	grfxObj = new ATProtocolGRFX();
	grfxObj2 = new ATProtocolGRFX();
	taskShown = true;
}
//	private ATtableElement first;
//	private ATtableElement second;
/**
 * ATtransition constructor comment.
 */
public ATProtocol(double ver, String maml, ATsystem sys) {
	this(ver,ATtokenOps.parseLine(maml),sys);
}
//	private ATtableElement first;
//	private ATtableElement second;
/**
 * ATtransition constructor comment.
 */
public ATProtocol(ATProtocol cp) {
	super(cp);
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void addPoint(int x, int y) {
	if(taskShown){
		grfxObj.addPoint(x,y);
		grfxObj.Arrow();
	} else {
		grfxObj2.addPoint(x,y);
		grfxObj2.Arrow();
	}
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void arrange_pts() {
	grfxObj.arrange_pts();
	grfxObj.Arrow();
	grfxObj2.arrange_pts();
	grfxObj2.Arrow();
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public boolean checkSelected(int x, int y) {
	if(taskShown){
		return grfxObj.dist(x,y);
	} else {
		return grfxObj2.dist(x,y);
	}
}
/**
 * This method was created in VisualAge.
 */
public void deleteMe() {
	grfxObj.deleteMe();
	grfxObj2.deleteMe();
}
/**
 * This method was created in VisualAge.
 * @param g java.awt.Graphics
 */
public void draw(java.awt.Graphics g) {
	if(taskShown){
		grfxObj.drawLine(g);
		if(Selected){
			grfxObj.drawSelected(g);
		}
	} else {
		grfxObj2.drawLine(g);
		if(Selected){
			grfxObj2.drawSelected(g);
		}
	}
}
/**
 * Insert the method's description here.
 * Creation date: (11/7/00 5:06:45 PM)
 * @return boolean
 */
public boolean external() {
	return grfxObj.external();
}
/**
 * Insert the method's description here.
 * Creation date: (7/18/00 7:54:56 AM)
 * @return system.ATTask
 */
public ATTask getInitiator() {
	return currentState;
}
/**
 * Insert the method's description here.
 * Creation date: (10/20/99 2:44:02 PM)
 */
public String getMAML() throws NullPointerException {
	MAML="";
//	String hold=null;
	//Opening line for an Transisiton element
	MAML+="\t\t<protocol";
//	if (nextState==null) hold="none";
//	else hold=nextState.getName();
	MAML+=" version=\"" + Double.toString(version) + "\"\n";
	
	MAML+=" name=\"" + name + "\"\n";
	
	MAML += " key=\"" + getKey() + "\"";
	
	MAML+=" c1=\"" + ((currentState==null) ? "resource" : currentState.getKey()) + "\"\n";	
	MAML+=" c2=\"" + ((nextState==null) ? "resource" : nextState.getKey()) + "\"";
	//MAML+=" c1=\"" + ((currentState==null) ? "resource" : currentState.getName()) + "\"\n";	
	//MAML+=" c2=\"" + ((nextState==null) ? "resource" : nextState.getName()) + "\"";
	
	
	MAML+="\n\t\t<view";
	MAML+=" n_pts=\""+grfxObj.n()+"\"";//>\n";
	for(int j = 0; j<grfxObj.n(); j++){
		MAML+=" x" +j+ "=\"" +grfxObj.x(j) +"\"";
		MAML+=" y" +j+ "=\"" +grfxObj.y(j) +"\"";
	}
	MAML+=" linetype =\"" + grfxObj.type()+ "\"";///>\n";
	MAML+=" ext =\"" + ((grfxObj.external())? "t":"f") + "\"";///>\n";
	MAML+=" POS1 =\"" + grfxObj.pos1 + "\" \"" + grfxObj.num1 + "\"";
	MAML+=" POS2 =\"" + grfxObj.pos2 + "\" \"" + grfxObj.num2 + "\"/>\n";
	
	MAML+=" n_pts2=\""+grfxObj2.n()+"\"";//>\n";
	for(int j = 0; j<grfxObj2.n(); j++){
		MAML+=" x" +j+ "=\"" +grfxObj2.x(j) +"\"";
		MAML+=" y" +j+ "=\"" +grfxObj2.y(j) +"\"";
	}
	MAML+=" linetype2 =\"" + grfxObj2.type()+ "\"";///>\n";
	MAML+=" POS1 =\"" + grfxObj2.pos1 + "\" \"" + grfxObj2.num1 + "\"";
	MAML+=" POS2 =\"" + grfxObj2.pos2 + "\" \"" + grfxObj2.num2 + "\"/>\n";
	MAML+="\t\t</protocol>\n";

	return MAML;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getName() {
	return name;
}
/**
 * Insert the method's description here.
 * Creation date: (7/18/00 7:54:56 AM)
 * @return system.ATTask
 */
public ATTask getResponder() {
	return nextState;
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void movePoint(int x, int y) {
	if(taskShown){
		grfxObj.movePoint(x,y);
		grfxObj.Arrow();
	} else {
		grfxObj2.movePoint(x,y);
		grfxObj2.Arrow();
	}
}
/**
 * This method was created in VisualAge.
 */
public java.awt.Graphics print(java.awt.Graphics g) {
	if(taskShown){
		grfxObj.paint(g);
	} else {
		grfxObj2.paint(g);
	}
	return g;
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 1:48:53 PM)
 * @param task system.ATTask
 */
public void resize(ATTask task) {
	if(taskShown){
		grfxObj.resize(task.getGrfx());
		//grfxObj.Arrow();
	} else {
		grfxObj2.resize(task.getGrfx());
		//grfxObj2.Arrow();
	}
}
/**
 * Insert the method's description here.
 * Creation date: (3/28/00 3:01:00 PM)
 */
public void reverse() {
	ATTask hold = currentState;
	currentState = nextState;
	nextState = hold;
	grfxObj.reverse();
	grfxObj2.reverse();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setComponent1(ATTask t) {
	currentState = t;
//	c1name=s.getName();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setComponent2(ATTask t) {
	nextState = t;
}
/**
 * This method was created in VisualAge.
 * @param x1 int
 * @param y1 int
 * @param x2 int
 * @param y2 int
 */
public void setCoordinates() {
	grfxObj.place(currentState.getGrfx(),nextState.getGrfx());
	grfxObj.checkEnds();
	grfxObj.Arrow();
	grfxObj2.place((currentState.getRole()).getGrfx(),(nextState.getRole()).getGrfx());
	grfxObj2.checkEnds();
	grfxObj2.Arrow();
}
/**
 * This method was created in VisualAge.
 * @param x1 int
 * @param y1 int
 * @param x2 int
 * @param y2 int
 */
public void setCoordinates(ATTask first, ATTask second) {
	this.setCurrentState(first);
	this.setNextState(second);
	grfxObj.place(first.getGrfx(),second.getGrfx());
	grfxObj.checkEnds();
	grfxObj.Arrow();
	grfxObj2.place((currentState.getRole()).getGrfx(),(nextState.getRole()).getGrfx());
	grfxObj2.checkEnds();
	grfxObj2.Arrow();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setCurrentState(ATTask s) {
	currentState = s;
}
/**
 * Insert the method's description here.
 * Creation date: (11/7/00 5:07:18 PM)
 * @param ext boolean
 */
public void setExternal(boolean ext) {
	grfxObj.setExternal(ext);
	grfxObj2.setExternal(ext);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setName(String s) {
	name = ATtokenOps.validName(s);
	//set the name of the graphics object
	grfxObj.setText(name);
	grfxObj2.setText(name);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setNextState(ATTask s) {
	nextState = s;
}
/**
 * Insert the method's description here.
 * Creation date: (7/17/00 2:17:09 PM)
 */
public void writeDATA() {
	super.writeDATA();
	MAML+= "\tTask1 = " + currentState.getName() +"\n";
	MAML+= "\tTask2 = " + nextState.getName() +"\n";
}
}
