package system;

/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
 import java.awt.*;
public class ATProtocolGRFX extends Line {
	String text = "";
	final static BasicStroke stroke1 = new BasicStroke(1.0f);
	final static BasicStroke stroke2 = new BasicStroke(3.0f);
	final static BasicStroke stroke3 = new BasicStroke(5.0f);
	
	final static float dash1[] = {8.0f};
	final static BasicStroke dashed = new BasicStroke(1.0f,
		BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, 5.0f,dash1,0.0f);
	
	private boolean external = true;
/**
 * ATtransitionGRFX constructor comment.
 */
public ATProtocolGRFX() {
	super();
}
/**
 * ATtransitionGRFX constructor comment.
 */
public ATProtocolGRFX(ATProtocolGRFX cp) {
	super(cp);
}
/**
 * This method was created in VisualAge.
 */
public void defineEndPt(int a, int b) {

	int f,g,h,i;
	f = (((Circle)second).width)/2+2;
	g = (((Circle)second).height)/2+2;
	h = x(n()-2) - ((Circle)second).center_x;
	i = y(n()-2) - ((Circle)second).center_y;

	double x;
	double y;

	x = f*h*g/(Math.sqrt(h*h*g*g + i*i*f*f));
	y = f*g*i/(Math.sqrt(h*h*g*g + i*i*f*f));
	
	

	this.setPoint(0,(int)(((Circle)first).center_x),(int)(((Circle)first).center_y));

	this.setPoint(n()-1,(int)(((Circle)second).center_x+x),(int)(((Circle)second).center_y+y));

}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void drawError(java.awt.Graphics g) {
	Graphics2D g2 = (Graphics2D)g;
	g2.setColor(Color.yellow);
	g2.setStroke(stroke3);
	if (type() != "loop"){
		for (int i=0; i<n()-1; i++){		//draw the actual line
			g2.drawLine(x(i),y(i),x(i+1),y(i+1));
		}
	} else{
		g.drawArc(x(0)+8,y(0)-25,30/*width*/,50/*height*/,0/*start*/,180);	//draw the arc
	}
	g2.setStroke(stroke1);
}
/**
 * This method was created in VisualAge.
 * @param g Graphics
 */
public void drawLine(Graphics g) {
	Graphics2D g2 = (Graphics2D)g;
	if(first != second){
		if(external) {
			g2.setColor(Color.red);
			g2.setStroke(stroke1);
		} else {
			g2.setColor(Color.blue);
			g2.setStroke(dashed);
		}
		
		for (int i=0; i<n()-1; i++){							//draw the actual line
			g2.drawLine(x(i),y(i),x(i+1),y(i+1));
		}

		
		g2.setColor(Color.black);
		g2.setStroke(stroke1);
		g2.drawLine(x(n()-1),y(n()-1),x1f,y1f);	//draw the two lines going back at an angle
		g2.drawLine(x(n()-1),y(n()-1),x2f,y2f);	//to form the arrow	

		g2.setColor(Color.black);								//set color to black for text
		int mid = n()/2;										//find middle of points on line
		int x = (x(mid-1) + x(mid))/2 - text.length()*3;		//find x and y for where the title
		int y = (y(mid-1) + y(mid))/2 - 3;					//will be placed
		g2.drawString(text,x,y);								//write the title
	}
}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void drawSelected(java.awt.Graphics g) {
	Graphics2D g2 = (Graphics2D)g;
	g2.setColor(Color.orange);
	g2.setStroke(stroke2);
	if (type() != "loop"){
		for (int i=0; i<n()-1; i++){		//draw the actual line
			g2.drawLine(x(i),y(i),x(i+1),y(i+1));
		}
		
		if(external) {
			g2.setColor(Color.red);
			g2.setStroke(stroke1);
		} else {
			g2.setColor(Color.blue);
			g2.setStroke(dashed);
		}
		
		for (int i=0; i<n()-1; i++){							//draw the actual line
			g2.drawLine(x(i),y(i),x(i+1),y(i+1));
		}
		
		g2.setStroke(stroke1);
		g2.setColor(Color.blue);
		for (int i=1; i<n()-1; i++){		//draw the actual line
			g2.drawOval(x(i)-4,y(i)-4,8,8);
		}
		
	} else{
		g2.drawArc(x(0)+8,y(0)-25,30/*width*/,50/*height*/,0/*start*/,180);	//draw the arc
		g2.setColor(Color.red);
		g2.setStroke(stroke1);
		g2.drawArc(x(0)+8,y(0)-25,30/*width*/,50/*height*/,0/*start*/,180);	//draw the arc
		
	//	g2.drawArc(x(0)+7,y(0)-25,32/*width*/,48/*height*/,0/*start*/,180);	//draw the arc
	}
}
/**
 * Insert the method's description here.
 * Creation date: (11/7/00 4:41:54 PM)
 * @return boolean
 */
public boolean external() {
	return external;
}
/**
 * This method was created in VisualAge.
 */
public void getGraphics() {
}
/**
 * Insert the method's description here.
 * Creation date: (10/27/99 10:51:31 AM)
 */
public String getText() {
	return text;
}
/**
 * This method was created in VisualAge.
 */
public void paint(Graphics g) {
	
	g.setColor(Color.red);									//set the color to red
	if(type() == "loop"){
		int x;
		int y;
		if(pos1=='y'){
			if(num1==1){
				g.drawArc(x(0)+8+75,y(0)-25+75,30/*width*/,50/*height*/,0/*start*/,180); //draw the arc

				g.setColor(Color.black);	//set color to black for text
				x = x(0) - text.length();		//find x and y for where the Name
				y = y(0) - height/3;					//will be placed
			} else{
				g.drawArc(x(0)+8+75,y(0)-25+75,30,50,180,180);
				g.setColor(Color.black);
				x = x(0) - text.length();
				y = y(0) + height/2-2;
			}
		} else {
			if(num1 == 1){
				g.drawArc(x(0)-25+75,y(0)-8+75,50,30,90,180);
				g.setColor(Color.black);
				x = x(0)-text.length()*10;
				y = y(0) + 5;
			} else {
				g.drawArc(x(0)-25+75,y(0)-8+75,50,30,270,180);
				g.setColor(Color.black);
				x = x(0)+ 10;
				y = y(0) + 5;
			}
		}
		if(text!=""){
			g.drawString(text,x+75,y+75);								//write the Name
		}
		g.setColor(Color.black);									//set color to black for arrow
		g.drawLine(x(1)+23+75,y(1)+75,x1f+23+75,y1f+75);					//draw the arrow
		g.drawLine(x1f+23+75,y1f+75,x2f+23+75,y2f+75);
		g.drawLine(x2f+23+75,y2f+75,x(1)+23+75,y(1)+75);

	} else {
		for (int i=0; i<n()-1; i++){							//draw the actual line
			g.drawLine(x(i)+75,y(i)+75,x(i+1)+75,y(i+1)+75);
		}
		g.setColor(Color.black);								//set color to black for text
		int mid = n()/2;										//find middle of points on line
		int x = (x(mid-1) + x(mid))/2 - text.length()*3;		//find x and y for where the Name
		int y = (y(mid-1) + y(mid))/2 - 3;					//will be placed
		if(text!=""){
			g.drawString(text,x+75,y+75);						//write the Name
		}

		g.drawLine(x(n()-1)+75,y(n()-1)+75,x1f+75,y1f+75);	//draw the two lines going back at an angle
		g.drawLine(x(n()-1)+75,y(n()-1)+75,x2f+75,y2f+75);	//to form the arrow
/*
		if(y(0)<y(1)){										//decide where the first description
			y=y(0) +13;										//should go.
		} else {
			y=y(0) -3;
		}
		if(x(0)<x(1)){
			x=x(0)+5;
		} else {
			x=x(0)-one.length()*6-2;
		}*/
	//	g.drawString(one,x,y);									//write the first discription
		
	/*	if(y(n()-1)<y(n()-2)){							//calculate where the second discription
			y=y(n()-1)+13;									//should go
		} else {
			y=y(n()-1)-3;
		}
		if(x(n()-1)<x(n()-2)){
			x=x(n()-1)+5;
		}else {
			x=x(n()-1)-two.length()*6-2; 
		}
		g.drawString(two,x,y);									//write the second*/
	}
		
	
}
/**
 * This method was created in VisualAge.
 * @param state system.ATstate
 */
public void place(ATstate state) {
	
}
/**
 * This method was created in VisualAge.
 * @param state system.ATstate
 */
public void placeLoop(Square state) {
	pos1 = 'y';
	num1 = 1;
	state.addLoop(this,1);
	first = state;
	second = state;
	Loop();
}
/**
 * Insert the method's description here.
 * Creation date: (11/7/00 4:42:29 PM)
 * @param ex boolean
 */
public void setExternal(boolean ex) {
	external = ex;	
}
/**
 * This method was created in VisualAge.
 */
public void setText(String s) {
	text = s;
}
}
