package system;

/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
import java.util.*;
public class ATRole2 extends ATobject{

	//name of the role
	private String Sup;
	private ATRole role;
//	private Vector messlages;
	///--graphics objects stuff.

	//actual graphics object
	private ATrole2GRFX grfxObj;
	int y2 = 0;
	//keeps track of whether agent is selected or not 
	public boolean Selected = false;
	private static final String ukh = "role2@";

/**
 * ATagent constructor comment.
 */
public ATRole2(double ver, String[] tokens, ATsystem sys) {
	this(ver,0,1); //*** Version 1 of ATagent ***
	
	int loc = ATtokenOps.findnextinstanceof("version",tokens,0);
	double v=Double.parseDouble(tokens[loc+3]);
	//setVersion(v);
  //Code for constructing object model from MAML tokens
	if (v>=1) constructFromV1(tokens, sys);
	else {
		System.out.println("Loading a version other than 1.");	
	}
 	//	System.out.println("Loaded an agent");
}
	//keeps track of whether an agent's corner is selected
	
/**
 * ATagent constructor comment.
 */
public ATRole2(double v, int keynum, int n) {
	super(v);
	setKey(ukh + keynum);
	MAMLheader+="<!DOCTYPE agent SYSTEM \"atagent"+Double.toString(getVersion())+".dtd\">\n";
	grfxObj = new ATrole2GRFX(n);
//	messages = new Vector();
}
/**
 * ATagent constructor comment.
 */
public ATRole2(double ver, String x, ATsystem sys) {
	this(ver,ATtokenOps.parseLine(x),sys);
}
	//keeps track of whether an agent's corner is selected
	
/**
 * ATagent constructor comment.
 */
public ATRole2(ATRole2 cp) {
	super(cp);
}
/**
 * This method returns the minimum depth a message should be placed at.
 * Creation date: (1/19/01 11:06:49 AM)
 * @return int
 */
public int base() {
	return grfxObj.base();
}
/**
 * Insert the method's description here.
 * Creation date: (7/11/00 4:11:01 PM)
 * @return boolean
 */
public boolean checkLineSelected(int x, int y) {
	return grfxObj.checkLineSelected(x,y);
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public boolean checkSelected(int x, int y) {
	//check to see if object has been selected
	if(grfxObj.dist(x,y)) {
	//	Selected = true;
		return true;
	} else {
	//	Selected = false;
		return false;
	}
}
/**
 * Insert the method's description here.
 * Creation date: (10/25/99 11:28:36 PM)
 */
public void constructFromV1(String[] tokens, ATsystem sys) {
	
	    int end=0;
		boolean keybased = false;
		
		int loc = ATtokenOps.findnextinstanceof("name",tokens,0);
		setName(tokens[12]);
		
		loc = ATtokenOps.findnextinstanceof("roleName",tokens, loc+2);
		String rName = tokens[loc+3];
		
		loc  = ATtokenOps.findnextinstanceof("key", tokens, loc);
		if(loc != -1) {
			setKey(tokens[loc+3]);
			keybased = true;
		} else {
			setKey(ukh + sys.getNextKey());
		}
		
		Enumeration roles = sys.returnRoles();
		ATRole role;
		while(roles.hasMoreElements()){
			role = (ATRole)roles.nextElement();
			if(keybased) {
				if(role.getKey().equals(rName)){
					setRole(role);
				}
			} else {
				if(role.getName().equals(rName)){
					setRole(role);
				}
			}
		}
		
		updateRoleName();
		if(this.role == null) {
			System.out.println("\nWarning! The role <" + rName + "> was not found during load!  This role may have been");
			System.out.println("deleted.  All Sequence Diagrams should be updated to reflect this change.\n");
		}
		
		int start=ATtokenOps.findnextinstanceof("description", tokens, loc+3);
	    loc  = ATtokenOps.findnextinstanceof("/description", tokens, start+2);
		description=ATtokenOps.extract(tokens,(start+2), (loc-2));
		
		//Get agent coordinates for graphics display
		loc  = ATtokenOps.findnextinstanceof("view", tokens, loc+2);
		if (loc>0){ //KB-stored agents do not have view information
					//because they appear at a location the operator selects
			int x = Integer.parseInt(tokens[loc+5]);
			int y = 55;//Integer.parseInt(tokens[loc+11]);
			int h = Integer.parseInt(tokens[loc+17]);
			int w = Integer.parseInt(tokens[loc+23]);
			grfxObj.place(x,y,h,w);
			loc = ATtokenOps.findnextinstanceof("lineLength", tokens,loc+23);
			if(loc>0){
				setLength(Integer.parseInt(tokens[loc+3]));
			}				
		}
//		start   = ATtokenOps.findnextinstanceof("architecture", tokens, end);
		//Need to locate "match" for this architecture, not for possible sub-architectures.
//		end     = findnextinstanceof("/agent", tokens, start);
//		end     = findlastinstanceof("/architecture", tokens, start, end);
//		submaml = extract(tokens, (start-1), (end+1));
}
/**
 * Insert the method's description here.
 * Creation date: (2/5/01 2:40:58 PM)
 */
public void deleteMe() {
	role.removeRole(this);
	grfxObj.deleteMe();
		
	Sup = null;
	role = null;
	grfxObj = null;
}
/**
 * This method was created in VisualAge.
 */
public void draw(java.awt.Graphics g) {
	
	//draw the object
	grfxObj.drawObject(g);
	
	//if the object is selected, draw the selection box
	if(Selected==true){
		grfxObj.drawSelected(g);
	}
	
}
/**
 * Insert the method's description here.
 * Creation date: (6/23/00 11:38:52 AM)
 * @return java.lang.String
 */
public String getFullName() {
	if((name != null)&&(!name.equals("null"))){
		return Sup + " : " + name;
	} else {
		return Sup + " : ";
	}
}
/**
 * This method was created in VisualAge.
 * @return system.ATagentGRFX
 */
public ATrole2GRFX getGrfx() {
	return grfxObj;
}
/**
 * Insert the method's description here.
 * Creation date: (7/11/00 4:17:03 PM)
 * @return int
 */
public int getLength() {
	return grfxObj.getLength();
}
/**
 * Insert the method's description here.
 * Creation date: (4/25/00 2:38:12 PM)
 */
public String getMAML() throws NullPointerException {
	
	//Opening line for a Role element
	MAML = "";
	MAML += "\t<Role2";
	MAML += " version=\"" + Double.toString(version) + "\"";
	MAML += " name=\"" + name + "\">\n";
	MAML += " roleName=\"" + role.getKey() + "\">\n";
	//New Line for Description element
	
	MAML += " key=\"" + getKey() + "\"";
	
	MAML += "\t\t<description>\n\t\t";
	MAML += getDescription();
	MAML += "\n\t\t</description>\n";
	
	int[] c = grfxObj.getCoords();
	MAML += "\t\t<view";
	MAML += " x=\"" + c[0] + "\"";
	MAML += " y=\"" + c[1] + "\"";
	MAML += " w=\"" + c[2] + "\"";
	MAML += " h=\"" + c[3] + "\"/>\n";
	MAML += " lineLength \"" + getLength() + "\"/>\n";
	//Closing line for an Agent element		
	MAML += "\t</Role2>\n";

	return MAML;
}
/**
 * Insert the method's description here.
 * Creation date: (1/19/01 10:59:08 AM)
 * @return java.util.Vector
 */
public Enumeration getMessages() {
	return grfxObj.getMessages();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getName() {
	return name;
}
/**
 * Insert the method's description here.
 * Creation date: (1/17/01 12:48:08 PM)
 * @return system.ATRole
 */
public ATRole getRole() {
	return this.role;
}
/**
 * Insert the method's description here.
 * Creation date: (6/20/00 11:27:47 AM)
 * @return boolean
 */
public boolean hasNoMessages() {
	return grfxObj.hasNoMessages();
}
/**
 * Insert the method's description here.
 * Creation date: (7/11/00 4:22:40 PM)
 * @return int
 */
public int lineEnd() {
	return grfxObj.lineEnd();
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void move(int x, int y) {
	//move the graphics object
	grfxObj.move(x,y);
}
/**
 * Insert the method's description here.
 * Creation date: (6/8/00 3:17:14 PM)
 * @return boolean
 */
public boolean nothingAttached() {
/*	if(grfxObj.lineCount()==0){
		return true;
	}*/
	return false;
}
/**
 * Insert the method's description here.
 * Creation date: (7/11/00 3:13:55 PM)
 * @return int
 */
public int returnMessageCount() {
	return grfxObj.messageCount();
}
	public void setCoordinates(int x, int y, int width, int height) {
	grfxObj.place(x,y,width,height);
}
/**
 * Insert the method's description here.
 * Creation date: (7/11/00 3:17:55 PM)
 * @param l int
 */
public void setLength(int l) {
	grfxObj.setLength(l);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setName(String s) {
	name = ATtokenOps.validName(s);
	if(name == null || name.equals("null")){
		name = "";
	}
	
	//set the name of the graphics object
	grfxObj.setName(Sup + " : " + name);
	//resize the graphics object accordingly
	grfxObj.resetMax();
}
/**
 * Insert the method's description here.
 * Creation date: (6/16/00 1:02:28 PM)
 * @param role system.ATRole
 */
public void setRole(ATRole role) {
	if(role != null) role.removeRole(this);	// remove reference to this from the old role
	this.role = role;
	role.addRole(this);		// set reference to this in the the new role
	
	if(role!=null) updateRoleName();
		
}
/**
 * Insert the method's description here.
 * Creation date: (1/19/01 11:12:31 AM)
 * @return int
 */
public int tip() {
	return grfxObj.tip();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void updateRoleName() {
	if(role != null) {
		Sup = role.getName();
		setName(name);
		grfxObj.resetMax();
	} 
}
}
