package system;

/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
import java.util.*;
public class ATagent extends ATobject {

	//agent's architecture
	ATarchitecture architecture;
	private Vector roles = null;
	private Vector cases = null;
	///--graphics objects stuff.

	//actual graphics object
	private ATagentGRFX grfxObj;
	//keeps track of whether agent is selected or not 
	public boolean Selected = false;
	private static final String ukh = "agent@";
/**
 * ATagent constructor comment.
 */
public ATagent(double ver, String[] tokens, ATsystem sys) {
	this(ver,0); //*** Version 1 of ATagent ***
	
  	int loc = ATtokenOps.findnextinstanceof("version",tokens,0);
  	double v=Double.parseDouble(tokens[loc+3]);
	//this.setVersion(v);
	
	roles = new Vector();
	//architecture = new ATarchitecture(v,);
	
  //Code for constructing object model from MAML tokens
	if (v>=1) constructFromV1(tokens, sys, v);
	else {
		System.out.println("Loading a version other than 1.");	
	}
 	//	System.out.println("Loaded an agent");
}
	//keeps track of whether an agent's corner is selected
	
/**
 * ATagent constructor comment.
 */
public ATagent(double v, int keynum) {
	super(v);
	MAMLheader+="<!DOCTYPE agent SYSTEM \"atagent"+Double.toString(getVersion())+".dtd\">\n";
	setKey(ukh + keynum);
	
	grfxObj = new ATagentGRFX();
	architecture = new ATarchitecture(v,keynum);
	roles = new Vector();
	cases = new Vector();
}
/**
 * ATagent constructor comment.
 */
public ATagent(double ver, String x, ATsystem sys) {
	this(ver,ATtokenOps.parseLine(x),sys);
}
	//keeps track of whether an agent's corner is selected
	
/**
 * ATagent constructor comment.
 */
public ATagent(ATagent cp) {
	super(cp);
	
}
/**
 * Insert the method's description here.
 * Creation date: (6/2/00 10:30:26 AM)
 * @param role afit.system.ATRole
 */
public void addCase(ATagent2 agent) {
	cases.addElement(agent);
}
public void addComponent(ATagentComponent c) {
	//add component c to the architecture
	architecture.addComponent(c);
}
public void addConnection(ATconnection c) {
	//add connection c to the architecture
	architecture.addConnection(c);
}
/**
 * Insert the method's description here.
 * Creation date: (6/2/00 10:30:26 AM)
 * @param role afit.system.ATRole
 */
public void addRole(ATRole role) {
	roles.addElement(role);
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public boolean checkSelected(int x, int y) {
	//check to see if object has been selected
	if(grfxObj.dist(x,y)) {
		return true;
	} else {
		return false;
	}
}
/**
 * Insert the method's description here.
 * Creation date: (10/25/99 11:28:36 PM)
 */
public void constructFromV1(String[] tokens, ATsystem sys, double v) {
	
	    int end=0;

		boolean keybased = false;
		
//		System.out.println("\ncheck location " + loc);
//		System.out.println("\nTokens |" + tokens[loc] + "|" + tokens[loc+1] + "|" + tokens[loc+2] + "|" + tokens[loc+3] + "|" + tokens[loc+4] + "|" + tokens[loc+5] + "|" + tokens[loc+6] + "|");

		int loc = ATtokenOps.findnextinstanceof("name",tokens,0);
  		setName(tokens[loc+3]);
		
		loc  = ATtokenOps.findnextinstanceof("key", tokens, loc);
		if(loc != -1) {
			setKey(tokens[loc+3]);
			keybased = true;
		} else {
			setKey(ukh + sys.getNextKey());
		}	

		int start=ATtokenOps.findnextinstanceof("description", tokens, loc+3);
		loc  = ATtokenOps.findnextinstanceof("/description", tokens, start+2);
		description=ATtokenOps.extract(tokens,(start+2), (loc-2));

		
		//Get agent coordinates for graphics display
		loc  = ATtokenOps.findnextinstanceof("view", tokens, loc+2);
		
		if (loc>0){ //KB-stored agents do not have view information
					//because they appear at a location the operator selects
			int x = Integer.parseInt(tokens[loc+5]);
			int y = Integer.parseInt(tokens[loc+11]);
			int h = Integer.parseInt(tokens[loc+17]);
			int w = Integer.parseInt(tokens[loc+23]);
			loc+=25;
			setCoordinates(x,y,h,w);
		}

		start   = ATtokenOps.findnextinstanceof("architecture", tokens, end);
		//Need to locate "match" for this architecture, not for possible sub-architectures.
		end     = ATtokenOps.findnextinstanceof("/agent", tokens, start);
		end     = ATtokenOps.findlastinstanceof("/architecture", tokens, start, end);

		
		String[] submaml = ATtokenOps.subTokens(tokens, (start-1), (end+1));
		ATarchitecture a = new ATarchitecture(version,submaml, sys);
		setArchitecture(a);
		
		if(sys!=null){
			loc  = ATtokenOps.findnextinstanceof("Roles", tokens, end);
			if(loc != -1){
				int rCount = Integer.parseInt(tokens[loc+8]);
				loc+=10;
				ATRole role;
				for(int i = 0; i<rCount; i++){
					String rName = tokens[loc];
					loc+=3;
					Enumeration mainRo = sys.returnRoles();
					while(mainRo.hasMoreElements()){
						role = (ATRole)mainRo.nextElement();
						if(keybased) {
							if((role.getKey()).equals(rName)){
								addRole(role);
								role.addAgent(this);
							}
						} else {
							if((role.getName()).equals(rName)){
								addRole(role);
								role.addAgent(this);
							}
						}
					}
				}
			}
			setRoles(roles);
		}
}
public int conversationCount() {
	//return the number of conversations connected to this agent
	return grfxObj.lineCount();
}
/**
 * Insert the method's description here.
 * Creation date: (7/5/00 9:38:04 AM)
 * @param agent afit.system.ATagent2
 */
public void deleteInstance(ATagent2 agent) {
	cases.remove(agent);
	}
/**
 * Insert the method's description here.
 * Creation date: (7/5/00 9:38:04 AM)
 * @param agent afit.system.ATagent2
 */
public void deleteRole(ATRole role) {
	roles.remove(role);
	}
/**
 * This method was created in VisualAge.
 */
public void draw(java.awt.Graphics g) {
	//draw the object
	grfxObj.drawObject(g);
	//if the object is selected, draw the selection box
	if(Selected==true){
		grfxObj.drawSelected(g);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (12/7/99 10:17:22 PM)
 * @return system.ATarch
 */
public ATarchitecture getArchitecture() {
	return architecture;
}
/**
 * Insert the method's description here.
 * Creation date: (7/6/00 2:45:24 PM)
 * @return java.util.Vector
 */
public Vector getCases() {
	return cases;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public int getComponentCount() {
	//return number of components in architecture
	return architecture.getComponentCount();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public int getConnectionCount() {
	//return number of connections in architecture
	return architecture.getConnectionCount();
}
/**
 * This method was created in VisualAge.
 * @return system.ATagentGRFX
 */
public ATagentGRFX getGrfx() {
	return grfxObj;
}
/**
 * Insert the method's description here.
 * Creation date: (10/20/99 1:16:45 PM)
 */
public String getMAML() throws Exception {

	//Opening line for an Agent element
	MAML = "";
	MAML += "\t<agent";
	MAML += " version=\"" + Double.toString(version) + "\"";
	MAML += " name=\"" + name + "\"";
	MAML += " key=\"" + getKey() + "\">\n";
	
	//New Line for Description element
	MAML += "\t\t<description>\n\t\t";
	MAML += getDescription();
	MAML += "\n\t\t</description>\n";
	int[] c = grfxObj.getCoords();
	MAML += "\t\t<view";
	MAML += " x=\"" + c[0] + "\"";
	MAML += " y=\"" + c[1] + "\"";
	MAML += " w=\"" + c[2] + "\"";
	MAML += " h=\"" + c[3] + "\"/>\n";
	MAML += architecture.getMAML();
	Enumeration Roles = roles.elements();
	ATRole role;
	MAML += "\t\t\t<Roles>\n\t\t\t";
	MAML += "\"Num Roles\" = " + roles.size();
	
	while(Roles.hasMoreElements()){
		role = (ATRole)Roles.nextElement();
		//MAML+= "\"" + role.getName() + "\"";
		MAML+= "\"" + role.getKey() + "\"";
	}
		
	//Closing line for an Agent element	
		
	MAML+="\t\t\t</agent>\n";

	return MAML;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getName() {
	return name;
}
/**
 * Insert the method's description here.
 * Creation date: (5/18/00 2:05:13 PM)
 * @return java.util.Enumeration
 */
public Vector getRoles() {
	return roles;
}
public int instanceCount() {
	//return the number of conversations connected to this agent
	return cases.size();
}
/**
 * Insert the method's description here.
 * Creation date: (10/28/99 10:31:27 AM)
 */
public void integrateKBInfo(String maml, ATsystem sys) {
  String[] tokens = ATtokenOps.parseLine(maml);
  int v=Integer.parseInt(tokens[6]);
	
  //Code for constructing object model from MAML tokens
  if (v==version) {
	constructFromV1(tokens, sys, v);
  }
  else {
	System.out.println("Loading from KB a version other than 1");	
  }	
}
/**
 * Insert the method's description here.
 * Creation date: (6/29/00 3:32:45 PM)
 * @return boolean
 * @param agent system.ATagent2
 */
public boolean isConnectedTo(ATagent agent, ATconversation c) {
	ATconvGRFX cGRFX = null;
	if(c!=null){
		cGRFX = c.getGrfx();
	}
	if(grfxObj.connectedTo(agent.getGrfx(),cGRFX)){
		return true;
	} 
	return false;
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void move(int x, int y) {
	//move the graphics object
	grfxObj.move(x,y);
}
/**
 * This method was created in VisualAge.
 */
public void print(java.awt.Graphics g) {
	grfxObj.paint(g);
}
public void removeComponent(ATagentComponent c) {
	//remove c from the architecture
	architecture.removeComponent(c);
}
public void removeConnection(ATconnection c) {
	//remove connection c from the architecture
	architecture.removeConnection(c);
}
/**
 * Insert the method's description here.
 * Creation date: (11/29/00 12:06:03 PM)
 * @return boolean
 * @param n java.lang.String
 */
public boolean repeatName(String n) {
	return architecture.repeatName(n);
}
/**
 * Insert the method's description here.
 * Creation date: (6/30/00 3:10:14 PM)
 */
public void resetRoleNames() {
	Vector hold = new Vector();
	Enumeration enum = roles.elements();
	ATRole role;
	while(enum.hasMoreElements()){
		role = (ATRole)enum.nextElement();
		hold.add((String)role.getName());
	}
	grfxObj.setRoles(hold);
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void resize(int x, int y) {
	//resize the graphics object
	grfxObj.resize(x,y);
}
public java.util.Enumeration returnComponents() {
	return architecture.returnComponents();
}
public java.util.Enumeration returnConnections() {
	return architecture.returnConnections();
}
/**
 * Insert the method's description here.
 * Creation date: (12/7/99 12:10:08 PM)
 */
public void setArchitecture(ATarchitecture a) {
  	architecture = a;	
}
/**
 * This method was created in VisualAge.
 */
public void setCoordinates(int x, int y, int width, int height) {
	grfxObj.place(x,y,width,height);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setName(String s) {
	name = ATtokenOps.validName(s);
	//set the name of the graphics object
	grfxObj.setName(name);
	//resize the graphics object accordingly
	grfxObj.resetMax();
	Enumeration c = cases.elements();
	ATagent2 agent;
	while(c.hasMoreElements()){
		agent = (ATagent2)c.nextElement();
		agent.renameAgent();
	}
}
/**
 * Insert the method's description here.
 * Creation date: (5/18/00 2:05:13 PM)
 * @return java.util.Enumeration
 */
public void setRoles(Vector r) {
	roles = r;
	Vector hold = new Vector();
	Enumeration enum = roles.elements();
	ATRole role;
	while(enum.hasMoreElements()){
		role = (ATRole)enum.nextElement();
		hold.add((String)role.getName());
	}
	grfxObj.setRoles(hold);
}
/**
 * Insert the method's description here.
 * Creation date: (7/17/00 2:17:09 PM)
 */
public void writeDATA(Vector conversations) {
	super.writeDATA();
	MAML+= "\n\tConnected to:\n";
	Enumeration convs = conversations.elements();
	ATconversation conv;
	while(convs.hasMoreElements()){
		conv = (ATconversation)convs.nextElement();
		if(conv.getInitiator() == this){
			MAML+= "\t"+ conv.getResponder().getName() + "\tvia " + conv.getName() +"\n";
		} else if(conv.getResponder() == this){
			MAML+= "\t"+ conv.getInitiator().getName() + "\tvia " + conv.getName() +"\n";
		}
	}
	MAML+= "\n\tRoles:\n";
	Enumeration roles = getRoles().elements();
	ATRole role;
	while(roles.hasMoreElements()){
		role = (ATRole)roles.nextElement();
		MAML+= "\t" + role.getName() + "\n";
	}
}
}
