package system;

/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
import java.util.*;
public class ATagent2 extends ATobject {

	private ATagent agent;
	
	///--graphics objects stuff.

	//actual graphics object
	private ATagent2GRFX grfxObj;
	//keeps track of whether agent is selected or not 
	public boolean Selected = false;
	private static final String ukh = "agent2@";
/**
 * ATagent constructor comment.
 */
public ATagent2(double ver, String[] tokens, ATsystem sys) {
	this(ver,0,0); //*** Version 1 of ATagent ***
	
	int loc = ATtokenOps.findnextinstanceof("version",tokens,0);
  	double v=Double.parseDouble(tokens[loc+3]);

	//setVersion(v);
//	roles = new Vector();
  //Code for constructing object model from MAML tokens
	if (v>=1) constructFromV1(tokens, sys, v);
	else {
		System.out.println("Loading a version other than 1.");	
	}
 	//	System.out.println("Loaded an agent");
}
	//keeps track of whether an agent's corner is selected
	
/**
 * ATagent constructor comment.
 */
public ATagent2(double v, int keynum, int n) {
	super(v);
	MAMLheader+="<!DOCTYPE agent SYSTEM \"atagent"+Double.toString(getVersion())+".dtd\">\n";
	setKey(ukh + keynum);
	
	grfxObj = new ATagent2GRFX();
	setName(null);
	setCoordinates(50 + (n % 5)* 150,50 + (n / 5)* 75,100,50);
}
/**
 * ATagent constructor comment.
 */
public ATagent2(double ver, String x, ATsystem sys) {
	this(ver,ATtokenOps.parseLine(x),sys);
}
	//keeps track of whether an agent's corner is selected
	
/**
 * ATagent constructor comment.
 */
public ATagent2(ATagent2 cp) {
	super(cp);
}
/**
 * Insert the method's description here.
 * Creation date: (2/12/01 1:20:03 PM)
 * @return boolean
 * @param container system.ATsys
 */
public boolean checkContained(ATsys container) {
	Square box = container.getGrfx();

	return (box.x1() <= grfxObj.x1() && box.x2() >= grfxObj.x2() &&
		box.y1() <= grfxObj.y1() && box.y2() >= grfxObj.y2());

	//return true;
	//return false;
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public boolean checkSelected(int x, int y) {
	//check to see if object has been selected
	if(grfxObj.dist(x,y)) {
		return true;
	} else {
		return false;
	}
}
/**
 * Insert the method's description here.
 * Creation date: (10/25/99 11:28:36 PM)
 */
public void constructFromV1(String[] tokens, ATsystem sys, double v) {
	
	int loc = ATtokenOps.findnextinstanceof("name",tokens,0);
  	int end=0;
	setName(tokens[loc+3]);
	loc = ATtokenOps.findnextinstanceof("aName",tokens,0);
	String agentN = tokens[loc+3];
	
	boolean keybased = false;
	
	loc  = ATtokenOps.findnextinstanceof("key", tokens, loc);
	if(loc != -1) {
		setKey(tokens[loc+3]);
		keybased = true;
	} else {
		setKey(ukh + sys.getNextKey());
	}
	
	Enumeration agents = sys.returnAgents();
	ATagent a,m = null;
	while(agents.hasMoreElements()){
		a = (ATagent)agents.nextElement();
		if(keybased) {
			if(a.getKey().equals(agentN)){
				m = a;
			}
		} else {
			if(a.getName().equals(agentN)){
				m = a;
			}
		}
	}
	if(m == null) {
		System.out.println("Error!!!  Agent " + agentN + " not found.");
	} else {
		setAgent(m);
	}
		
	int start=ATtokenOps.findnextinstanceof("description", tokens, loc+3);
	loc  = ATtokenOps.findnextinstanceof("/description", tokens, start+2);
	description=ATtokenOps.extract(tokens,(start+2), (loc-2));
	//Get agent coordinates for graphics display
	loc  = ATtokenOps.findnextinstanceof("view", tokens, loc+2);
	if (loc>0){ //KB-stored agents do not have view information
				//because they appear at a location the operator selects
		int x = Integer.parseInt(tokens[loc+5]);
		int y = Integer.parseInt(tokens[loc+11]);
		int h = Integer.parseInt(tokens[loc+17]);
		int w = Integer.parseInt(tokens[loc+23]);
		loc+=25;
		setCoordinates(x,y,h,w);
	}
}
public int conversationCount() {
	//return the number of conversations connected to this agent
	return grfxObj.lineCount();
}
/**
 * Insert the method's description here.
 * Creation date: (7/5/00 9:37:32 AM)
 */
public void deleteMe() {
	agent.deleteInstance(this);}
/**
 * This method was created in VisualAge.
 */
public void draw(java.awt.Graphics g) {
	//draw the object
	grfxObj.drawObject(g);
	//if the object is selected, draw the selection box
	if(Selected==true){
		grfxObj.drawSelected(g);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (6/29/00 4:01:01 PM)
 * @return system.ATagent
 */
public ATagent getAgent() {
	return agent;
}
/**
 * Insert the method's description here.
 * Creation date: (7/14/00 10:07:00 AM)
 * @return int
 */
public int getCenterX() {
	return grfxObj.center_x;
}
/**
 * Insert the method's description here.
 * Creation date: (7/14/00 10:07:00 AM)
 * @return int
 */
public int getCenterY() {
	return grfxObj.center_y;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getFname() {
	return grfxObj.getFname();
}
/**
 * This method was created in VisualAge.
 * @return system.ATagentGRFX
 */
public ATagent2GRFX getGrfx() {
	return grfxObj;
}
/**
 * Insert the method's description here.
 * Creation date: (10/20/99 1:16:45 PM)
 */
public String getMAML() throws Exception {

	//Opening line for an Agent element
	MAML = "";
	MAML += "\t<agent2";
	MAML += " version=\"" + Double.toString(version) + "\"";
	MAML += " name=\"" + name + "\">\n";
	//MAML += " aName=\"" + agent.getName() + "\"";
	MAML += " aName=\"" + agent.getKey() + "\"";
	//MAML += " name=\"" + name + "\">\n";
	//New Line for Description element
	MAML += " key=\"" + getKey() + "\"";
	MAML += "\t\t<description>\n\t\t";
	MAML += getDescription();
	MAML += "\n\t\t</description>\n";
	int[] c = grfxObj.getCoords();
	MAML += "\t\t<view";
	MAML += " x=\"" + c[0] + "\"";
	MAML += " y=\"" + c[1] + "\"";
	MAML += " w=\"" + c[2] + "\"";
	MAML += " h=\"" + c[3] + "\"/>\n";

//	architecture.encodeMAML();
//	MAML += architecture.getMAML();
/*	Enumeration Roles = roles.elements();
	ATRole role;
	MAML += "\t\t\t<Roles>\n\t\t\t";
	MAML += "\"Num Roles\" = " + roles.size();
	while(Roles.hasMoreElements()){
		role = (ATRole)Roles.nextElement();
		MAML+= "\"" + role.getName() + "\"";
	}
		*/
	//Closing line for an Agent element		
	MAML += "\t</agent2>\n";
	
	return MAML;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getName() {
	return name;
}
/**
 * Insert the method's description here.
 * Creation date: (10/28/99 10:31:27 AM)
 */
public void integrateKBInfo(String maml, ATsystem sys) {
  String[] tokens = ATtokenOps.parseLine(maml);
  int v=Integer.parseInt(tokens[6]);
	
  //Code for constructing object model from MAML tokens
  if (v==version) {
	constructFromV1(tokens, sys, v);
  }
  else {
	System.out.println("Loading from KB a version other than 1");	
  }	
}
/**
 * Insert the method's description here.
 * Creation date: (6/29/00 3:32:45 PM)
 * @return boolean
 * @param agent system.ATagent2
 */
public boolean isConnectedTo(ATagent2 agent) {
	Line l = null;
	if(grfxObj.connectedTo(agent.getGrfx(),l)){
		return true;
	} 
	return false;
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void move(int x, int y, int mode) {
	//move the graphics object
	grfxObj.move(x,y,mode);
}
/**
 * This method was created in VisualAge.
 */
public void print(java.awt.Graphics g) {
	grfxObj.paint(g);
}
/**
 * Insert the method's description here.
 * Creation date: (6/29/00 9:51:33 AM)
 * @param a system.ATagent
 */
public void renameAgent() {
	grfxObj.setAName(agent.getName());
	grfxObj.resetMax();
}
/**
 * Insert the method's description here.
 * Creation date: (6/29/00 9:51:33 AM)
 * @param a system.ATagent
 */
public void setAgent(ATagent a) {
	agent = a;

	grfxObj.setAName(a.getName());
	agent.addCase(this);
}
/**
 * This method was created in VisualAge.
 */
public void setCoordinates(int x, int y, int width, int height) {
	grfxObj.place(x,y,width,height);
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 3:43:43 PM)
 * @param n java.lang.String
 */
public void setName(String n) {
	n = ATtokenOps.validName(n);
	if(n == null || n.equals("")) {
		name = "*(" + Editor.SelectAgent.UNNAMED + ")*";
	//} else if(n.indexOf(Editor.SelectAgent.UNNAMED) != -1) {
	//	name = "*(" + n + ")*";
	} else {
		name = n;
	}
	grfxObj.setName(name);
}
/**
 * Insert the method's description here.
 * Creation date: (7/17/00 2:17:09 PM)
 */
public void writeDATA(Vector conversations) {
	super.writeDATA();
	MAML+= "\tAgent = " + agent.getName() + "\n";
	MAML+= "\n\tConnected to:\n";
	Enumeration convs = conversations.elements();
	ATconversation2 conv;
	while(convs.hasMoreElements()){
		conv = (ATconversation2)convs.nextElement();
		if(conv.getInitiator() == this){
			MAML+= "\t"+ conv.getResponder().getFname()+"\n";
		} else if(conv.getResponder() == this){
			MAML+= "\t"+ conv.getInitiator().getFname()+"\n";
		}
	}
}
}
