package system;

/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
//___________________________________________________
// Class to represent a line
//___________________________________________________
import java.io.*;
import java.util.Vector;
import java.awt.*;
class ATagentComponentGRFX extends Square {

	//Labels for square
	String name = "";
	Vector attributes = new Vector();
	Vector methods = new Vector();
	private int Max=60;
	private int x, y; //---the corner that is selected (1,1), (1,2), (2,1), (2,2) ...(x,y)
	int center, textHeight, tempY;
	String attrName;
/**
 * This method was created in VisualAge.
 */
public ATagentComponentGRFX() {
	super();
}
/**
 * This method was created in VisualAge.
 */
public ATagentComponentGRFX(ATagentComponentGRFX cp) {
	super(cp);
}
public void drawObject(java.awt.Graphics g)
{
	Font f = g.getFont();
	//FontMetrics fm = Toolkit.getDefaultToolkit().getFontMetrics(f);
	FontMetrics fm = g.getFontMetrics(); // SAD Change - deprecated fix???
	String s = name;
	attrName = "";
	String methodName = "";
	int size = 0;
	int ascent = fm.getAscent();
	textHeight = fm.getHeight();
	int textWidth = fm.stringWidth(s);
	int tempY2 = 0;
	tempY = 0;
	ATagentComponentAttribute anAttribute;
	ATagentComponentMethod aMethod;
	g.setColor(new Color(150, 150, 255));


	//size the component width based on max attribute value
	width = Max;
	x2 = x1 + Max;

	//size the component height based on the number of attributes and methods
	if (attributes.size() == 0 || attributes.size() == 1)
		tempY = 1;
	else
		tempY = attributes.size();
	if (methods.size() == 0 || methods.size() == 1)
		tempY2 = 1;
	else
		tempY2 = methods.size();
	height = textHeight * (tempY + tempY2 + 1) + 5;
	y2 = y1 + (textHeight * (tempY + tempY2 + 1) + 5);


	//see if rectangle needs to be enlarged for component name
	if ((textWidth) > (Max))
	{
		Max = textWidth + 5;
		width = Max;
		x2 = x1 + Max;
	}
	for (x = 0; x < attributes.size(); x++)
	{
		anAttribute = (ATagentComponentAttribute) attributes.elementAt(x);
		attrName = anAttribute.getAttrView();
		size = fm.stringWidth(attrName);
		if ((size) > (width))
		{
			Max = size + 5;
			width = Max;
			x2 = x1 + Max;
		}
	}
	for (x = 0; x < methods.size(); x++)
	{
		aMethod = (ATagentComponentMethod) methods.elementAt(x);
		methodName = aMethod.getMethodView();
		size = fm.stringWidth(methodName);
		if ((size) > (width))
		{
			Max = size + 5;
			width = Max;
			x2 = x1 + Max;
		}
	}
	center = x1 + (width - textWidth) / 2;
	
	//draw rectangle
	g.fillRect(x1, y1, width, height); //white background for rect.
	g.setColor(Color.black);
	g.drawRect(x1, y1, width, height);
	
	//draw lines after component name
	g.drawLine(x1, y1 + textHeight + 3, x2, y1 + textHeight + 3);


	//draw component name text in rectangle
	g.drawString(s, center, y1 + 13);


	//display all attributes in the component box


	for (x = 0; x < attributes.size(); x++)
	{
		anAttribute = (ATagentComponentAttribute) attributes.elementAt(x);
		attrName = anAttribute.getAttrView();
		g.drawString(attrName, x1 + 2, y1 + (2 + x) * textHeight);
	/*	size = fm.stringWidth(attrName);
		if ((size) > (width))
		{
			Max = size + 5;
			width = Max;
			x2 = x1 + Max;
		}*/
	}

	//draw line after last attribute
	g.drawLine(x1, y1 + textHeight * (tempY + 1) + 2, x2, y1 + textHeight * (tempY + 1) + 2);

	//display all methods in the component box
	for (x = 0; x < methods.size(); x++)
	{
		aMethod = (ATagentComponentMethod) methods.elementAt(x);
		methodName = aMethod.getMethodView();
		g.drawString(methodName, x1 + 2, y1 + (2 + tempY + x) * textHeight);
	/*	size = fm.stringWidth(methodName);
		if ((size) > (width))
		{
			Max = size + 5;
			width = Max;
			x2 = x1 + Max;
		}*/
	}
}
public void drawSelected(java.awt.Graphics g) {
	//set color to orange
	g.setColor(Color.orange);
	//draw two rectangles-
	//one just inside the perimeter of the component,
	//and one just outside the perimeter
	g.drawLine(x1-1, y1-1, x2+1, y1-1);   
	g.drawLine(x2+1, y1-1, x2+1, y2+1);
	g.drawLine(x2+1, y2+1, x1-1, y2+1);
	g.drawLine(x1-1, y2+1, x1-1, y1-1);
	g.drawLine(x1+1, y1+1, x2-1, y1+1);   
	g.drawLine(x2-1, y1+1, x2-1, y2-1);
	g.drawLine(x2-1, y2-1, x1+1, y2-1);
	g.drawLine(x1+1, y2-1, x1+1, y1+1);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getAttr() {
	return name;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getName() {
	return name;
}
public void paint(java.awt.Graphics g)
{

	ATagentComponentAttribute anAttribute;
	ATagentComponentMethod aMethod;
	String methodName;
	
	//size the component width based on max attribute value
	width = Max;
	x2 = x1 + Max;

	//draw the perimeter of the component
	g.setColor(Color.black);
	g.drawRect(x1+75, y1+75, width, height);
	
	//draw lines after component name
	g.drawLine(x1+75, y1 + textHeight + 3+75, x2+75, y1 + textHeight + 3+75);


	//draw component name text in rectangle
	g.drawString(name, center+75, y1 + 13+75);


	//display all attributes in the component box
	for (x = 0; x < attributes.size(); x++)
	{
		anAttribute = (ATagentComponentAttribute) attributes.elementAt(x);
		attrName = anAttribute.getAttrView();
		g.drawString(attrName, x1 + 2+75, y1 + (2 + x) * textHeight+75);
	}

	//draw line after last attribute
	g.drawLine(x1+75, y1 + textHeight * (tempY + 1) + 2+75, x2+75, y1 + textHeight * (tempY + 1) + 2 +75);

	//display all methods in the component box
	for (x = 0; x < methods.size(); x++)
	{
		aMethod = (ATagentComponentMethod) methods.elementAt(x);
		methodName = aMethod.getMethodView();
		g.drawString(methodName, x1 + 2+75, y1 + (2 + tempY + x) * textHeight+75);
	}
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void resetMax() {
	Max=60;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setAttr(Vector attrs)
{
	attributes = attrs;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setMethods(Vector meth)
{
	methods = meth;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setName(String s) {
	name = s;
}
}
