package system;

/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
public class ATagentComponentMethod  extends ATobject {
	private String returnType="";
	private String pre;
	private String post;
	private String params="";
	private boolean visible;
	private String methodView;
	private static final String ukh = "compmethod@";
/**
 * ATagentComponentAttribute constructor comment.
 */
public ATagentComponentMethod(String[] tokens, ATsystem sys){
	this(0);
	int loc = ATtokenOps.findnextinstanceof("name",tokens,0);
  	setName(tokens[loc+3]);
	
  	loc  = ATtokenOps.findnextinstanceof("key", tokens, 0);
	if(loc != -1) {
		setKey(tokens[loc+3]);
	} else {
		setKey(ukh + sys.getNextKey());
	}

	loc  = ATtokenOps.findnextinstanceof("returntype", tokens, loc) + 3;
	returnType = (tokens[loc].equals("\"") ? "" : tokens[loc]);
	
	loc  = ATtokenOps.findnextinstanceof("parameters", tokens, loc) + 3;
	params = (tokens[loc].equals("\"") ? "" : tokens[loc]);
	
	loc  = ATtokenOps.findnextinstanceof("pre", tokens, loc) + 3;
	pre = (tokens[loc].equals("\"") ? "" : tokens[loc]);
	
	loc  = ATtokenOps.findnextinstanceof("post", tokens, loc) + 3;
	post = (tokens[loc].equals("\"") ? "" : tokens[loc]);
	
	loc  = ATtokenOps.findnextinstanceof("visible", tokens, loc) + 3;
	if (tokens[loc].equals("true")) setVisible(true);
		else setVisible(false);	
	
	setMethodView();		
}
/**
 * ATagentComponentAttribute constructor comment.
 */
public ATagentComponentMethod(int keynum){
	super(1);
	setKey(ukh + keynum);
}
/**
 * ATagentComponentAttribute constructor comment.
 */
public ATagentComponentMethod(String maml, ATsystem sys){
	this(ATtokenOps.parseLine(maml),sys);
}
/**
 * ATagentComponentAttribute constructor comment.
 */
public ATagentComponentMethod(ATagentComponentMethod cp){
	super(cp);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getMAML() throws Exception {
	MAML="";
	MAML+="\t\t\t\t<method";
	MAML+=" name=\"" + name + "\"";
	MAML += " key=\"" + getKey() + "\"";
	MAML+=" returntype=\"" + returnType + "\"";
	MAML+=" parameters=\""+params+"\"";	
	MAML+=" pre=\""+pre+"\"";
	MAML+=" post=\""+post+"\"";
	MAML+=" visible=\""+((visible)? "true" : "false")+"\"/>\n";
	
	return MAML;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getMethodView()
{
	return methodView;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getName()
{
	return name;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getParams()
{
	return params;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getPost()
{
	return post;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getPre()
{
	return pre;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getReturnType()
{
	return returnType;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public boolean getVisible()
{
	return visible;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setMethodView()
{
	methodView = name + "(" + params + ")";
	if (!(returnType.equals("")))
		methodView = methodView + ":" + returnType;
	if (visible == false)
		methodView = "#" + methodView;
	else
		methodView = " " + methodView;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setName(String n)
{
	name = ATtokenOps.validName(n);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setParams(String p)
{
	params = p;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setPost(String p)
{
	post = p;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setPre(String p)
{
	pre = p;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setReturnType(String r)
{
	returnType = r;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setVisible(boolean v)
{
	visible = v;
}
}
