package system;

/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
//___________________________________________________
// Class to represent a line
//___________________________________________________
import java.io.*;
import java.util.*;
import java.awt.*;

class ATagentGRFX extends Square {
	
	//Labels for square
	String name = "";
	int x,y; //---the corner that is selected (1,1), (1,2), (2,1), (2,2) ...(x,y)
	int Max = 60, MaxH = 60;
	int center;
	Vector roles;
/**
 * This method was created in VisualAge.
 */
public ATagentGRFX() {
	super();
	roles = new Vector();
}
/**
 * This method was created in VisualAge.
 */
public ATagentGRFX(ATagentGRFX cp) {
	super(cp);
}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void drawObject(java.awt.Graphics g) {
	String s = name;
	Font f = g.getFont();
	//FontMetrics fm = Toolkit.getDefaultToolkit().getFontMetrics(f);
	FontMetrics fm = g.getFontMetrics(); // SAD Change - deprecated fix???
	int textWidth = fm.stringWidth(s);
	int textHeight = fm.getHeight();
//	center = x1 + (width - textWidth)/2;//(x1+x2)/2- s.length()*3;

	height = MaxH;
	width = Max;
	x2 = x1 + Max;
	if((textWidth) > (Max)){
		Max = textWidth + 5;
		width = Max;
		x2 = x1 + Max;
	}
	Enumeration r = roles.elements();
	String role;
	while(r.hasMoreElements()){
		role = (String)r.nextElement();
		textWidth = fm.stringWidth(role);
		if(textWidth > Max){
			Max = textWidth + 5;
			width = Max;
			x2 = x1 + Max;
		}
	}
	int num = roles.size();
	int h = (num+1)*textHeight +3;
	if(h>MaxH){
		MaxH = h;
		height = h;
		y2 = y1 + h;
	}
	y2 = y1 + height;
	g.setColor(new java.awt.Color(247,250,255));
	g.fillRect( x1, y1,  width,  height);	//white background for rect.
	g.setColor(new java.awt.Color(40,38,217));//new java.awt.Color(0,0,75));
		
	//draw rectangle
	g.drawLine( x1,  y1,  x2,  y1);   
	g.drawLine( x2,  y1,  x2,  y2);
	g.drawLine( x2,  y2,  x1,  y2);
	g.drawLine( x1,  y2,  x1,  y1);
//	int h =  height/3;
	g.drawLine(x1, y1 + textHeight + 3, x2, y1+textHeight+3);

	textWidth = fm.stringWidth(s);
	center = x1 + (width - textWidth)/2;//(x1+x2)/2- s.length()*3;

	//draw text in rectangle
	g.setColor(Color.black);
	g.drawString(s,center, y1+13);

	
	for(x=0; x<roles.size(); x++){
		String rName = (String) roles.elementAt(x);
		g.drawString(rName,x1+2, y1+(2+x)*textHeight);
	}
}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void drawSelected(java.awt.Graphics g) {
	//draw and orange rectangle just inside the perimeter of the
	//component and one just outside the perimeter
	g.setColor(new java.awt.Color(255,170,71));
	g.drawLine(x1-1, y1-1, x2+1, y1-1);   
	g.drawLine(x2+1, y1-1, x2+1, y2+1);
	g.drawLine(x2+1, y2+1, x1-1, y2+1);
	g.drawLine(x1-1, y2+1, x1-1, y1-1);
	g.drawLine(x1+1, y1+1, x2-1, y1+1);   
	g.drawLine(x2-1, y1+1, x2-1, y2-1);
	g.drawLine(x2-1, y2-1, x1+1, y2-1);
	g.drawLine(x1+1, y2-1, x1+1, y1+1);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getName() {
	return name;
}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void paint(java.awt.Graphics g) {
			
	//draw rectangle
	g.drawRect(x1+75,y1+75,width,height);
	if(name!=""){
		g.drawString(name,center+75, y1+13+75);
	}
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void resetMax() {
	Max=60;
	MaxH = 50;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setName(String s) {
	name = s;
}
/**
 * Insert the method's description here.
 * Creation date: (5/19/00 9:25:23 AM)
 * @param v java.util.Vector
 */
public void setRoles(Vector v) {
	roles = v;
	resetMax();
	}
}
