package system;

/**
 * connection between two components
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
public class ATconnection extends ATobject {
	private ATagentComponent component1;
	private ATagentComponent component2;
	
	// graphics info
	private ATconnectionGRFX grfxObj;
	public boolean Selected;

	int both   = 4;
	int second = 2;
	int first  = 1;
	int ArrowType = second;
	private static final String ukh = "conn@";
//	private ATtableElement first;
//	private ATtableElement second;
/**
 * ATtransition constructor comment.
 */
public ATconnection(double ver, String[] tokens, ATarchitecture a, ATsystem sys) {
	super(ver);
	grfxObj    = new ATconnectionGRFX();
	component1 = null;
	component2 = null;
	int loc = ATtokenOps.findnextinstanceof("version",tokens,0);
  	double v=Double.parseDouble(tokens[loc+3]);
	
	boolean keybased = false;
		
	loc  = ATtokenOps.findnextinstanceof("key", tokens, loc);
	if(loc != -1) {
		setKey(tokens[loc+3]);
		keybased = true;
	} else {
		setKey(ukh + sys.getNextKey());
	}

	loc  = ATtokenOps.findnextinstanceof("c1", tokens, loc);
	String c1name = tokens[loc+3];
	if(keybased) {
		setComponent1(a.findComponentbykey(c1name));
	} else {
		setComponent1(a.findComponentbyname(c1name));
	}
	
	loc  = ATtokenOps.findnextinstanceof("c2", tokens, loc);
	String c2name = tokens[loc+3];
	if(keybased) {
		setComponent2(a.findComponentbykey(c2name));
	} else {
		setComponent2(a.findComponentbyname(c2name));
	}
	
	if(component1 == null) {
		System.out.println("Error!!!  Component " + c1name + " not found.");
	} else if(component2 == null) {
		System.out.println("Error!!!  Agent " + c2name + " not found.");
	} else {
		setCoordinates(component1,component2);
	}
	
	loc  = ATtokenOps.findnextinstanceof("arrowtype", tokens, loc);
	setArrow(tokens[loc+3]);

	
	loc = ATtokenOps.findnextinstanceof("view",tokens,loc+2);
	int j = 0;

	
	if(loc>0){
		j = Integer.parseInt(tokens[loc+5]);
		loc= loc +5;
	}
	
	int[] xpos = new int[j];
	int[] ypos = new int[j];
	
	for(int i=0; i<j; i++){
		loc+=12;
		xpos[i] = Integer.parseInt(tokens[loc-6]);
		ypos[i] = Integer.parseInt(tokens[loc]);
	}
	grfxObj.initializePoints(xpos,ypos);
	
	grfxObj.Arrow();
	
	loc = ATtokenOps.findnextinstanceof("linetype",tokens,loc);
	grfxObj.setType(tokens[loc+4]);
//	System.out.println(grfxObj.type());
	
	if(v>1){
		loc = ATtokenOps.findnextinstanceof("POS1",tokens,loc);
		char p1 = (tokens[loc+4]).charAt(0);
		int n1 = Integer.parseInt(tokens[loc+8]);
		
		loc = ATtokenOps.findnextinstanceof("POS2",tokens,loc);
		char p2 = (tokens[loc+4]).charAt(0);
		int n2 = Integer.parseInt(tokens[loc+8]);
		
		// grfxObj.n_pts = j;
		if(component1!=component2 && component2!=null)
		{
			grfxObj.setPos(p1, n1, p2, n2);
		}
		else 
		{
		}
		
		grfxObj.Arrow();
	} else {
		setCoordinates(component1,component2);
	}
	
	
//	grfxObj.n_pts=j;
//	grfxObj.Arrow();
	//	grfxObj.setPos(p1,n1,p2,n2);
//	grfxObj.n_pts=j;
//	setCoordinates(component1, component2);
}
//	private ATtableElement first;
//	private ATtableElement second;
/**
 * ATtransition constructor comment.
 */
public ATconnection(double v, int keynum) {
	super(v);
	setKey(ukh + keynum);
	
	grfxObj = new ATconnectionGRFX();
	component1   = null;
	component2   = null;
}
//	private ATtableElement first;
//	private ATtableElement second;
/**
 * ATtransition constructor comment.
 */
public ATconnection(double ver, String maml, ATarchitecture a, ATsystem sys) {
	this(ver,ATtokenOps.parseLine(maml),a,sys);
}
//	private ATtableElement first;
//	private ATtableElement second;
/**
 * ATtransition constructor comment.
 */
public ATconnection(ATconnection cp) {
	super(cp);
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void addPoint(int x, int y) {
	grfxObj.addPoint(x,y);
	grfxObj.Arrow();
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void arrange_pts() {
	grfxObj.arrange_pts();
	grfxObj.Arrow();
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public boolean checkSelected(int x, int y) {
	if(grfxObj.dist(x,y)) {
		Selected = true;
		return false;
	} else {
		Selected = false;
		return true;
	}
}
/**
 * This method was created in VisualAge.
 * @return boolean
 * @param agent afit.system.ATagent
 */
public boolean checkState(ATagentComponent state) {
	boolean match;
	match = grfxObj.checkMatch(state.getGrfx());
	return match;
}
/**
 * This method was created in VisualAge.
 */
public void deleteMe() {
	grfxObj.deleteMe();
}
/**
 * This method was created in VisualAge.
 * @param g java.awt.Graphics
 */
public void draw(java.awt.Graphics g) {
	grfxObj.drawLine(g);
	if(Selected){
		grfxObj.drawSelected(g);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (11/18/99 3:45:22 PM)
 * @param Arrow java.lang.String
 */
public String getArrow() {
	if(ArrowType== 1){
		return "first";
	} 
	if (ArrowType == 2){
		return "second";
	} 
	else return "both";
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public ATagentComponent getComponent1() {
	return component1;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getComponent1Name() {
//	c1name=component1.getName();
//	return c1name;
	return component1.getName();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public ATagentComponent getComponent2() {
	return component2;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getComponent2Name() {
	return component2.getName();
}
/**
 * Insert the method's description here.
 * Creation date: (10/20/99 2:44:02 PM)
 */
public String getMAML() throws Exception {

	MAML="";
//	String hold=null;
	//Opening line for an Transisiton element
	MAML+="\t\t\t<connection";
//	if (nextState==null) hold="none";
//	else hold=nextState.getName();
	MAML+=" version=\"" + Double.toString(version) + "\"";
	
	MAML += " key=\"" + getKey() + "\"";
	
	MAML+=" c1=\"" + ((component1==null) ? "resource" : component1.getKey()) + "\"";	
	MAML+=" c2=\"" + ((component2==null) ? "resource" : component2.getKey()) + "\"";
	//MAML+=" c1=\"" + ((component1==null) ? "resource" : component1.getName()) + "\"";	
	//MAML+=" c2=\"" + ((component2==null) ? "resource" : component2.getName()) + "\"";
	MAML+=" arrowtype=\"" + ArrowType + "\"";		///>";
	
	MAML+="\n\t\t\t<view";
	MAML+=" n_pts=\""+grfxObj.n()+"\"";		//>\n";
	for(int j = 0; j<grfxObj.n(); j++){
		MAML+=" x" +j+ "=\"" +grfxObj.x(j) +"\"";
		MAML+=" y" +j+ "=\"" +grfxObj.y(j) +"\"";
	}
	MAML+=" linetype =\"" + grfxObj.type()+ "\"";		///>\n";
	MAML+=" POS1 =\"" + grfxObj.pos1 + "\" \"" + grfxObj.num1 + "\"";
	MAML+=" POS2 =\"" + grfxObj.pos2 + "\" \"" + grfxObj.num2 + "\"/>\n";

	return MAML;
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void movePoint(int x, int y) {
	grfxObj.movePoint(x,y);
	grfxObj.Arrow();
}
/**
 * Insert the method's description here.
 * Creation date: (3/7/00 2:35:53 PM)
 */
public void print(java.awt.Graphics g) {
	grfxObj.paint(g);
	}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 1:02:36 PM)
 * @param comp system.ATagentComponent
 */
public void resize(ATagentComponent comp) {
	grfxObj.resize(comp.getGrfx());
	grfxObj.Arrow();
	}
/**
 * Insert the method's description here.
 * Creation date: (3/28/00 3:01:00 PM)
 */
public void reverse() {
	ATagentComponent hold = component1;
	component1 = component2;
	component2 = hold;
	grfxObj.reverse();
}
/**
 * Insert the method's description here.
 * Creation date: (11/18/99 3:45:22 PM)
 * @param Arrow java.lang.String
 */
public void setArrow(String Arrow) {
	if(Arrow.equals("first")){
		this.ArrowType = first;
	} if (Arrow.equals("second")){
		this.ArrowType = second;
	} if (Arrow.equals("both")){
		this.ArrowType = both;
	}
	grfxObj.setArrow(Arrow);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setComponent1(ATagentComponent s) {
	component1 = s;
//	c1name=s.getName();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setComponent2(ATagentComponent s) {
	component2 = s;
}
/**
 * This method was created in VisualAge.
 */
public void setCoordinates(ATagentComponent select1, ATagentComponent select2) {
	if(select1!=select2 && select2!=null){
		grfxObj.place(select1.getGrfx(),select2.getGrfx());
		component1 = select1;
		component2 = select2;
	} else{
		component1 = select1;
		select2    = null;
		grfxObj.setEmptyConn(select1.getGrfx());
	}
}
}
