package system;

/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
// import java.util.Vector;
import java.util.*;

public class ATconversation2 extends ATobject {

//	private String mult;
	private ATagent2 agent1;
	private ATagent2 agent2;

// graphics info
	private ATconv2GRFX grfxObj;
	public boolean Selected;
	private static final String ukh = "conv2@";
/**
 * ATconversation constructor comment.
 */
public ATconversation2(double ver, String[] tokens, ATsystem sys) {
	this(ver,0); //*** Version 1 of ATconversation ***
  
	int loc = ATtokenOps.findnextinstanceof("version",tokens,0);
  	double v=Double.parseDouble(tokens[loc+3]);
  //setVersion(v);
  //Code for constructing object model from MAML tokens
  if (v>=1) constructFromV1(tokens, sys);
  else {
	System.out.println("Loading a version other than 1");	
  }
 }   
/**
 * ATconversation constructor comment.
 */
public ATconversation2(double v, int keynum) {
	super(v);
	setKey(ukh + keynum);
//	initiator = null;
//	responder = null;
	MAMLheader+="<!DOCTYPE conversation SYSTEM \"atconversation"+Double.toString(getVersion())+".dtd\">\n";
	grfxObj = new ATconv2GRFX();
	Selected = false;
}
/**
 * ATconversation constructor comment.
 */
public ATconversation2(double ver, String maml, ATsystem sys) {
	this(ver,ATtokenOps.parseLine(maml),sys);
 }  
/**
 * ATconversation constructor comment.
 */
public ATconversation2(ATagent2 first, ATagent2 second, double v, int keynum) {
	this(v,keynum);
	agent1 = first;
	agent2 = second;
	setCoordinates(first,second);
	}
/**
 * ATconversation constructor comment.
 */
public ATconversation2(ATconversation2 cp) {
	super(cp);
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void addPoint(int x, int y) {
	grfxObj.addPoint(x,y);
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void arrange_pts() {
	grfxObj.arrange_pts();
}
/**
 * This method was created in VisualAge.
 * @return java.util.Vector
 */
public java.util.Vector buildVerificationTable() {
	java.util.Vector tempVec;

	//tempVec = initiator.clone();
	return null;
}
/**
 * This method was created in VisualAge.
 * @return boolean
 * @param agent afit.system.ATagent
 */
public boolean checkAgent(ATagent agent) {
	boolean match;
	match = grfxObj.checkMatch(agent.getGrfx());
	return match;
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public boolean checkSelected(int x, int y) {
	if(grfxObj.dist(x,y)) {
		Selected = true;
		return false;
	} else {
		Selected = false;
		return true;
	}
}
/**
 * Insert the method's description here.
 * Creation date: (10/25/99 11:33:58 PM)
 * @param tokens java.lang.String[]
 */
public void constructFromV1(String[] tokens, ATsystem sys) {
	
	String submaml=null;
	
	int loc = ATtokenOps.findnextinstanceof("version",tokens,0);
	double v = Double.parseDouble(tokens[loc+3]);
	 	
	ATagent2 agent, agent1= null,agent2= null;
//	setName(tokens[12]);
//	description=tokens[18];
	int start, end;

	boolean keybased = false;
	
	loc  = ATtokenOps.findnextinstanceof("key", tokens, 0);
	if(loc != -1) {
		setKey(tokens[loc+3]);
		keybased = true;
	} else {
		setKey(ukh + sys.getNextKey());
	}
	
	start = ATtokenOps.findnextinstanceof("description", tokens, 15);
	end   = ATtokenOps.findnextinstanceof("/description", tokens, start+2);
	String a1name, a2name;
	loc = ATtokenOps.findnextinstanceof("Agent1",tokens,end+2);
	a1name = tokens[loc+3];
	loc = ATtokenOps.findnextinstanceof("Agent2",tokens,loc+2);
	a2name = tokens[loc+3];
	Enumeration agents = sys.returnAgentInstances();
	while(agents.hasMoreElements()){
		agent = (ATagent2)agents.nextElement();
		if(keybased) {
			if(agent.getKey().equals(a1name)){
				agent1 = agent;
			}
			if(agent.getKey().equals(a2name)){
				agent2 = agent;
			}
		} else {
			if(agent.getFname().equals(a1name)){
				agent1 = agent;
			}
			if(agent.getFname().equals(a2name)){
				agent2 = agent;
			}
		}
	}
	if(agent1 == null) {
		System.out.println("Error!!!  Agent " + a1name + " not found.");
	} else if(agent2 == null) {
		System.out.println("Error!!!  Agent " + a2name + " not found.");
	} else {
		setCoordinates(agent1,agent2);
	}
	
	loc = ATtokenOps.findnextinstanceof("view",tokens,loc+2);
	int j = 0;
	if(loc>0){
		j = Integer.parseInt(tokens[loc+5]);
		loc= loc +5;
	}
	ATagent temp,init = null,resp = null;
			
	//grfxObj.place(initiator.getParticipant().getGrfx(),responder.getParticipant().getGrfx());
	if(v>1){
/*		for(int i=0; i<j; i++){
			int k = Integer.parseInt(tokens[loc+6]);
			loc+=6;
			int l = Integer.parseInt(tokens[loc+6]);
			loc+=6;
			grfxObj.Xs[i]=k;
			grfxObj.Ys[i]=l;
		}
*/
		int[] xpos = new int[j];
		int[] ypos = new int[j];
		
		for(int i=0; i<j; i++){
			xpos[i] = Integer.parseInt(tokens[loc+6]);
			loc+=6;
			ypos[i] = Integer.parseInt(tokens[loc+6]);
			loc+=6;
		}
		grfxObj.initializePoints(xpos,ypos);

//		grfxObj.type = tokens[loc+7];
//		loc+=7;
//		char p1 = (tokens[loc+7]).charAt(0);
//		loc+=7;
//		int n1 = Integer.parseInt(tokens[loc+4]);
//		loc+=4;
//		char p2 = (tokens[loc+7]).charAt(0);
//		loc+=7;
//		int n2 = Integer.parseInt(tokens[loc+4]);
//		grfxObj.n_pts=j;
		grfxObj.Arrow();
//		grfxObj.setPos(p1,n1,p2,n2);
	}	
//	System.out.println("End of conversation parsing at token: "+(end+7)+" of "+tokens.length);	
//	System.out.println("Last 7 tokens were: "+ATtokenOps.extract(tokens,(end+1), (end+7)));
}
public void deleteMe() {
	grfxObj.deleteMe();
}
/**
 * This method was created in VisualAge.
 */
public void draw(java.awt.Graphics g) {
	if (grfxObj != null) {
		grfxObj.drawLine(g);
		if(Selected){
			grfxObj.drawSelected(g);
		}
	}
}
/**
 * Insert the method's description here.
 * Creation date: (7/18/00 7:45:34 AM)
 * @return system.ATagent2
 */
public ATagent2 getInitiator() {
	return agent1;
}
/**
 * Insert the method's description here.
 * Creation date: (10/20/99 1:15:09 PM)
 */
public String getMAML() throws NullPointerException {
	MAML="";
	//Opening line for an Conversation element			
	MAML+="\n\t<conversation2";
	MAML+=" version=\"" + Double.toString(version) + "\"";
	MAML+=" name=\"" + name + "\">\n";
	//New Line for Description element
	
	MAML += " key=\"" + getKey() + "\"";
	
	MAML+="\t\t<description>\n\t\t";
	MAML+=getDescription();
	MAML+="\n\t\t</description>\n";
	MAML+="Agent1=\"" + agent1.getKey() + "\"";
	MAML+="Agent2=\"" + agent2.getKey() + "\"\n";
	//MAML+="Agent1=\"" + agent1.getFname() + "\"";
	//MAML+="Agent2=\"" + agent2.getFname() + "\"\n";

	
//Opening line for an Participant element
//	MAML+="\t\t<participant";
//	MAML+=" name=\"initiator\">\n";
//	initiator.encodeMAML();
//	MAML+=initiator.getMAML();
	//Closing line for an Participant element
//	MAML+="\t\t</participant>\n";	
	//Opening line for an Participant element
/*	MAML+="\t\t<participant";
	MAML+=" name=\"responder\">\n";
	responder.encodeMAML();
	MAML+=responder.getMAML();
*/	MAML+="\n\t\t<view";
	MAML+=" n_pts=\""+grfxObj.n()+"\"";//>\n";
	for(int j = 0; j<grfxObj.n(); j++){
		MAML+=" x" +j+ "=\"" +grfxObj.x(j) +"\"";
		MAML+=" y" +j+ "=\"" +grfxObj.y(j) +"\"";
	}
	MAML+=" linetype =\"" + grfxObj.type()+ "\"";///>\n";
	MAML+=" POS1 =\"" + grfxObj.pos1 + "\" \"" + grfxObj.num1 + "\"";
	MAML+=" POS2 =\"" + grfxObj.pos2 + "\" \"" + grfxObj.num2 + "\"/>\n";

	//Closing line for an Participant element
	MAML+="\t\t</participant>\n";
	MAML+="\t</conversation2>\n";

	return MAML;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getName() {
	return name;
}
/**
 * Insert the method's description here.
 * Creation date: (7/18/00 7:45:34 AM)
 * @return system.ATagent2
 */
public ATagent2 getResponder() {
	return agent2;
}
/**
 * Insert the method's description here.
 * Creation date: (10/28/99 10:36:53 AM)
 */
public void integrateKBInfo(String maml, ATsystem sys) {
	
  String[] tokens = ATtokenOps.parseLine(maml);
  int v=Integer.parseInt(tokens[6]);
	
  //Code for constructing object model from MAML tokens
  if (v==version) {
	constructFromV1(tokens, sys);
  }
  else {
	System.out.println("Loading a version other than 1");	
  }
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void movePoint(int x, int y) {
	grfxObj.movePoint(x,y);
}
/**
 * This method was created in VisualAge.
 */
public java.awt.Graphics print(java.awt.Graphics g) {
	grfxObj.paint(g);
	return g;
}
/**
 * This method was created in VisualAge.
 * @param agent system.ATagent
 */
public void resize(ATagent agent) {
	grfxObj.resize(agent.getGrfx());
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 1:05:46 PM)
 * @param ag system.ATagent2
 */
public void resize(ATagent2 ag) {
	
	grfxObj.resize(ag.getGrfx());
	}
/**
 * Insert the method's description here.
 * Creation date: (3/28/00 3:01:00 PM)
 */
public void reverse() {
	ATagent2 hold = agent1;
	agent1 = agent2;
	agent2 = hold;
	grfxObj.reverse();
}
/**
 * This method was created in VisualAge.
 */
public void setCoordinates(ATagent2 first, ATagent2 second) {

	grfxObj.place(first.getGrfx(),second.getGrfx());
	agent1 = first;
	agent2 = second;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setName(String s) {
	name = ATtokenOps.validName(s);
	grfxObj.setName(s);
}
/**
 * Insert the method's description here.
 * Creation date: (7/17/00 2:17:09 PM)
 */
public void writeDATA() {
	super.writeDATA();
	MAML+= "\tAgent1 = " + getInitiator().getFname() +"\n";
	MAML+= "\tAgent2 = " + getResponder().getFname() +"\n";
}
}
