package system;

/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
//___________________________________________________
// Class to represent a line
//___________________________________________________
import java.io.*;
import java.util.*;
import java.awt.*;

class ATgoalGRFX extends Square implements Serializable{
	
	//Labels for square
	private String name = "";
	private int x,y; //---the corner that is selected (1,1), (1,2), (2,1), (2,2) ...(x,y)
	private int Max = 60;
	private int center;
	private double version;
	private Vector strings = new Vector();
/**
 * This method was created in VisualAge.
 */
public ATgoalGRFX(double v) {
	super();
	name = " ";
	version = v;
}
/**
 * This method was created in VisualAge.
 */
public ATgoalGRFX(ATgoalGRFX cp) {
	super(cp);
}
/**
 * Insert the method's description here.
 * Creation date: (11/16/00 3:10:58 PM)
 */
public void autosize(Graphics g) {
	String s = name;
	Font f = g.getFont();
	//FontMetrics fm = Toolkit.getDefaultToolkit().getFontMetrics(f);
	FontMetrics fm = g.getFontMetrics(); // SAD Change - deprecated fix???
	int textWidth = fm.stringWidth(s);
	int textHeight = fm.getHeight();

	resetMax();
	
	strings.removeAllElements();
	String hold1 = name,hold2;
	int n = 2; //number of rows
	
	
	if(version >= 1.8) {
		int k = 20;
		
		if(hold1.length() > 1.5*k){
			int index = -1;
			n = 1;
			while(hold1.length() > k){
				index = hold1.lastIndexOf(" ",k);
				if(index>=0){
					strings.add(hold1.substring(0,index));
					hold1 = hold1.substring(index+1);
					n++;
				} else {
					hold2 = hold1.substring(0,k-1) + "-";
					strings.add(hold2);
					hold1 = hold1.substring(k-1);
					n++;
				}
			}
		
			strings.add(hold1);
			if(n<2) n=2;
		
		} else {
			k = (int)(0.66 * hold1.length());
			int index = hold1.lastIndexOf(" ",k);
			if(index>=0){
				strings.add(hold1.substring(0,index));
				strings.add(hold1.substring(index+1));
			} else {
				strings.add(hold1);
			}
		}

	} else {
		int j,k,index = -1;
		int length = hold1.length();
		if(n>1){
			int pL = length/n;
			int current = pL;
			for(int i=1; i<n; i++){
				if(hold1.length()>1){
					if(pL>5){
						hold2 = hold1.substring(current);
						k = current;
					} else {
							hold2 = hold1.substring(current-1);
							k = current-1;
					}
					index = hold2.indexOf(" ");
					if(index>=0){
						j=index+k;
					} else {
						j = k+hold2.length();
					}
					String newS = hold1.substring(0,j);
					if(index>=0){
						hold1 = hold1.substring(j);
					}
					strings.add(newS);
				} else {
					index = 1;
				}
			}
			if(index>=0){
				strings.add(hold1);
			}
		} else {
			strings.add(name);
		}
	}
		
	Enumeration rows = strings.elements();
	while(rows.hasMoreElements()){
		String hold = (String)rows.nextElement();
		textWidth = fm.stringWidth(hold);	
		if((textWidth+9) > Max){
			Max = textWidth + 9;
		}
	}
	
	width = Max;
	x2 = x1 + Max;
	
	height = textHeight*n + 5;
	y2 = y1 + height;
	
	center = x1 + (width - textWidth)/2;//(x1+x2)/2- s.length()*3;
	center_x = (x1 + x2)/2;
	center_y = (y1 + y2)/2;
	
	refresh();
}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void drawHighlighted(java.awt.Graphics g) {
	//draw and orange rectangle just inside the perimeter of the
	//component and one just outside the perimeter
	g.setColor(Color.yellow);
	g.drawLine(x1-2, y1-2, x2+2, y1-2);
	g.drawLine(x2+2, y1-2, x2+2, y2+2);
	g.drawLine(x2+2, y2+2, x1-2, y2+2);
	g.drawLine(x1-2, y2+2, x1-2, y1-2);
	g.drawLine(x1+2, y1+2, x2-2, y1+2);   
	g.drawLine(x2-2, y1+2, x2-2, y2-2);
	g.drawLine(x2-2, y2-2, x1+2, y2-2);
	g.drawLine(x1+2, y2-2, x1+2, y1+2);
	
	g.drawLine(x1-1, y1-1, x2+1, y1-1);   
	g.drawLine(x2+1, y1-1, x2+1, y2+1);
	g.drawLine(x2+1, y2+1, x1-1, y2+1);
	g.drawLine(x1-1, y2+1, x1-1, y1-1);
	g.drawLine(x1+1, y1+1, x2-1, y1+1);   
	g.drawLine(x2-1, y1+1, x2-1, y2-1);
	g.drawLine(x2-1, y2-1, x1+1, y2-1);
	g.drawLine(x1+1, y2-1, x1+1, y1+1);
}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void drawObject(java.awt.Graphics g) {
	drawObject(g,false);
}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void drawObject(java.awt.Graphics g, boolean greyed) {
	String s = name;
	Font f = g.getFont();
	//FontMetrics fm = Toolkit.getDefaultToolkit().getFontMetrics(f);
	FontMetrics fm = g.getFontMetrics(); // SAD Change - deprecated fix???
	int textWidth = fm.stringWidth(s);
	int textHeight = fm.getHeight();

	autosize(g);
/*	width = Max;
	x2 = x1 + Max;

	strings.removeAll();
	String hold1 = name,hold2;
	int n = 2; //number of rows
	
	
	if(version >= 1.8) {
		int k = 20;
		
		if(hold1.length() > 1.5*k){
			int index = -1;
			n = 1;
			while(hold1.length() > k){
				index = hold1.indexOf(" ",k-1);
				if(index>=0){
					strings.add(hold1.substring(0,index));
					hold1 = hold1.substring(index);
					n++;
				} else {
					break;
				}
			}
		
			strings.add(hold1);
			if(n<2) n=2;
		
		} else {
			k = (int)(0.33 * hold1.length());
			int index = hold1.indexOf(" ",k);
			if(index>=0){
				strings.add(hold1.substring(0,index));
				strings.add(hold1.substring(index));
			} else {
				strings.add(hold1);
			}
		}

	} else {
		int j,k,index = -1;
		int length = hold1.length();
		if(n>1){
			int pL = length/n;
			int current = pL;
			for(int i=1; i<n; i++){
				if(hold1.length()>1){
					if(pL>5){
						hold2 = hold1.substring(current);
						k = current;
					} else {
							hold2 = hold1.substring(current-1);
							k = current-1;
					}
					index = hold2.indexOf(" ");
					if(index>=0){
						j=index+k;
					} else {
						j = k+hold2.length();
					}
					String newS = hold1.substring(0,j);
					if(index>=0){
						hold1 = hold1.substring(j);
					}
					strings.add(newS);
				} else {
					index = 1;
				}
			}
			if(index>=0){
				strings.add(hold1);
			}
		} else {
			strings.add(name);
		}
	}
		
	Enumeration rows = strings.elements();
	int j = 0;
	while(rows.hasMoreElements()){
		String hold = (String)rows.nextElement();
		textWidth = fm.stringWidth(hold);	
		if((textWidth) > (Max-5)){
			Max = textWidth + 9;
			width = Max;
			x2 = x1 + Max;
		}
		j++;
	}

	height = textHeight*n + 5;
	y2 = y1 + height;
		
	center = x1 + (width - textWidth)/2;//(x1+x2)/2- s.length()*3;
*/
	g.setColor((greyed) ? new java.awt.Color(192,192,192) : new java.awt.Color(210,232,255));
	g.fillRect( x1, y1,  width,  height);	//white background for rect.
	g.setColor(new java.awt.Color(0,0,130));
		
	//draw rectangle
	g.drawLine( x1,  y1,  x2,  y1);   
	g.drawLine( x2,  y1,  x2,  y2);
	g.drawLine( x2,  y2,  x1,  y2);
	g.drawLine( x1,  y2,  x1,  y1);
//	g.drawLine(x1, y1 + textHeight + 3, x2, y1+textHeight+3);


	//draw text in rectangle
	g.setColor(Color.black);
	Enumeration rows = strings.elements();
	int j = 0;
	while(rows.hasMoreElements()){
		String hold = (String)rows.nextElement();
		g.drawString(hold,x1+5, y1+13+j*textHeight);
		j++;
	}
}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void drawSelected(java.awt.Graphics g) {
	//draw and orange rectangle just inside the perimeter of the
	//component and one just outside the perimeter
	g.setColor(new java.awt.Color(255,170,71));
	g.drawLine(x1-1, y1-1, x2+1, y1-1);   
	g.drawLine(x2+1, y1-1, x2+1, y2+1);
	g.drawLine(x2+1, y2+1, x1-1, y2+1);
	g.drawLine(x1-1, y2+1, x1-1, y1-1);
	g.drawLine(x1+1, y1+1, x2-1, y1+1);   
	g.drawLine(x2-1, y1+1, x2-1, y2-1);
	g.drawLine(x2-1, y2-1, x1+1, y2-1);
	g.drawLine(x1+1, y2-1, x1+1, y1+1);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getName() {
	return name;
}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void paint(java.awt.Graphics g) {
			
	//draw rectangle
	g.drawRect(x1+75,y1+75,width,height);
	if(name!=""){
		g.drawString(name,center+75, y1+13+75);
	}
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void resetMax() {
	Max=60;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setName(String s) {
	name = s;
}
/**
 * Insert the method's description here.
 * Creation date: (11/16/00 2:28:28 PM)
 * @param v double
 */
public void setVersion(double v) {
	version = v;	
}
}
