package system;

/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
//___________________________________________________
// Class to represent a line
//___________________________________________________
import java.io.*;
import java.util.Vector;
import java.awt.*;

class ATroleGRFX extends Square {
	//Labels for square
	String name = "";
	int x,y; //---the corner that is selected (1,1), (1,2), (2,1), (2,2) ...(x,y)
	int Max = 60;
	int MaxH = 60;
	int center;
	Vector goals = null;
	FontMetrics fm;

/**
 * This method was created in VisualAge.
 */
public ATroleGRFX() {
	super();
	goals = new Vector();
}
/**
 * This method was created in VisualAge.
 */
public ATroleGRFX(ATroleGRFX cp) {
	super(cp);
}
/**
 * Insert the method's description here.
 * Creation date: (1/26/01 3:55:28 PM)
 */
public void bounds() {
	if(fm != null) {
		
		resetMax();
		int textWidth = fm.stringWidth(name);
		int textHeight = fm.getHeight();
		width = Max;
		x2 = x1 + Max;
		if((textWidth) > (Max)){
			Max = textWidth + 5;
			width = Max;
			x2 = x1 + Max;
		}
		java.util.Enumeration r = goals.elements();
		ATGoal goal;
		String gname;
		while(r.hasMoreElements()){
			goal = (ATGoal)r.nextElement();
			gname = goal.getNum();
			textWidth = fm.stringWidth(gname);
			if(textWidth > Max){
				Max = textWidth + 5;
				width = Max;
				x2 = x1 + Max;
			}
		}
		int num = goals.size();
		int h = (num+1)*textHeight +3;
		if(h>MaxH){
			MaxH = h;
			height = h;
		}
		y2 = y1 + height;
		
		textWidth = fm.stringWidth(name);
		center = x1 + (width - textWidth)/2;
	}
}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void drawHighlighted(java.awt.Graphics g) {
	//draw and orange rectangle just inside the perimeter of the
	//component and one just outside the perimeter
	g.setColor(Color.yellow);
	g.drawLine(x1-2, y1-2, x2+2, y1-2);
	g.drawLine(x2+2, y1-2, x2+2, y2+2);
	g.drawLine(x2+2, y2+2, x1-2, y2+2);
	g.drawLine(x1-2, y2+2, x1-2, y1-2);
	g.drawLine(x1+2, y1+2, x2-2, y1+2);   
	g.drawLine(x2-2, y1+2, x2-2, y2-2);
	g.drawLine(x2-2, y2-2, x1+2, y2-2);
	g.drawLine(x1+2, y2-2, x1+2, y1+2);
	
	g.drawLine(x1-1, y1-1, x2+1, y1-1);   
	g.drawLine(x2+1, y1-1, x2+1, y2+1);
	g.drawLine(x2+1, y2+1, x1-1, y2+1);
	g.drawLine(x1-1, y2+1, x1-1, y1-1);
	g.drawLine(x1+1, y1+1, x2-1, y1+1);   
	g.drawLine(x2-1, y1+1, x2-1, y2-1);
	g.drawLine(x2-1, y2-1, x1+1, y2-1);
	g.drawLine(x1+1, y2-1, x1+1, y1+1);
}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void drawObject(java.awt.Graphics g) {
	Font f = g.getFont();
	//FontMetrics fm = Toolkit.getDefaultToolkit().getFontMetrics(f);
	fm = g.getFontMetrics(); // SAD Change - deprecated fix???
	int textWidth = fm.stringWidth(name);
	int textHeight = fm.getHeight();

	bounds();
	
	g.setColor(new java.awt.Color(250,250,230));
	g.fillRect( x1, y1,  width,  height);	//white background for rect.
	g.setColor(new java.awt.Color(0,0,130));
		
	//draw rectangle
	g.drawLine( x1,  y1,  x2,  y1);   
	g.drawLine( x2,  y1,  x2,  y2);
	g.drawLine( x2,  y2,  x1,  y2);
	g.drawLine( x1,  y2,  x1,  y1);
	g.drawLine(x1, y1 + textHeight + 3, x2, y1+textHeight+3);

	int h =  height/3;

	//draw text in rectangle
	g.setColor(Color.black);
	g.drawString(name,center, y1+13);
	
	for(x=0; x<goals.size(); x++){
		ATGoal goal = (ATGoal)goals.elementAt(x);
		String gName = goal.getNum();
		g.drawString(gName,x1+2, y1+(2+x)*textHeight);
	}
}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void drawSelected(java.awt.Graphics g) {
	//draw and orange rectangle just inside the perimeter of the
	//component and one just outside the perimeter
	g.setColor(new java.awt.Color(255,170,71));
	g.drawLine(x1-1, y1-1, x2+1, y1-1);   
	g.drawLine(x2+1, y1-1, x2+1, y2+1);
	g.drawLine(x2+1, y2+1, x1-1, y2+1);
	g.drawLine(x1-1, y2+1, x1-1, y1-1);
	g.drawLine(x1+1, y1+1, x2-1, y1+1);   
	g.drawLine(x2-1, y1+1, x2-1, y2-1);
	g.drawLine(x2-1, y2-1, x1+1, y2-1);
	g.drawLine(x1+1, y2-1, x1+1, y1+1);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getName() {
	return name;
}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void paint(java.awt.Graphics g) {
			
	//draw rectangle
	g.drawRect(x1+75,y1+75,width,height);
	if(name!=""){
		g.drawString(name,center+75, y1+13+75);
	}
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void resetMax() {
	Max=60;
	MaxH = 50;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setName(String s) {
	name = s;
}
}
