package system;

/**
 * Insert the type's description here.
 * Creation date: (6/12/00 10:49:24 AM)
 * @author: 
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
 import java.util.*;
 import java.awt.*;
public class ATseqDiag extends ATobject{
	private Vector roles, messages;
	private static final String ukh = "seqdiag@";
/**
 * ATagent constructor comment.
 */
public ATseqDiag(double ver, String[] tokens, ATsystem sys) {
	this(ver,0); //*** Version 1 of ATagent ***
	
	int loc = ATtokenOps.findnextinstanceof("version",tokens,0);
	double v=Double.parseDouble(tokens[loc+3]);
	//setVersion(v);
  //Code for constructing object model from MAML tokens
	if (v>=1) constructFromV1(tokens, sys);
	else {
		System.out.println("Loading a version other than 1.");	
	}
 	//	System.out.println("Loaded an agent");
}
/**
 * ATseqDiag constructor comment.
 */
public ATseqDiag(double v, int keynum) {
	super(v);
	setKey(ukh + keynum);
	roles = new Vector();
	messages = new Vector();
}
/**
 * ATagent constructor comment.
 */
public ATseqDiag(double ver, String x, ATsystem sys) {
	this(ver,ATtokenOps.parseLine(x),sys);
}
/**
 * ATseqDiag constructor comment.
 */
public ATseqDiag(ATseqDiag cp) {
	super(cp);
}
/**
 * Insert the method's description here.
 * Creation date: (6/16/00 10:05:50 AM)
 * @param role afit.system.ATRole
 */
public void addMessage(ATmessage message) {
	messages.add(message);
}
/**
 * Insert the method's description here.
 * Creation date: (6/16/00 10:05:50 AM)
 * @param role afit.system.ATRole
 */
public void addRole(ATRole2 role) {
	roles.add(role);
	}
/**
 * Insert the method's description here.
 * Creation date: (6/19/00 2:06:23 PM)
 */
public void arrangeMessages(int length) {
	Vector hold = messages;
	messages = new Vector();
	orderMessages(hold, length);
	
}
/**
 * Insert the method's description here.
 * Creation date: (10/25/99 11:03:31 PM)
 */
public void constructFromV1(String[] tokens, ATsystem sys) {
	int loc = ATtokenOps.findnextinstanceof("name",tokens,0);
	name=tokens[loc+3];

	loc  = ATtokenOps.findnextinstanceof("key", tokens, loc);
	if(loc != -1) {
		setKey(tokens[loc+3]);
	} else {
		setKey(ukh + sys.getNextKey());
	}
	
//	int start=findnextinstanceof("description", tokens, loc+4);
//	loc=findnextinstanceof("/description", tokens, start+3);
//	description=extract(tokens,(start+2), (loc-2));

//	loc+=8;
//	String framework = tokens[loc];
	for(int i=(loc+2);i<tokens.length;++i){
		if(tokens[i].equals("Role2")){
			loc=ATtokenOps.findnextinstanceof("/Role2",tokens, i);
			String[] submaml=ATtokenOps.subTokens(tokens,(i-1),(loc+1));
			ATRole2 role = new ATRole2(version,submaml, sys);
			addRole(role);
			i = loc;
		}
	}
	for(int i=(loc+2);i<tokens.length;++i){
		if(tokens[i].equals("message")){
			loc=ATtokenOps.findnextinstanceof("/message",tokens, i);
			String[] submaml=ATtokenOps.subTokens(tokens,(i-1),(loc+1));
			ATmessage message = new ATmessage(version,submaml, this, sys);
			addMessage(message);
		}
	}
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void deleteMessage(ATmessage m) {
	messages.removeElement(m);
	m.deleteMe();
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void deleteRole(ATRole2 r) {
	roles.removeElement(r);
	r.deleteMe();
}
/**
 * Insert the method's description here.
 * Creation date: (6/16/00 8:32:40 AM)
 */
public void draw(Graphics g) {
	Enumeration r = roles.elements();
	Enumeration m = messages.elements();
	ATRole2 role;
	ATmessage message;
	while(r.hasMoreElements()){
		role = (ATRole2)r.nextElement();
		role.draw(g);
	}
	while(m.hasMoreElements()){
		message = (ATmessage)m.nextElement();
		message.draw(g);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (10/20/99 1:15:38 PM)
 */
public String getMAML() throws Exception {
	Enumeration roles = returnRoles();
	Enumeration messages = returnMessages();
	ATmessage message;
	ATRole2 role;
	
	MAML="";
	//Opening line for an Multi Agent System element
	MAML+="<seqDiag";
	MAML+=" version=\"" + Double.toString(version) + "\"";
	MAML+=" name=\"" + name + "\">\n";
	
	MAML += " key=\"" + getKey() + "\"";
	
	//New Line for Description element
/*	MAML+="<description>\n";
	MAML+=getDescription();
	MAML+="\n</description>\n";
*/	//New Line for Framework element
	//Look through and encode then get constituent agent MAML code
	while(roles.hasMoreElements()){
		role = (ATRole2)roles.nextElement();
		MAML+=role.getMAML();
	}
	while(messages.hasMoreElements()){
		message = (ATmessage)messages.nextElement();
		MAML+=message.getMAML();
	}
	//Closing line for an MAS element		
	MAML+="</seqDiag>";
//	System.out.println("\nThis is the MAML text: \n" + MAML);

	return MAML;
}
/**
 * Insert the method's description here.
 * Creation date: (6/12/00 10:46:39 AM)
 * @return java.lang.String
 */
public String getName() {
	return name;
}
/**
 * Insert the method's description here.
 * Creation date: (1/19/01 1:34:32 PM)
 * @return int
 */
public int getRole2Count() {
	return roles.size();
}
/**
 * Insert the method's description here.
 * Creation date: (12/7/00 4:18:04 PM)
 * @return int
 */
public int messageCount() {
	return messages.size();
}
/**
 * Insert the method's description here.
 * Creation date: (6/19/00 2:06:43 PM)
 * @param m java.util.Vector
 */
public void orderMessages(Vector m, int height) {
	int Min = height;
	Enumeration mess = m.elements();
	ATmessage message, MinMess = null;
	while(mess.hasMoreElements()){
		message = (ATmessage)mess.nextElement();
		if(message.getHeight() < Min){
			Min = message.getHeight();
			MinMess = message;
		}
	}
	if(MinMess!=null){
		messages.add(MinMess);
		m.remove(MinMess);
		orderMessages(m, height);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (12/22/00 11:32:06 AM)
 * @return boolean
 */
public void removeAllMessages() {
	messages.removeAllElements();
}
/**
 * Insert the method's description here.
 * Creation date: (12/22/00 11:32:23 AM)
 * @return boolean
 */
public void removeAllRoles() {
	roles.removeAllElements();
}
/**
 * Insert the method's description here.
 * Creation date: (12/14/00 2:02:09 PM)
 * @return boolean
 * @param s java.lang.String
 */
public boolean repeatName(String s) {
	Enumeration enum = roles.elements();
	while(enum.hasMoreElements()) {
		ATRole2 role = (ATRole2)enum.nextElement();
		if(s.equals(role.getName())) return true;
	}
	return false;
}
/**
 * Insert the method's description here.
 * Creation date: (6/16/00 8:38:10 AM)
 * @return java.util.Enumeration
 */
public Enumeration returnMessages() {
	Enumeration m = messages.elements();
	return m;
}
/**
 * Insert the method's description here.
 * Creation date: (6/16/00 8:38:10 AM)
 * @return java.util.Enumeration
 */
public Enumeration returnRoles() {
	Enumeration r = roles.elements();
	return r;
}
/**
 * Insert the method's description here.
 * Creation date: (6/16/00 8:38:10 AM)
 * @return java.util.Enumeration
 */
public Vector returnRoleVector() {
	return roles;
}
/**
 * Insert the method's description here.
 * Creation date: (6/12/00 10:46:11 AM)
 * @param n java.lang.String
 */
public void setName(String n) {
	name = ATtokenOps.validName(n);
	}
}
