package system;

/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
 import java.util.*;
public class ATstartState extends ATtableElement{
	private ATstartStateGRFX grfxObj = null;
	private static final String ukh = "startstate@";
/**
 * ATtransitionGRFX constructor comment.
 */
public ATstartState(double v, int keynum) {
	super(v);
	setKey(ukh + keynum);
	grfxObj = new ATstartStateGRFX();
}
/**
 * ATtransitionGRFX constructor comment.
 */
public ATstartState(ATstartState cp) {
	super(cp);
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public boolean checkSelected(int x, int y) {
	if(grfxObj.dist(x,y)) {
	//	notSelected = false;
		return false;
	} else {
	//	notSelected = true;
		return true;
	}
}
/**
 * Insert the method's description here.
 * Creation date: (2/7/01 1:27:55 PM)
 * @param tokens java.lang.String[]
 */
public void decodeMAML(String[] tokens) {
	
	int loc  = ATtokenOps.findnextinstanceof("key", tokens, 0);
	if(loc != -1) {
		setKey(tokens[loc+3]);
	}
		   	
	loc  = ATtokenOps.findnextinstanceof("pos", tokens, 0);
	if(loc != -1) {
		setPos(Integer.parseInt(tokens[loc+3]),Integer.parseInt(tokens[loc+7]));
	}
}
/**
 * Insert the method's description here.
 * Creation date: (2/7/01 1:27:55 PM)
 * @param tokens java.lang.String[]
 */
public void decodeMAML(String MAML) {
	decodeMAML(ATtokenOps.parseLine(MAML));
}
/**
 * This method was created in VisualAge.
 * @param g java.awt.Graphics
 */
public void draw(java.awt.Graphics g) {
	if(errorSelected) {
		grfxObj.drawError(g);
	}		
	grfxObj.drawObject(g);
	if(Selected){
		grfxObj.drawSelected(g);
	}
}
public Vector getActions() {
	return null;
}
/**
 * This method was created in VisualAge.
 * @return system.Circle
 */
public Square getGrfx() {
	return grfxObj;
}
/**
 * Insert the method's description here.
 * Creation date: (10/20/99 2:34:37 PM)
 */
public String getMAML() throws NullPointerException {
	//Opening line for an State element
	MAML="";
	MAML+="\t\t\t\t<state";
	MAML+=" name=\""+getName()+"\">\n";
	MAML += " key=\"" + getKey() + "\"";
		MAML+=" \t\t\t\t pos=\"" + grfxObj.x1 +"\",\"" + grfxObj.y1+"\">\n\t\t\t\t</state>\n";
//	System.out.println("start Position: " + grfxObj.x1 + "," + grfxObj.y1);
	//Closing line for an State element
	
	return MAML;
	
}
public String getName() {
	return "StartState";
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void move(int x, int y) {
	grfxObj.move(x,y);
}
/**
 * This method was created in VisualAge.
 * @param g java.awt.Graphics
 */
public void print(java.awt.Graphics g) {
			
	grfxObj.paint(g);
	
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void resize(int x, int y) {
}
/**
 * Insert the method's description here.
 * Creation date: (1/29/01 4:43:34 PM)
 * @param keynum int
 */
public void setKey(int keynum) {
	setKey(ukh + keynum);
}
/**
 * Insert the method's description here.
 * Creation date: (4/11/00 3:41:10 PM)
 * @param x int
 * @param y int
 */
public void setPos(int x, int y) {
	if(x>0&&y>0){
		grfxObj.set(x,y);
	}
/*	grfxObj.x1 = x;
	grfxObj.y1 = y;
	grfxObj.center_x = x;
	grfxObj.center_y = y;
	*/}
}
