package system;

import java.util.*;
/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
public class ATstate extends ATtableElement{
	private String action;
	private Vector actions = new Vector();
	
	// graphics info	
	private ATstateGRFX grfxObj;

	private static final String ukh = "state@";
//	public boolean corner = false;
	
/**
 * ATstate constructor comment.
 */
public ATstate(String[] tokens, double v, ATsystem sys) {
	super(v);
	grfxObj = new ATstateGRFX();
	//Constitute Object

	//initializing variables used in parsing
	String currenttoken = null;
	
		
  //Code for constructing object model from MAML tokens
  if (v>=1) {
	int loc = ATtokenOps.findnextinstanceof("name",tokens,0);
	setName(tokens[loc+3]);
	loc  = ATtokenOps.findnextinstanceof("key", tokens, loc);
	if(loc != -1) {
		setKey(tokens[loc+3]);
	} else {
		setKey(ukh + sys.getNextKey());
	}

	int loc2 = ATtokenOps.findnextinstanceof("action", tokens, loc);
	while(loc2 != -1){
		loc2 +=3;
		currenttoken = (tokens[loc2].equals("\"") ? "" : tokens[loc2]);
		addAction(currenttoken);
		loc2 = ATtokenOps.findnextinstanceof("action", tokens, loc2);
	}
	grfxObj.setAction(actions);
	//Get agent coordinates for graphics display
		loc  = ATtokenOps.findnextinstanceof("view", tokens, loc);
		int x = Integer.parseInt(tokens[loc+5]);
		int y = Integer.parseInt(tokens[loc+11]);
		int h = Integer.parseInt(tokens[loc+17]);
		int w = Integer.parseInt(tokens[loc+23]);	
	setCoordinates(x,y,h,w);	
  }
  //End Constitute
}
//	public boolean corner = false;
	
/**
 * ATstate constructor comment.
 */
public ATstate(double v, int keynum) {
	super(v);
	setKey(ukh + keynum);
	grfxObj = new ATstateGRFX();
}
//	public boolean corner = false;
	
/**
 * ATstate constructor comment.
 */
public ATstate(String maml, double v, ATsystem sys) {
	this(ATtokenOps.parseLine(maml),v,sys);
}
//	public boolean corner = false;
	
/**
 * ATstate constructor comment.
 */
public ATstate(ATstate cp) {
	super(cp);
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void addAction(String a) {
	actions.addElement(a);
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public boolean checkSelected(int x, int y) {
	corner = false;
	if(grfxObj.dist(x,y)) {
	//	notSelected = false;
		return false;
	} else {
	//	notSelected = true;
		return true;
	}
}
/**
 * This method was created in VisualAge.
 * @param g java.awt.Graphics
 */
public void draw(java.awt.Graphics g) {
	//grfxObj.drawObject(g);
	if(errorSelected){
		grfxObj.drawError(g);
	}
	grfxObj.drawObject(g);
	if((Selected)||(corner)){
		grfxObj.drawSelected(g);
	}
	/*if(errorSelected) {
		grfxObj.drawError(g);
	}*/
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public Vector getActions() {
	return actions;
}
/**
 * This method was created in VisualAge.
 * @return system.ATagentGRFX
 */
public Square getGrfx() {
	return grfxObj;
}
/**
 * Insert the method's description here.
 * Creation date: (10/20/99 2:34:51 PM)
 */
public String getMAML() throws NullPointerException {
	String hold="";
	Enumeration actions = returnActions();
	
	//Opening line for an State element
	MAML = "";
	MAML += "\t\t\t\t<state";
	MAML += " name=\"" + name + "\"";
//	MAML += " action=\"" + action + "\">\n";

	
	MAML += " key=\"" + getKey() + "\"";
	
	while(actions.hasMoreElements()){
		hold=(String)actions.nextElement();;
		MAML+=" action=\"" + hold + "\"";//Temporary fix
	}
	MAML+="/>\n";
	
	int[] c = grfxObj.getCoords();
	MAML += "\t\t\t\t\t<view";
	MAML += " x=\"" + c[0] + "\"";
	MAML += " y=\"" + c[1] + "\"";
	MAML += " w=\"" + c[2] + "\"";
	MAML += " h=\"" + c[3] + "\"/>\n";
	MAML += "\t\t\t\t</state>\n";
	//Closing line for an State element

	return MAML;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getName() {
	return name;
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void move(int x, int y) {
	grfxObj.move(x,y);
}
/**
 * This method was created in VisualAge.
 * @param g java.awt.Graphics
 */
public void print(java.awt.Graphics g) {
	//grfxObj.drawObject(g);
	
	grfxObj.paint(g);
	
	/*if(errorSelected) {
		grfxObj.drawError(g);
	}*/
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void resize(int x, int y) {
	grfxObj.resize(x,y);
	grfxObj.resizeLoop(0);
	
}
/**
 * Insert the method's description here.
 * Creation date: (3/14/00 3:13:33 PM)
 */
public Enumeration returnActions() {
	return actions.elements();
	}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setAction(String s) {
	if (grfxObj == null) {
		grfxObj = new ATstateGRFX();
	}

	actions.add(s);
	grfxObj.setAction(actions);
}
/**
 * Insert the method's description here.
 * Creation date: (2/24/00 10:24:31 AM)
 * @param list java.util.Vector
 */
public void setActions(Vector list) {
	actions = list;
	grfxObj.setAction(actions);
}
/**
 * This method was created in VisualAge.
 */
public void setCoordinates(int x, int y, int width, int height) {
	if (grfxObj == null) {
		grfxObj = new ATstateGRFX();
	}
	grfxObj.place(x,y,width,height);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setName(String s) {
	if (grfxObj == null) {
		grfxObj = new ATstateGRFX();
	}

	name = ATtokenOps.validName(s);
	grfxObj.setName(name);
	grfxObj.resetMax();
}
/**
 * This method was created in VisualAge.
 * @return int
 */
public int transitionCount() {
	return grfxObj.lineCount();
}
public void updateText() {

	grfxObj.setName(this.getName());
	grfxObj.setAction(this.getActions());
}
}
