package system;

import java.util.*;
/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
public class ATstatetable extends ATobject{
	private   ATagent    agent;
	protected Vector     transitionTable;
	protected Vector     stateTable;
	protected ATstartState start;
	protected ATendState end;
	public 	  String 	 ownername;
	public    String     agentname;
	private static final String ukh = "statetable@";
/**
 * ATstatetable constructor comment.
 */
public ATstatetable(double v, String[] tokens, ATsystem sys) {
	this(v,0);
	//initializing variables used in parsing

	int  location=0;
	ATstate state=null;
	
  //Code for constructing object model from MAML tokens
 // if (v==version) {
	//The following if accounts for loading a conv from the KB but keeping agents involved constant  
	if (agent==null) ownername=tokens[6];

	boolean keybased = false;
	int loc  = ATtokenOps.findnextinstanceof("key", tokens, 6);
	if(loc != -1) {
		String key = tokens[loc+3];
		setKey(key);
		int pos = key.indexOf('@');
		int keynum = 0;
		try {
			keynum = Integer.parseInt(key.substring(pos+1, key.length()));
		} catch (NumberFormatException e) {}
			
		start.setKey(keynum);
		end.setKey(keynum);
		
		keybased = true;
	} else {
		int keynum = sys.getNextKey();
		setKey(ukh + keynum);
		start.setKey(keynum);
		end.setKey(keynum);
	}

	ATagent a1;
	Enumeration agents = sys.returnAgents();
	while(agents.hasMoreElements()){
		a1 = (ATagent)agents.nextElement();
		if(keybased) {
			if(a1.getKey().equals(ownername)){ setAgent(a1);}
		} else {
			if(a1.getName().equals(ownername)){ setAgent(a1);}
		}
	}
	
	
	//Now we find each state (not start or endstate though)
	for(int i=9;i<tokens.length;++i) {
	   if (tokens[i].equals("state")) {
		  location=ATtokenOps.findnextinstanceof("/state", tokens, i);
		  String[] submaml = ATtokenOps.subTokens(tokens,(i-1),(location+1));

	//add start & end and other states to stateTable
	//add start & end and other states GRFX info
	   	if (!((tokens[i+5].equals("StartState"))||(tokens[i+5].equals("EndState")))){

	   	addState(new ATstate(submaml, v, sys));
	   	} else if (tokens[i+5].equals("StartState")){
		   	if(v>1){
				location=ATtokenOps.findnextinstanceof("/state", tokens, i);
		 		submaml=ATtokenOps.subTokens(tokens,(i-1),(location+1));
				start.decodeMAML(submaml);
		   	}
	 	} else if (tokens[i+5].equals("EndState")){
			if(v>1){
				location=ATtokenOps.findnextinstanceof("/state", tokens, i);
		 		submaml=ATtokenOps.subTokens(tokens,(i-1),(location+1));
				end.decodeMAML(submaml);
		   	}
		}
	   }
	}

	//Then we find each transistion
	for(int i=9;i<tokens.length;++i) {
		//ATtableElement cs=null;
		//ATtableElement ns=null;
		if (tokens[i].equals("transition")) {
			location=ATtokenOps.findnextinstanceof("/", tokens, i);
			String[] submaml=ATtokenOps.subTokens(tokens,(i-1),(location+1));
			ATtransition trans = new ATtransition(submaml, v, this, sys);
			addTransition(trans);
			/*if (trans.getCurrentState()==null || trans.getCurrentStateName()=="StartState" || trans.getCurrentStateName()=="EndState") {
				cs = findStatebyname(trans.getCurrentStateName());
			}
			if (trans.getNextState()==null || trans.getNextStateName()=="StartState" || trans.getNextStateName()=="EndState") {
				ns = findStatebyname(trans.getNextStateName()); 
			}*/		 
			//trans.setCoordinates(cs,ns); 
	   }
	}
 // }
}
/**
 * ATstatetable constructor comment.
 */
public ATstatetable(double v, int keynum) {
	super(v);
	setKey(ukh + keynum);
	transitionTable = new Vector();
	stateTable =      new Vector();
	start = new ATstartState(v,keynum);
	end =   new ATendState(v,keynum);
	this.addState(start);
	this.addState(end);
}
/**
 * ATstatetable constructor comment.
 */
public ATstatetable(double v, String s, ATsystem sys) {
	this(v,ATtokenOps.parseLine(s),sys);
}
/**
 * ATstatetable constructor comment.
 */
public ATstatetable(ATagent a, double v, int keynum) {
	this(v,keynum);
	agent = a;
	ownername=agent.getKey();
}
/**
 * ATstatetable constructor comment.
 */
public ATstatetable(ATstatetable cp) {
	super(cp);
}
/**
 * This method was created in VisualAge.
 * @param t afit.system.ATtransition
 */
public void addState(ATtableElement s) {
	stateTable.addElement(s);
}
/**
 * This method was created in VisualAge.
 * @param t afit.system.ATtransition
 */
public void addTransition(ATtransition t) {
	transitionTable.addElement(t);
}
/**
 * Insert the method's description here.
 * Creation date: (2/1/00 10:25:04 AM)
 */
public void clear() {
/*	Enumeration trans = transitionTable.elements();
	Enumeration states = stateTable.elements();

	ATtransition tran;
	ATtableElement state;

	while(trans.hasMoreElements()){
		tran = (ATtransition)trans.nextElement();
		removeTransition(tran);
	}
	while(states.hasMoreElements()){
		state = (ATtableElement)states.nextElement();
		removeState(state);
	}*/

	transitionTable.removeAllElements();
	
	int size = stateTable.size();
	for(int i= 2; i<size; i++){
		stateTable.removeElementAt(2);
	}
}
/**
 * This method was created in VisualAge.
 */
public void draw(java.awt.Graphics g) {
	java.util.Enumeration Estate = stateTable.elements();
	java.util.Enumeration Etransition = transitionTable.elements();
	
	while (Estate.hasMoreElements())
	{
		((ATtableElement)Estate.nextElement()).draw(g);
	}
	
	while (Etransition.hasMoreElements())
	{
		((ATtransition)Etransition.nextElement()).draw(g);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (10/22/99 3:10:54 PM)
 */
public ATtableElement findStatebykey(String key) {
	if (stateTable == null) {
		return null;
	}
	ATtableElement state = null;
	Enumeration states = stateTable.elements();
	while(states.hasMoreElements()){
		state = (ATtableElement)states.nextElement();
		if (state.getKey().equals(key)) return (ATtableElement)state;
	}	
	return null;
}
/**
 * Insert the method's description here.
 * Creation date: (10/22/99 3:10:54 PM)
 */
public ATtableElement findStatebyname(String name) {
	if (stateTable == null) {
		return null;
	}
	ATtableElement state = null;
	Enumeration states = stateTable.elements();
		while(states.hasMoreElements()){
		   state = (ATtableElement)states.nextElement();
		   if(state.getName()!=null){
			   if (state.getName().equals(name)) return (ATtableElement)state;
		   }
	}	
	return null;
}
/**
 * Insert the method's description here.
 * Creation date: (1/30/01 9:58:07 AM)
 * @return system.ATendState
 */
public ATendState getEndClone() {
	ATendState endClone = end;
	return endClone;
}
/**
 * Insert the method's description here.
 * Creation date: (10/20/99 1:16:11 PM)
 */
public String getMAML() throws Exception {
	Enumeration states = returnStates();
	Enumeration trans  = returnTrans();
	ATstate state;
	ATtransition tran;
	MAML="";
	//Opening line for an Statetable element			
	MAML+="\t\t\t<statetable";
	ownername=getParticipantKey();
	MAML+=" owner=\""+ownername+"\">\n";
	
	MAML += " key=\"" + getKey() + "\"";
	
	//Opening line for an State elements
	while(states.hasMoreElements()){
		MAML+= ((ATtableElement)states.nextElement()).getMAML();
	}
	//Opening line for an Transition elements
	while(trans.hasMoreElements()){
		tran = (ATtransition)trans.nextElement();
		if (!((tran.getNextState()==null) || (tran.getCurrentState()==null))) {
			MAML+=tran.getMAML();
		}
		else System.out.println("Transition w/o current or next state encountered, not encoding it...");
	}	
	//Closing line for an Statetable element	
	MAML+="\t\t\t</statetable>\n";

	return MAML;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public ATagent getParticipant() {
	return agent;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getParticipantKey() {
	if (agent!=null)
	   return agent.getKey();
	else 
	return ownername;
}
/**
 * Insert the method's description here.
 * Creation date: (1/31/01 3:04:28 PM)
 * @return java.lang.String
 */
public String getParticipantName() {
	if (agent!=null)
	   return agent.getName();
	else 
	return ownername;
}
/**
 * Insert the method's description here.
 * Creation date: (1/30/01 9:56:46 AM)
 * @return system.ATstartState
 */
public ATstartState getStartClone() {
	ATstartState startClone = start;
	return startClone;
}
/**
 * Insert the method's description here.
 * Creation date: (1/19/01 1:48:05 PM)
 * @return int
 */
public int getStateCount() {
	return stateTable.size();
}
/**
 * This method was created in VisualAge.
 */
public void print(java.awt.Graphics g) {
	java.util.Enumeration Estate = stateTable.elements();
	java.util.Enumeration Etransition = transitionTable.elements();
	
	while (Estate.hasMoreElements())
	{
		((ATtableElement)Estate.nextElement()).print(g);
	}
	
	while (Etransition.hasMoreElements())
	{
		((ATtransition)Etransition.nextElement()).print(g);
	}
}
/**
 * This method was created in VisualAge.
 * @param t system.ATtransition
 */
public void removeState(ATtableElement s) {
	stateTable.removeElement(s);
}
/**
 * This method was created in VisualAge.
 * @param t system.ATtransition
 */
public void removeTransition(ATtransition t) {
	transitionTable.removeElement(t);
	t.deleteMe();
}
/**
 * Insert the method's description here.
 * Creation date: (12/14/00 2:03:26 PM)
 * @return boolean
 * @param s java.lang.String
 */
public boolean repeatName(String s) {
	Enumeration enum = stateTable.elements();
	while(enum.hasMoreElements()) {
		ATtableElement state = (ATtableElement)enum.nextElement();
		if(s == state.getName());
		else if(s.equals(state.getName())) return true;
	}
	return false;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Enumeration
 */
public java.util.Enumeration returnStates() {
	if (stateTable == null) {
		return null;
	}
	java.util.Enumeration StatesEnum = stateTable.elements();
	return StatesEnum;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Enumeration
 */
public java.util.Enumeration returnTrans() {
	if (transitionTable == null) {
		return null;
	}
	java.util.Enumeration TransEnum = transitionTable.elements();
	return TransEnum;
}
/**
 * Insert the method's description here.
 * Creation date: (3/9/00 9:48:02 AM)
 * @param a system.ATagent
 */
public void setAgent(ATagent a) {
	agent = a;
	}
/**
 * This method was created in VisualAge.
 * @param a system.ATagent
 */
public void setParticipant(ATagent a) {
	agent = a;
	ownername=a.getKey(); //needed for MAML reconstruct?
}
}
