package system;

import java.util.*;
/**
 * main system of agentTool
 * it stores EVERYTHING
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
import java.util.Vector;

public class ATsystem extends ATobject{

	private Vector agents;
	private Vector conversations;
	private Vector roles;
	private Vector tasks;
	private Vector protocols;
	private Vector goals;
	private Vector useCases;
	private Vector agentInstances;
	private Vector agentConn;
	private Vector systems;
	private int goalNum = 0;
	// constants
	public static final int INITIATOR = 1;
	public static final int RESPONDER = 2;

	private int keymarker = 0;

	public Editor.TextWindow display = null;
/**
 * ATsystem constructor comment.
 */
public ATsystem(double i) {
	super(i);
	MAMLheader+="<!DOCTYPE mas SYSTEM \"atsystem"+Double.toString(getVersion())+".dtd\">\n";

	setKey("system@000");
	
	tasks = new Vector();
	goals = new Vector();
	roles = new Vector();
	agents = new Vector();
	useCases = new Vector();
	protocols = new Vector();
	conversations = new Vector();
	agentInstances = new Vector();
	agentConn = new Vector();
	systems = new Vector();
	
}
/**
 * ATsystem constructor comment.
 */
public ATsystem(double ver, String x) {
	this(ver);
	goalNum = 0;
	reConstruct(x);
}
/**
 * ATsystem constructor comment.
 */
public ATsystem(double ver, String x, Editor.TextWindow display) {
	this(ver);
	goalNum = 0;
	this.display = display;
	reConstruct(x);
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void addAgent(ATagent a) {
	agents.addElement(a);
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void addAgentComponent(ATagent a, ATagentComponent c) {
	a.addComponent(c);
}
/**
 * Insert the method's description here.
 * Creation date: (6/29/00 3:20:07 PM)
 * @param conv afit.system.ATconversation2
 */
public void addAgentConn(ATconversation2 conv) {
	agentConn.add(conv);}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void addAgentInstance(ATagent2 a) {
	agentInstances.addElement(a);
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void addConvs(ATconversation c) {
	conversations.addElement(c);
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void addConvsState(ATconversation c, int InitiatorOrResponder, ATstate s) {
	(c.getStateTable(InitiatorOrResponder)).addState(s);
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void addConvsTransition(ATconversation c, int InitOrResp, ATtransition t) {
	(c.getStateTable(InitOrResp)).addTransition(t);
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void addConvsTransition(ATconversation c, ATagent a, ATtransition t) {
	(c.getParticipant(a)).addTransition(t);
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void addGoal(ATGoal g) {
	goals.addElement(g);
	goalNum++;
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void addProtocol(ATProtocol p) {
	protocols.addElement(p);
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void addRole(ATRole r) {
	roles.addElement(r);
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void addSystem(ATsys a) {
	systems.addElement(a);
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void addTask(ATTask t) {
	tasks.addElement(t);
}
/**
 * Insert the method's description here.
 * Creation date: (6/14/00 9:35:40 AM)
 * @param uC afit.system.ATuseCase
 */
public void addUseCase(ATuseCase uC) {
	useCases.addElement(uC);
}
/**
 * Insert the method's description here.
 * Creation date: (10/25/99 11:03:31 PM)
 */
public void constructFromV1(String[] tokens) {

  System.out.println("Loading from version 1 ASML/System model");	
  if(display != null) display.append("  * Loading from version 1 ASML/System model\n");
  
  String[] submaml;
  int loc = ATtokenOps.findnextinstanceof("mas",tokens,0);
  loc = ATtokenOps.findnextinstanceof("name",tokens,loc);
  
	name=tokens[loc+3];
	if(name.equals("\"")) { name = "null"; }
	
	int start=ATtokenOps.findnextinstanceof("description", tokens, loc+4);
	loc=ATtokenOps.findnextinstanceof("/description", tokens, start+3);
	description=ATtokenOps.extract(tokens,(start+2), (loc-2));

	loc = ATtokenOps.findnextinstanceof("framework",tokens,loc);
  	String framework = tokens[loc+5];

	int loc2 = ATtokenOps.findnextinstanceof("keymarker", tokens, loc);
	if(loc2 > 0) {
		try {
			keymarker = Integer.parseInt(tokens[loc2 + 3]);
		} catch (NumberFormatException e) {}
	}
	
	if(display != null) display.append("        - loading goals\n");
	
	for(int i=(loc+5);i<tokens.length;++i){
		if(tokens[i].equals("goal") && tokens[i-1].equals("<")){
			loc=ATtokenOps.findnextinstanceof("/goal",tokens, i);
			submaml=ATtokenOps.subTokens(tokens,(i-1),(loc+1));
			ATGoal goal = new ATGoal(version,submaml,this);
			addGoal(goal);
			i = loc;
		}
	}

	if(display != null) display.append("        - linking secondary parents\n");
	
	for(int i=0; i<goals.size(); i++) {
		ATGoal goal = (ATGoal)goals.elementAt(i);
		goal.linkSecondaryParents(this);
	}
	
	if(display != null) display.append("        - loading roles\n");
	
	for(int i=(loc+2);i<tokens.length;++i){
		if(tokens[i].equals("role") && tokens[i-1].equals("<")){
			loc=ATtokenOps.findnextinstanceof("/role",tokens, i);
			submaml=ATtokenOps.subTokens(tokens,(i-1),(loc+1));
			ATRole role = new ATRole(version,submaml, this);
			addRole(role);
			i = loc;
		}
	}

	if(display != null) display.append("        - loading use cases\n");
	
	for(int i=(loc+2);i<tokens.length;++i){
		if(tokens[i].equals("useCase") && tokens[i-1].equals("<")){
			loc=ATtokenOps.findnextinstanceof("/useCase",tokens, i);
			submaml=ATtokenOps.subTokens(tokens,(i-1),(loc+1));
			ATuseCase useCase = new ATuseCase(submaml,this, version);
			addUseCase(useCase);
			i = loc;
		}
	}
	
	if(display != null) display.append("        - loading tasks\n");
	
	for(int i=(loc+2);i<tokens.length;++i){
		if(tokens[i].equals("task") && tokens[i-1].equals("<")){
			loc=ATtokenOps.findnextinstanceof("/task",tokens, i);
			submaml=ATtokenOps.subTokens(tokens,(i-1),(loc+1));
			ATTask task = new ATTask(version,submaml,this);
			addTask(task);
			i = loc;
			}
	}

	if(display != null) display.append("        - loading protocols\n");
	
	for(int i=(loc+2);i<tokens.length;++i){
		if(tokens[i].equals("protocol") && tokens[i-1].equals("<")){
			loc=ATtokenOps.findnextinstanceof("/protocol",tokens, i);
			submaml=ATtokenOps.subTokens(tokens,(i-1),(loc+1));
			ATProtocol prot = new ATProtocol(version,submaml,this);
			addProtocol(prot);
			i = loc;
		}
	}
	
	if(display != null) display.append("        - loading agents\n");
	
	for(int i=(loc+2);i<tokens.length;++i) {
	   if (tokens[i].equals("agent") && tokens[i-1].equals("<")) {
		  loc = ATtokenOps.findnextinstanceof("/agent", tokens, i);
		  submaml=ATtokenOps.subTokens(tokens,(i-1), (loc+1));
		  ATagent agent = new ATagent(version,submaml,this);
		  addAgent(agent);
		  i = loc;
	   }
	}   
	
	if(display != null) display.append("        - loading conversations\n");
	
	for(int i=(loc+2);i<tokens.length;++i) {
	   if (tokens[i].equals("conversation") && tokens[i-1].equals("<")) {
		  loc=ATtokenOps.findnextinstanceof("/conversation", tokens, i);
		  submaml=ATtokenOps.subTokens(tokens,(i-1), (loc+1));
		  ATconversation conv = new ATconversation(version, submaml, this);
		  addConvs(conv);
		  i = loc;
	   }
	}
	
	if(display != null) display.append("        - loading secondary agents\n");
	
	for(int i=(loc+2); i<tokens.length;++i) {
		if(tokens[i].equals("agent2") && tokens[i-1].equals("<")){
			loc = ATtokenOps.findnextinstanceof("/agent2",tokens,i);
			submaml=ATtokenOps.subTokens(tokens,(i-1),(loc+1));
			ATagent2 agent2 = new ATagent2(version,submaml,this);
			addAgentInstance(agent2);
			i = loc;
		}
	}
	
	if(display != null) display.append("        - loading secondary conversations\n");
	
	for(int i=(loc+2); i<tokens.length;++i) {
		if(tokens[i].equals("conversation2") && tokens[i-1].equals("<")){
			loc = ATtokenOps.findnextinstanceof("/conversation2",tokens,i);
			submaml = ATtokenOps.subTokens(tokens,(i-1),(loc+1));
			ATconversation2 conv2 = new ATconversation2(version,submaml,this);
			addAgentConn(conv2);
			i = loc;
		}
	}
	
	if(display != null) display.append("        - loading deployment systems\n");
	
	for(int i=(loc+2); i<tokens.length; ++i){
		if(tokens[i].equals("sys") && tokens[i-1].equals("<")){
			loc = ATtokenOps.findnextinstanceof("/sys",tokens,i);
			submaml = ATtokenOps.subTokens(tokens,(i-1),(loc+1));
			ATsys sys = new ATsys(version,submaml,this);
			addSystem(sys);
			i = loc;
		}
	}
  //Linking agents to statetables
  //Need to enumerate through conversations and assign agents to statetables by matching the 'agentname' 
	Enumeration convs  = returnConvs();
	ATagent i=null;
	ATagent r=null;
	ATagent temp;
	ATconversation conv;
	String name = null;
	ATstatetable table =null;
  //This needs to take each conversation and pass the initiator and responder agents to the place() method	

  	if(display != null) display.append("        - linking statetables\n");
	
		while(convs.hasMoreElements()){
			conv=(ATconversation)convs.nextElement();
			String iname = conv.getInitiatorKey();			
			String rname = conv.getResponderKey();
			Enumeration agnts = returnAgents();
			while(agnts.hasMoreElements()){
			     temp = (ATagent)agnts.nextElement();
			     if (temp.getKey().equals(iname)) i=temp;  
			     if (temp.getKey().equals(rname)) r=temp;
			}
	//		conv.setCoordinates2(i,r);
		}
		
  System.out.println("End of System parsing at token #"+(loc+4)+" of "+tokens.length);	
  System.out.println("Last 4 tokens were: "+ATtokenOps.extract(tokens,(loc+1), (loc+4)));	
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void deleteAgent(ATagent a) {
	
	agents.removeElement(a);
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void deleteAgentConn(ATconversation2 c) {
	
	agentConn.removeElement(c);
	c.deleteMe();
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void deleteAgentInstance(ATagent2 a) {
	
	agentInstances.removeElement(a);
	a.deleteMe();
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void deleteConvs(ATconversation c) {
	
	conversations.removeElement(c);
	c.deleteMe();
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void deleteGoal(ATGoal g) {
	goals.removeElement(g);
	g.deleteMe();
	goalNum--;
	renumberGoals();
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void deleteProt(ATProtocol p) {
	
	protocols.removeElement(p);
	p.deleteMe();
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void deleteRole(ATRole r) {
	
	roles.removeElement(r);
	r.deleteMe();
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void deleteSystem(ATsys s) {
	
	systems.removeElement(s);
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
public void deleteTask(ATTask t) {
	
	tasks.removeElement(t);
	t.deleteMe();
}
/**
 * Insert the method's description here.
 * Creation date: (6/14/00 9:35:40 AM)
 * @param uC afit.system.ATuseCase
 */
public void deleteUseCase(ATuseCase uC) {
	useCases.removeElement(uC);
}
/**
 * Insert the method's description here.
 * Creation date: (10/20/99 1:15:38 PM)
 */
public void encodeDataDict() {
	Enumeration useCases = returnUseCases();
	Enumeration goals = returnGoals();
	Enumeration roles = returnRoles();
	Enumeration tasks = returnTasks();
	Enumeration protocols = returnProtocols();
	Enumeration agents = returnAgents();
	Enumeration convs  = returnConvs();
	Enumeration agentInstances = returnAgentInstances();
	Enumeration agentConn = returnAgentConns();
	Enumeration systems = returnSystems();
	Enumeration seqDiags;
	Vector sD = new Vector();
	
	ATuseCase useCase;
	ATseqDiag seqDiag;
	ATGoal goal;
	ATagent agent;
	ATconversation conv;
	ATTask task;
	ATRole role;
	ATProtocol protocol;
	ATagent2 agent2;
	ATconversation2 aConn;
	ATsys system;

	MAML="Data Dictionary\n\n\n";
	MAML+= "GOALS\n";
	while(goals.hasMoreElements()){
		goal = (ATGoal)goals.nextElement();
		MAML+= "Goal " + goal.getNum() + "\n";
		goal.writeDATA();
		MAML+=goal.getDATA();
		MAML+= "\n";
	}
	MAML+= "\nUSE CASES\n";
	while(useCases.hasMoreElements()){
		useCase = (ATuseCase)useCases.nextElement();
		seqDiags = useCase.getSeqDiags().elements();
		while(seqDiags.hasMoreElements()){
			seqDiag = (ATseqDiag)seqDiags.nextElement();
			sD.add(seqDiag);
		}
		MAML+= "Use Case: " + useCase.getName() + "\n";
		useCase.writeDATA();
		MAML+=useCase.getDATA();
		MAML+="\n";
	}
	MAML+= "\nSEQUENCE DIAGRAMS\n";
	seqDiags = sD.elements();
	while(seqDiags.hasMoreElements()){
		seqDiag = (ATseqDiag)seqDiags.nextElement();
		seqDiag.writeDATA();
		MAML+="Sequence Diagram: " + seqDiag.getName() + "\n";
		MAML+=seqDiag.getDATA();
		MAML+="\n";
	}
	MAML+= "\nROLES\n";
	while(roles.hasMoreElements()){
		role = (ATRole)roles.nextElement();
		role.writeDATA();
		MAML+="Role: " + role.getName() + "\n";
		MAML+=role.getDATA();
		MAML+="\n";
	}
	MAML+="\nTASKS\n";
	while(tasks.hasMoreElements()){
		task = (ATTask)tasks.nextElement();
		task.writeDATA(this.protocols);
		MAML+="Task: " + task.getName() + "\n";
		MAML+=task.getDATA();
		MAML+="\n";
	}
	MAML+="\nPROTOCOLS\n";
	while(protocols.hasMoreElements()){
		protocol = (ATProtocol)protocols.nextElement();
		protocol.writeDATA();
		MAML+="Protocol: " + protocol.getName() + "\n";
		MAML+=protocol.getDATA();
		MAML+="\n";
	}
	MAML+="\nAGENTS\n";
	while(agents.hasMoreElements()){
		agent = (ATagent)agents.nextElement();
		agent.writeDATA(this.conversations);
		MAML+= "Agent: " + agent.getName() + "\n";
		MAML+=agent.getDATA();
		MAML+="\n";
	}
	//Look through and encode then get constituent conversation MAML code
	MAML+="\nCONVERSATIONS\n";
	while(convs.hasMoreElements()){
		conv = (ATconversation)convs.nextElement();
		conv.writeDATA();
		MAML+="Conversation: " + conv.getName() + "\n";
		MAML+=conv.getDATA();
		MAML+="\n";
	}
	MAML+="\nAGENT INSTANCES\n";
	while(agentInstances.hasMoreElements()){
		agent2 = (ATagent2)agentInstances.nextElement();
		agent2.writeDATA(this.agentConn);
		MAML+="AgentInstance: " + agent2.getName() + "\n";
		MAML+=agent2.getDATA();
		MAML+="\n";
	}
	MAML+="\nSYSTEMS\n";
	while(systems.hasMoreElements()){
		system = (ATsys)systems.nextElement();
		system.writeDATA();
		MAML+="System: " + system.getName() + "\n";
		MAML+=system.getDATA();
		MAML+="\n";
	}
	//Closing line for an MAS element
	MAML+= "The End";
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public int getAgentCount() {
	return agents.size();
}
/**
 * Insert the method's description here.
 * Creation date: (12/7/00 5:38:01 PM)
 * @return int
 */
public int getAgentInstanceCount() {
	return agentInstances.size();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public int getConvCount() {
	return conversations.size();
}
/**
 * Insert the method's description here.
 * Creation date: (6/26/00 2:27:01 PM)
 * @return int
 */
public int getGoalNum() {
	return goalNum;
}
/**
 * Insert the method's description here.
 * Creation date: (10/20/99 1:15:38 PM)
 */
public String getMAML() throws Exception {

	Enumeration useCases = returnUseCases();
	Enumeration goals = returnGoals();
	Enumeration roles = returnRoles();
	Enumeration tasks = returnTasks();
	Enumeration protocols = returnProtocols();
	Enumeration agents = returnAgents();
	Enumeration convs  = returnConvs();
	Enumeration agentInstances = returnAgentInstances();
	Enumeration agentConn = returnAgentConns();
	Enumeration systems = returnSystems();
	
	ATuseCase useCase;
	ATGoal goal;
	ATagent agent;
	ATconversation conv;
	ATTask task;
	ATRole role;
	ATProtocol protocol;
	ATagent2 agent2;
	ATconversation2 aConn;
	ATsys system;
	super.MAMLheader="<?xml version=\""+Double.toString(version)+"\"?>\n";
	MAMLheader+="<!DOCTYPE mas SYSTEM \"atsystem"+Double.toString(version)+".dtd\">\n\n";

	MAML=MAMLheader;
	//Opening line for an Multi Agent System element
	MAML+="<mas";
	MAML+=" version=\"" + Double.toString(version) + "\"";
	MAML+=" name=\"" + ((name==null)? "null" : name )+ "\">\n";
	//New Line for Description element
	MAML+="<description>\n";
	MAML+=getDescription();
	MAML+="\n</description>\n";
	//New Line for Framework element
	MAML+="<framework name=\"agentMOM\"/>\n";	

	// Used key index, necessary for data integrity.  This value allows for unique
	// key generation for each ATobject.
	MAML+="<keymarker=\"" + keymarker + "\"/>\n";	
	
	
	//Look through and encode then get constituent agent MAML code
		
	while(goals.hasMoreElements()){
		goal = (ATGoal)goals.nextElement();
		MAML+=goal.getMAML();
	}
	while(roles.hasMoreElements()){
		role = (ATRole)roles.nextElement();
		MAML+=role.getMAML();
	}
	while(useCases.hasMoreElements()){
		useCase = (ATuseCase)useCases.nextElement();
		MAML+=useCase.getMAML();
	}
	while(tasks.hasMoreElements()){
		task = (ATTask)tasks.nextElement();
		MAML+=task.getMAML();
	}
	while(protocols.hasMoreElements()){
		protocol = (ATProtocol)protocols.nextElement();
		MAML+=protocol.getMAML();
	}
	while(agents.hasMoreElements()){
		agent = (ATagent)agents.nextElement();
		String agentmaml = agent.getMAML();
		MAML+=agentmaml;
	}
	//Look through and encode then get constituent conversation MAML code
	while(convs.hasMoreElements()){
		conv = (ATconversation)convs.nextElement();
		MAML+=conv.getMAML();
	}
	while(agentInstances.hasMoreElements()){
		agent2 = (ATagent2)agentInstances.nextElement();
		MAML+=agent2.getMAML();
	}
	while(agentConn.hasMoreElements()){
		aConn = (ATconversation2)agentConn.nextElement();
		MAML+=aConn.getMAML();
	}
	while(systems.hasMoreElements()){
		system = (ATsys)systems.nextElement();
		MAML+=system.getMAML();
	}

	//Closing line for an MAS element		
	MAML+="</mas>";
//	System.out.println("\nThis is the MAML text: \n" + MAML);

	return MAML;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getName() {
	return name;
}
/**
 * Insert the method's description here.
 * Creation date: (1/29/01 1:36:37 PM)
 * @return int
 */
public int getNextKey() {
	return keymarker++;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public int getProtocolCount() {
	return protocols.size();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public int getRoleCount() {
	return roles.size();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public int getSystemCount() {
	return systems.size();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public int getTaskCount() {
	return tasks.size();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public int getUseCaseCount() {
	return useCases.size();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Enumeration
 */
public Vector getUseCasesVector() {
	return useCases;
}
/**
 * This method was created in VisualAge.
 * @return java.util.Vector
 */
public java.util.Vector getVerifyVector() {
	java.util.Vector tVec = new java.util.Vector();
	String tTransString = "";

	java.util.Enumeration E = conversations.elements();

	ATconversation tConv = null;
	String tConvName = "";
	String tParticipantName = "";
	String tCurrentState = "";
	String tRecMsg = "";
	String tGuardCondition = "";
	String tTransmitMsg = "";
	String tNextState = "";

	while (E.hasMoreElements()) {
		tConv = (ATconversation)E.nextElement();
		tConvName = tConv.getName();
		
		//initiator
		tParticipantName = "Initiator";
		java.util.Enumeration E1 = (tConv.getStateTable(1)).returnTrans();

		while (E1.hasMoreElements()) {
			ATtransition tTrans = (ATtransition)E1.nextElement();
			
			tCurrentState = tTrans.getCurrentState().getName();
			
			tRecMsg = tTrans.getRecMessage();
			if (tRecMsg == null || tRecMsg.equals("")) {tRecMsg = "null";}
			
			tGuardCondition = tTrans.getGuardCondition();
			if (tGuardCondition == null || tGuardCondition.equals("")) {tGuardCondition = "null";}
			
			tTransmitMsg = tTrans.getTransMessage();
			if (tTransmitMsg == null || tTransmitMsg.equals("")) {tTransmitMsg = "null";}
			
			tNextState = tTrans.getNextState().getName();

			tTransString = 
				tConvName + ";" +
				tParticipantName + ";" +
				tCurrentState + ";" +
				tRecMsg + ";" +
				tGuardCondition + ";" +
				tTransmitMsg + ";" +
				tNextState;
			    
			tVec.addElement(tTransString);
		}
		
		//responder
		tParticipantName = "Responder";
		java.util.Enumeration E2 = (tConv.getStateTable(2)).returnTrans();

		while (E2.hasMoreElements()) {
			ATtransition tTrans = (ATtransition)E2.nextElement();
			
			tCurrentState = tTrans.getCurrentState().getName();
			
			tRecMsg = tTrans.getRecMessage();
			if (tRecMsg == null || tRecMsg.equals("")) {tRecMsg = "null";}
			
			tGuardCondition = tTrans.getGuardCondition();
			if (tGuardCondition == null || tGuardCondition.equals("")) {tGuardCondition = "null";}
			
			tTransmitMsg = tTrans.getTransMessage();
			if (tTransmitMsg == null || tTransmitMsg.equals("")) {tTransmitMsg = "null";}
			
			tNextState = tTrans.getNextState().getName();

			tTransString = 
				tConvName + ";" +
				tParticipantName + ";" +
				tCurrentState + ";" +
				tRecMsg + ";" +
				tGuardCondition + ";" +
				tTransmitMsg + ";" +
				tNextState;
			    
			tVec.addElement(tTransString);
		}
		
	}
	
	return tVec;
}
/**
 * Insert the method's description here.
 * Creation date: (10/28/99 11:05:23 AM)
 */
public void reConstruct(String maml) {
	agents = new Vector();
	conversations = new Vector();

	MAML = maml;
	System.out.println("Tokenizing system MAML");
	if(display != null) display.append("  * Tokenizing system MAML\n");
		
	//Extracting tokens from MAML string
  	String[] tokens = ATtokenOps.parseLine(MAML,display);
	//DO NOT change this part of system ELEMENT  	

	int loc = ATtokenOps.findnextinstanceof("mas",tokens,0);
	loc = ATtokenOps.findnextinstanceof("version",tokens,loc);
	if(loc != -1) {
		double v = Double.parseDouble(tokens[loc+3]);
		//Code for constructing object model from MAML tokens
		if (v>=1) {
			constructFromV1(tokens);
		} else {
			System.out.println("Loading a version other than 1");	
		}
	} else {
		System.out.println("This file is not a valid MAML file");
	}
}
/**
 * Insert the method's description here.
 * Creation date: (12/21/00 4:35:04 PM)
 */
public void removeAllGoals() {
	goalNum=0;
	goals.removeAllElements();
//	g.deleteMe();
	}
/**
 * Insert the method's description here.
 * Creation date: (12/28/00 1:47:26 PM)
 */
public void removeAllProts() {
	protocols.removeAllElements();
	}
/**
 * Insert the method's description here.
 * Creation date: (12/28/00 1:47:11 PM)
 */
public void removeAllRoles() {
	roles.removeAllElements();
	}
/**
 * Insert the method's description here.
 * Creation date: (12/28/00 1:47:48 PM)
 */
public void removeAllTasks() {
	tasks.removeAllElements();
	}
/**
 * Insert the method's description here.
 * Creation date: (6/8/00 3:48:35 PM)
 */
public void renumberGoals() {
	ATGoal root = ((ATGoal)goals.elementAt(0)).root();
	root.setNum("1");
	
	/*Enumeration G = goals.elements();
	ATGoal goal;
	while(G.hasMoreElements()){
		goal = (ATGoal)G.nextElement();
		goal.setSubGoals(0);
	}
	G = goals.elements();
	while(G.hasMoreElements()){
		goal = (ATGoal)G.nextElement();
		goal.setNum();
		goal.setDescription(goal.getDescription());
	}*/
}
/**
 * Insert the method's description here.
 * Creation date: (12/14/00 2:01:10 PM)
 * @return boolean
 * @param s java.lang.String
 */
public boolean repeatName(String s) {
	Enumeration enum = agentInstances.elements();
	Enumeration enum2 = roles.elements();
	Enumeration enum3 = tasks.elements();
	Enumeration enum4 = agents.elements();
	while(enum.hasMoreElements()) {
		ATagent2 agent2 = (ATagent2)enum.nextElement();
		if(s == agent2.getName()) {}
		else if(s.equals(agent2.getName())) return true;
	}	
	while(enum2.hasMoreElements()) {
		ATRole role = (ATRole)enum2.nextElement();
		if(s == role.getName()) {}
		else if(s.equals(role.getName())) return true;
	}
	while(enum3.hasMoreElements()) {
		ATTask task = (ATTask)enum3.nextElement();
		if(s == task.getName()) {}
		else if(s.equals(task.getName())) return true;	
	}
	while(enum4.hasMoreElements()) {
		ATagent agent = (ATagent)enum4.nextElement();
		if(s == agent.getName()) {}
		else if(s.equals(agent.getName())) return true;
	}
	return false;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Enumeration
 */
public java.util.Enumeration returnAgentConns() {
	if (agentConn == null) {
		return null;
	}
	java.util.Enumeration AgentConnsEnum = agentConn.elements();
	return AgentConnsEnum;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Enumeration
 */
public java.util.Enumeration returnAgentInstances() {
	if (agentInstances == null) {
		return null;
	}
	java.util.Enumeration agentInstancesEnum = agentInstances.elements();
	return agentInstancesEnum;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Enumeration
 */
public java.util.Enumeration returnAgents() {
	if (agents == null) {
		return null;
	}
	java.util.Enumeration AgentsEnum = agents.elements();
	return AgentsEnum;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Enumeration
 */
public Vector returnAgentsVector() {
	return agents;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Enumeration
 */
public java.util.Enumeration returnConvs() {
	if (conversations == null) {
		return null;
	}
	Enumeration ConvsEnum = conversations.elements();
	return ConvsEnum;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Enumeration
 */
public java.util.Enumeration returnGoals() {
	if (goals == null) {
		return null;
	}
	java.util.Enumeration GoalsEnum = goals.elements();
	return GoalsEnum;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Enumeration
 */
public Vector returnGoalsVector() {
	return goals;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Enumeration
 */
public java.util.Enumeration returnProtocols() {
	if (protocols == null) {
		return null;
	}
	java.util.Enumeration ProtocolsEnum = protocols.elements();
	return ProtocolsEnum;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Enumeration
 */
public Enumeration returnRoles() {
	if (roles == null) {
		return null;
	}
	java.util.Enumeration RolesEnum = roles.elements();
	return RolesEnum;

}
/**
 * This method was created in VisualAge.
 * @return java.lang.Enumeration
 */
public Vector returnRolesVector() {
	return roles;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Enumeration
 */
public java.util.Enumeration returnSystems() {
	if (systems == null) {
		return null;
	}
	java.util.Enumeration SystemsEnum = systems.elements();
	return SystemsEnum;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Enumeration
 */
public java.util.Enumeration returnTasks() {
	if (tasks == null) {
		return null;
	}
	java.util.Enumeration TasksEnum = tasks.elements();
	return TasksEnum;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Enumeration
 */
public java.util.Enumeration returnUseCases() {
	if (useCases == null) {
		return null;
	}
	java.util.Enumeration useCasesEnum = useCases.elements();
	return useCasesEnum;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setName(String s) {
	name = ATtokenOps.validName(s);
}
}
