package system;

/**
 * Insert the type's description here.
 * Creation date: (6/12/00 10:45:30 AM)
 * @author: 
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */

import java.util.*;

public class ATuseCase extends ATobject{
	private Vector seqDiags = new Vector();
	private static final String ukh = "usecase@";
/**
 * ATagent constructor comment.
 */
public ATuseCase(String[] tokens, ATsystem sys, double v) {
	this(v,0); //*** Version 1 of ATagent ***

	int loc = ATtokenOps.findnextinstanceof("version",tokens,0);
	v=Double.parseDouble(tokens[loc+3]);
	//setVersion(v);
  //Code for constructing object model from MAML tokens
	if (v>=1) constructFromV1(tokens, sys);
	else {
		System.out.println("Loading a version other than 1.");	
	}
 	//	System.out.println("Loaded an agent");
}
/**
 * ATuseCase constructor comment.
 */
public ATuseCase(double i, int keynum) {
	super(i);
	setKey(ukh + keynum);
}
/**
 * ATagent constructor comment.
 */
public ATuseCase(String x, ATsystem sys, double v) {
	this(ATtokenOps.parseLine(x),sys,v);
}
/**
 * ATuseCase constructor comment.
 */
public ATuseCase(ATuseCase cp) {
	super(cp);
}
/**
 * Insert the method's description here.
 * Creation date: (6/12/00 10:52:58 AM)
 * @param sD hold.ATseqDiag
 */
public void addSeqDiag(ATseqDiag sD) {
	seqDiags.add(sD);}
/**
 * Insert the method's description here.
 * Creation date: (10/25/99 11:28:36 PM)
 */
public void constructFromV1(String[] tokens,ATsystem sys) {
	int end = 0;
//	double v = Double.parseDouble(tokens
	int loc = ATtokenOps.findnextinstanceof("name",tokens,0);
	name=tokens[loc+3];
	
	loc  = ATtokenOps.findnextinstanceof("key", tokens, loc);
	if(loc != -1) {
		setKey(tokens[loc+3]);
	} else {
		setKey(ukh + sys.getNextKey());
	}
	
	int start=ATtokenOps.findnextinstanceof("description", tokens, loc+4);
	loc=ATtokenOps.findnextinstanceof("/description", tokens, start+3);
	setDescription(ATtokenOps.extract(tokens,(start+2), (loc-2)));
	for(int i=(loc+2);i<tokens.length;++i){
		if(tokens[i].equals("seqDiag")){
			loc=ATtokenOps.findnextinstanceof("/seqDiag",tokens, i);
			String[] submaml=ATtokenOps.subTokens(tokens,(i-1),(loc+1));
			ATseqDiag seqDiag = new ATseqDiag(version, submaml, sys);
			addSeqDiag(seqDiag);
		}
	}
}
/*	    String submaml=""; 
		int loc=12;
		int end=0;
		double v = Double.parseDouble(tokens[6]);
	//	name = tokens[loc];
		int start=findnextinstanceof("description", tokens, loc+3);
	    loc  = findnextinstanceof("/description", tokens, start+2);
		description=extract(tokens,(start+2), (loc-2));
		//Get agent coordinates for graphics display
		loc = findnextinstanceof("gName",tokens,loc+2);
		String gNum = (String)tokens[loc+3];
		Enumeration goals = sys.returnGoals();
		ATGoal goal;
		while(goals.hasMoreElements()){
			goal = (ATGoal)goals.nextElement();
			if(goal.getNum().equals(gNum)){
				this.goal = goal;
			}
		}
		setGoal(this.goal);
		loc  = findnextinstanceof("view", tokens, loc+2);
		if (loc>0){ //KB-stored agents do not have view information
					//because they appear at a location the operator selects
			int x = Integer.parseInt(tokens[loc+5]);
			int y = Integer.parseInt(tokens[loc+11]);
			int h = Integer.parseInt(tokens[loc+17]);
			int w = Integer.parseInt(tokens[loc+23]);
	//		loc+=25;
			setCoordinates(x,y,h,w);
		}
		loc = findnextinstanceof("n_pts",tokens,loc+2);
		int j = 0;
		if(loc>0){
			j = Integer.parseInt(tokens[loc+3]);
			loc= loc +3;
		}
//		setCoordinates(component1,component2);
		for(int i=0; i<j; i++){
			int k = Integer.parseInt(tokens[loc+6]);
			loc+=6;
			int l = Integer.parseInt(tokens[loc+6]);
			loc+=6;
			grfxCObj.Xs[i]=k;
			grfxCObj.Ys[i]=l;
		}
//		setGoal(this.goal);
//		setName(name);
}*/
/**
 * Insert the method's description here.
 * Creation date: (6/12/00 10:52:58 AM)
 * @param sD hold.ATseqDiag
 */
public void deleteSeqDiag(int index) {
	seqDiags.removeElementAt(index);		
}
/**
 * Insert the method's description here.
 * Creation date: (6/12/00 10:46:39 AM)
 * @return java.lang.String
 */
public String getDescription() {
	return description;
}
/**
 * This method was created in VisualAge.
 */
public String getMAML() throws Exception {
	Enumeration seqDiagrams = seqDiags.elements();
	ATseqDiag seqDiag;
	MAML="";
	//Opening line for an Multi Agent System element
	MAML+="<useCase";
	MAML+=" version=\"" + Double.toString(version) + "\"";
	MAML+=" name=\"" + name + "\">\n";
	//New Line for Description element
	
	MAML += " key=\"" + getKey() + "\"";
	
	MAML+="<description>\n";
	MAML+=getDescription();
	MAML+="\n</description>\n";
	//New Line for Framework element
	//Look through and encode then get constituent agent MAML code
	while(seqDiagrams.hasMoreElements()){
		seqDiag = (ATseqDiag)seqDiagrams.nextElement();
		MAML+=seqDiag.getMAML();
	}
	MAML+= "</useCase>";

	return MAML;
}
/**
 * Insert the method's description here.
 * Creation date: (6/12/00 10:46:39 AM)
 * @return java.lang.String
 */
public String getName() {
	return name;
}
/**
 * Insert the method's description here.
 * Creation date: (1/19/01 1:56:20 PM)
 * @return int
 */
public int getSeqDiagCount() {
	return seqDiags.size();
}
/**
 * Insert the method's description here.
 * Creation date: (6/12/00 11:07:58 AM)
 * @return java.util.Vector
 */
public Vector getSeqDiags() {
	return seqDiags;
}
/**
 * Insert the method's description here.
 * Creation date: (6/12/00 10:46:11 AM)
 * @param n java.lang.String
 */
public void setName(String n) {
	name = ATtokenOps.validName(n);
	}
/**
 * Insert the method's description here.
 * Creation date: (7/17/00 2:17:09 PM)
 */
public void writeDATA() {
	super.writeDATA();
	MAML+="Sequence Diagrams:\n";
	Enumeration sD = getSeqDiags().elements();
	ATseqDiag seqDiag;
	while(sD.hasMoreElements()){
		seqDiag = (ATseqDiag)sD.nextElement();
		MAML+= seqDiag.getName() + "\n";
	}
}
}
