package system;

/**
 * all line-like graphics (conversation, transition...)
 * extend this type.
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
//___________________________________________________
// Class to represent a line
//___________________________________________________
import java.io.*;
import java.util.Vector;
import java.awt.*;

abstract class Line {

	Square first, second;				//the first/second square(s) that the line is attached to
	
	protected char pos1, pos2;					//the positions (x or y) on the square that the line attaches to
	protected int num1, num2;						//the side (1 or 2) on the square that the line attaches to

	final static int MAX_POINTS = 10;

	private int n_pts = 2;
	private int Xs[] = new int[MAX_POINTS];
	private int Ys[] = new int[MAX_POINTS];
	private int choosen;


	int x1f, x2f, y1f, y2f, w,v;
	private String type=" ";
	//used for loops (width and height of loop)
	//(start and finishing degrees of loop)
	int width, height, start, finish;

	int edgeLock = FREE;
	static final int FREE = 1;
	static final int LOCKED = 0;

	public static final double INFINITE_SLOPE = 100000000;
/**
 * This method was created in VisualAge.
 */
public Line() {
	super();
}
/**
 * This method was created in VisualAge.
 */
public Line(Line cp) {
	super();
}
/**
 * This method was created in VisualAge.
 */
public void addPoint(int x, int y) {
	double dist = 25;
	double max = 1000;
	int index = 0;

	
	// This loop finds the line vertex closest to the new point.
	for(int i=0; i<n_pts; i++) {
		dist = Math.sqrt(Math.pow(Xs[i]-x,2) + Math.pow(Ys[i]-y,2));
		if(dist < max) {
			if(dist > 10) {
				if(i>0 && ((Xs[i-1]-5<x && Xs[i]+5>x) || (Xs[i-1]+5>x && Xs[i]-5<x)) &&
		 	        ((Ys[i-1]-5<y && Ys[i]+5>y) || (Ys[i-1]+5>y && Ys[i]-5<y))) {
					index = i;		// if the point is between index-1 and index...
		 			max = dist;
				} else 				// note : these have a buffer zone of +- 5
		 	    if(i<n_pts-1 && ((Xs[i]-5<x && Xs[i+1]+5>x) || (Xs[i]+5>x && Xs[i+1]-5<x)) &&
	 		        ((Ys[i]-5<y && Ys[i+1]+5>y) || (Ys[i]+5>y && Ys[i+1]-5<y))) {
					index = i + 1;		// if the point is between index and index+1...
		  		  	max = dist;
				}
			} else {
				max = dist;
				index = i;
				break;
			}
		}
	}


	// if there are still open point slots, and the point is not too close to another...
	if(n_pts < MAX_POINTS  && index != 0 && max>10) {
		for(int i= n_pts-1; i>=index; i--) {
		  Xs[i+1] = Xs[i];
		  Ys[i+1] = Ys[i];		// bump over everything from the end down to the index
		}
		n_pts++;
		Xs[index] = x;
		Ys[index] = y;			// add the new point to the array.
		max = 0;
	}

	if(max < 10) choosen = index;
	else choosen = 0;
	          
/*  	int count= n_pts+1;
	int count2 = -1;
	double dist= 25;
	double max = 25;
	for (int i=1; i<n_pts; i++) {
		dist = Math.sqrt(((Xs[i]-x)*(Xs[i]-x))+((Ys[i]-y)*(Ys[i]-y)));
		if (dist<max){ 
			count2=i;
			max = dist;
		}
		if (max>10){
			if(((Xs[i-1]<=x)&&(x<=Xs[i]))||((Xs[i]<=x)&&(x<=Xs[i-1]))){
				if(((Ys[i-1]<=y)&&(y<=Ys[i]))||((Ys[i]<=y)&&(y<=Ys[i-1]))){
					count = i;
				
				}
			}
		}
	}
	dist = Math.sqrt(((Xs[0]-x)*(Xs[0]-x))+((Ys[0]-y)*(Ys[0]-y)));
	if(dist<max){
		count2 = 0;
	}
//	if(count2==n_pts-1){
//		choosen=n_pts-1;
//	}
	System.out.println(count + " " + count2);

	if(count2==-1 && n_pts < MAX_POINTS){
		for (int j=n_pts; j>=count; j--){
			Xs[j+1]=Xs[j];
			Ys[j+1]=Ys[j];
		}
		n_pts++;
		choosen = count;
//	} else if (count2 == 0){
//		choosen = 0;
	} else {
		choosen = count2;
		Xs[choosen]=x;
		Ys[choosen]=y;
	}
*/  
}
/**
 * Insert the method's description here.
 * Creation date: (6/29/00 1:49:39 PM)
 * @param sq1 system.Square
 * @param sq2 system.Square
 */
public boolean areConnected(Square sq1, Square sq2) {
	if((sq1 == first)&&(sq2 == second)){
		return true;
	} else if((sq1 == second)&&(sq2 == first)){
		return true;
	} else if((sq1 == first)&&(sq2 == first)&&(type== "loop")){
		return true;
	} 
	return false;
	}
/**
 * This method was created in VisualAge.
 */
public int arrange_pts() {
	if(n_pts > 2) {
		final int MIN_DIST = 10;
	
		int x = Xs[choosen];
		int y = Ys[choosen];
		double dist1 = MIN_DIST;
		double dist2 = MIN_DIST;

	
		if(choosen != 0) {
			int x_1 = Xs[choosen-1];
			int y_1 = Ys[choosen-1];
			dist1 = Math.sqrt((x-x_1)*(x-x_1)+(y-y_1)*(y-y_1));
		}

		if(choosen != n_pts-1) {
			int x_2 = Xs[choosen+1];
			int y_2 = Ys[choosen+1];
			dist2 = Math.sqrt((x-x_2)*(x-x_2)+(y-y_2)*(y-y_2));
		}
		
		if (dist1 < MIN_DIST || dist2 < MIN_DIST){
			int node = choosen;
			if(choosen == n_pts-1) node = n_pts-2;
			
			for(int j = node; j < n_pts - 1; j++) {
				Xs[j] = Xs[j+1];
				Ys[j] = Ys[j+1];
			}
			n_pts--;
			
		} 

	}
	
	return n_pts;
}
/**
 * This method was created in VisualAge.
 */
public void Arrow() {
	int a = 10;
	//x and y components of line
	double x = (Xs[n_pts-2]-Xs[n_pts-1]);	
	double y = (Ys[n_pts-2]-Ys[n_pts-1]);	
	
	//find distance between two points.
	double dist = Math.sqrt( (x)*(x) + (y)*(y) );	

	//find point 20 pts away from final point and still on line
	double xi_dist = (a*x)/dist;
	double yi_dist = (a*y)/dist;

	
	double xi =0;
	double yi =0;

		
	xi = Xs[n_pts-1]+xi_dist;	
	yi = Ys[n_pts-1]+yi_dist;
		
	//find two final points for arrow lines.
	if (type != "loop") {

		x1f = (int)(xi - (yi_dist/3));
		y1f = (int)(yi + (xi_dist/3));	

		x2f = (int)(xi + (yi_dist/3));
		y2f = (int)(yi - (xi_dist/3));
		w = (int)xi;
		v = (int)yi;

	} else {
		//Loop();
	}
}
/**
 * Insert the method's description here.
 * Creation date: (11/3/00 3:03:02 PM)
 * @return int
 */
public int ch() {
	return choosen;
}
/**
 * This method was created in VisualAge.
 */
public void checkEnds() {
/*	if(first instanceof system.ATTaskGRFX ||
			first instanceof system.ATstartStateGRFX ||
			first instanceof system.ATendStateGRFX ){
				defineEndPt(1);
		}

	if(second instanceof system.ATTaskGRFX ||
			second instanceof system.ATstartStateGRFX ||
			second instanceof system.ATendStateGRFX ){
				defineEndPt(2);
		}
*/
	if(first instanceof system.Circle) {
		defineEndPt(1);
	}
	if(second instanceof system.Circle) {
		defineEndPt(2);
	}
	//Arrow();
}
/**
 * This method was created in VisualAge.
 * @return boolean
 * @param sq afit.system.Square
 */
public boolean checkMatch(Square sq) {
	if (first == sq) {
		return true;
	} else if(second == sq) {
		return true;
	} else {
		return false;
	}
}
/**
 * This method was created in VisualAge.
 */
public void defineEndPt(int b) {
	//int f,g,h,i;
	//double x,y;
	
	if(b == 2){
		((Circle)second).setEndPoint(this,2);
		
	/*	f = (((Circle)second).width)/2+2;
		g = (((Circle)second).height)/2+2;
		h = Xs[n_pts-2] - ((Circle)second).center_x;
		i = Ys[n_pts-2] - ((Circle)second).center_y;

		x = f*h*g/(Math.sqrt(h*h*g*g + i*i*f*f));
		y = f*g*i/(Math.sqrt(h*h*g*g + i*i*f*f));
		this.Xs[n_pts-1] = (int)(((Circle)second).center_x+x);
		this.Ys[n_pts-1] = (int)(((Circle)second).center_y+y);
	*/
	} else {
		((Circle)first).setEndPoint(this,1);
	
	/*	f = (((Circle)first).width)/2+2;
		g = (((Circle)first).height)/2+2;
		h = Xs[1] - ((Circle)first).center_x;
		i = Ys[1] - ((Circle)first).center_y;

		x = f*h*g/(Math.sqrt(h*h*g*g + i*i*f*f));
		y = f*g*i/(Math.sqrt(h*h*g*g + i*i*f*f));
		
		this.Xs[0] = (int)(((Circle)first).center_x+x);
		this.Ys[0] = (int)(((Circle)first).center_y+y);
	*/
	}
}
/**
 * This method was created in VisualAge.
 */
public void deleteMe() {
	first.deleteLine(this, posnumTOquad(pos1,num1));
	second.deleteLine(this, posnumTOquad(pos2,num2));
}
/**
 * This method was created in VisualAge.
 */
public boolean dist(int x, int y) {
	
	double slope = 0;
	double y_intersect1;
	double y_intersect2;
	double yi;
	double xi;
	double dist;
	double greatdist = 1000;
	int xj,yj,xk,yk;

	if(type != "loop"){
		for (int i=0; i<n_pts-1; i++) {
			xj=Xs[i];
			yj=Ys[i];
			xk=Xs[i+1];
			yk=Ys[i+1];		

			if (xj>xk){							//find the slope of the line
				slope = (double)(yj-yk)/(double)(xj-xk);
			} else if (xk>xj){
				slope = (double)(yk-yj)/(double)(xk-xj);
			}
			
			y_intersect1 = yj-slope*xj;
				

			y_intersect2 = (-slope*y-x)/(-slope);
			
	
			xi = (slope*y_intersect2-slope*y_intersect1)/(slope*slope + 1);
			yi = slope*xi + y_intersect1;
		
		
			dist = Math.sqrt((x-xi)*(x-xi)+(y-yi)*(y-yi));
		
			if(xj==xk){
				dist = Math.abs(x-xj);
			}
			if(yj==yk){
				dist = Math.abs(y-yj);
			}
		
			if(((xj>=xk)&&(x>=xk&&x<=xj))||((xk>=xj)&&(x>=xj&&x<=xk))||(xk==xj)){
				if(((yj>=yk)&&(y>=yk&&y<=yj))||((yk>=yj)&&(y>=yj&&y<=yk))||(yk==yj)){
					greatdist=dist;
				}
			}
	
		}
	
		if(greatdist<10){
		
			return true;
		} else {
			return false;
		}
	} else {
		int centx = Xs[0];
		int centy = Ys[0];
		if(pos1 == 'x'){
			centy = centy;// + height/2;
		} else {
			centx = centx + width/2;
		}
		dist = Math.sqrt((centx-x)*(centx-x)+(centy-y)*(centy-y));
		if (dist < width/2){
			return true;
		} else {
			return false;
		}
	}
		 
}
/**
 * This method was created in VisualAge.
 */
public abstract void drawLine(Graphics g);
/**
 * Insert the method's description here.
 * Creation date: (11/3/00 1:01:07 PM)
 */
public void initializePoints(int[] xpts, int[] ypts) {
	n_pts = xpts.length;
	for(int i=0; i<n_pts; i++) {
		Xs[i] = xpts[i];
		Ys[i] = ypts[i];
	}
	if(n_pts < 2)  {
		Xs[1] = 100;
		Ys[1] = 100;
	
		if(n_pts < 1) {
			Xs[0] = 0;
			Ys[0] = 0;
		}

		System.out.println("Error, missing line points in MAML file!");
		n_pts = 2;
	}
	
}
/**
 * This method was created in VisualAge.
 */
public void linedist(Square sq, int i, int j, double max) {
		double dist=max;
		int a = 1;
		char b = 'x';
		
		if ((sq.x1<i && i<sq.x2) || (sq.x2 <i && i <sq.x1)){
			dist = sq.y2-j;
			dist = (dist>0) ? dist: -dist;
			b = 'y';
			if(dist < max){
				a = 2;
				max = dist;
			}
			dist = sq.y1-j;
			dist = (dist>0) ? dist: -dist;
			if(dist <max){
				a = 1;
				max = dist;
			}
		}
		if ((sq.y1<j && j<sq.y2) || (sq.y2 <j && j <sq.y1)){
			dist = sq.x2-i;
			dist = (dist>0) ? dist: -dist;
			if(dist <max){
				a = 2;
				max = dist;
				b = 'x';
			}
			dist = sq.x1-i;
			dist = (dist>0) ? dist: -dist;
			if(dist < max) {
				a = 1;
				max = dist;
				b = 'x';
			}
		}

		pos1 =b;
		num1 =a;
	}
/**
 * This method was created in VisualAge.
 */
public void Loop() {
	
	if (pos1=='x'){
		width = 90;
		height = 45;
		if(num1==1) {
			start = 90;
			finish = 270;
			Ys[0]=Ys[0]+height/2;
			Xs[0] = first.x1-width/2;
			Ys[n_pts-1] = Ys[0]-height;
			Xs[n_pts-1] = first.x1;
			x1f = Xs[n_pts-1]-10;
			x2f = Xs[n_pts-1]-10;
			y1f = Ys[n_pts-1]-5;
			y2f = Ys[n_pts-1]+5;
			
		} else if (num1 == 2) {
			start = 270;
			finish = 90;
			Ys[0] = Ys[0]+height/2;
			Xs[0] = first.x2-width/2;
			Ys[n_pts-1] = Ys[0];
			Xs[n_pts-1] = first.x2;
			x1f = Xs[n_pts-1]+10;
			x2f = Xs[n_pts-1]+10;
			y1f = Ys[n_pts-1]-5;
			y2f = Ys[n_pts-1]+5;
			
		}
			
			
	} else if (pos1 == 'y') {
		width = 45;
		height = 90;
		if(num1 == 1) {
			start = 0;
			finish = 180;
			Xs[0] = Xs[0]-width/2;
			Ys[n_pts-1] = first.y1;
			Xs[n_pts-1] = Xs[0]+width/2-7;
			y1f = Ys[n_pts-1]-10;
			y2f = Ys[n_pts-1]-10;
			x1f = Xs[n_pts-1]-5;
			x2f = Xs[n_pts-1]+5;
		}else if (num1 == 2) {
			start = 180;
			finish = 0;
			Ys[n_pts-1] = first.y2;
			Xs[0] = Xs[0]-width/2;
			Xs[n_pts-1] = Xs[0];
			y1f = Ys[n_pts-1]+10;
			y2f = Ys[n_pts-1]+10;
			x1f = Xs[n_pts-1]-5;
			x2f = Xs[n_pts-1]+5;
			
		}
	}
	
}
/**
 * This method was created in VisualAge.
 */
public void movePoint(int x, int y) {
	if(type != "loop" && choosen != 0 && choosen != n_pts-1){
		Xs[choosen] = x;
		Ys[choosen] = y;
				
		if ((choosen == 1)&&(first != null)) {
			if(first instanceof system.Circle){
				defineEndPt(1);
			} else {
				newSide(1);
				first.rearrangeLines(posnumTOquad(pos1,num1));
			}
			
		}
		
		if ((choosen == n_pts-2)&&(second != null)) {
			if(second instanceof system.Circle){
				defineEndPt(2);
			} else {
				newSide(2);
				second.rearrangeLines(posnumTOquad(pos2,num2));
			}
		}
		
		/*
		if((choosen == n_pts-1)&&(second == first)){
			Xs[choosen] = x;
			Ys[choosen] = y;
			newSide(first,Xs[0],Xs[1],Ys[0],Ys[1],1);
			newSide(second,Xs[n_pts-1],Xs[n_pts-2],Ys[n_pts-1],Ys[n_pts-2],2);
		}
		if(first instanceof system.Circle){
				defineEndPt(1);
		}
		if(second instanceof system.Circle){
				defineEndPt(2);
			}
		if (this instanceof system.ATconnectionGRFX ){
			if(choosen == n_pts-1){
				Xs[choosen] = x;
				Ys[choosen] = y;
				if(choosen == 1){
					newSide(1);
				}
				return;
			}
		}
		
		else if ((choosen == 1)||(choosen == n_pts-2)) {
			Ys[choosen] = y;
			Xs[choosen] = x;
			newSide(1);
			if(second != null){
				newSide(2);
			}
		}
		else {
			Ys[choosen] = y;
			Xs[choosen] = x;
		}
		*/
	}else {//type == "loop"
		rotateLoop(first,Xs[0],x,Ys[0],y);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (11/3/00 1:50:32 PM)
 * @return int
 */
public int n() {
	return n_pts;
}
/**
 * This method was created in VisualAge.
 */
public void newSide(int ForS) {
	//public void newSide(Square sq,int x1,int x2, int y1, int y2, int ForS) {

	char pos;
	int num;
	int dx,dy;
	//double slope;
	double vbuff;
	double hbuff;
	double delta;
	Square sq;
	int quad_ori;
	
	if(type != "loop"  && edgeLock==FREE){
		if (ForS == 1){
			pos = pos1;
			num = num1;
			sq = first;
			dx = Xs[1] - sq.center_x;
			dy = Ys[1] - sq.center_y;
			//System.out.println("First " + Xs[1] + " " + sq.center_x + " " + Ys[1]  + " " + sq.center_y);
			
		} else if (ForS == 2) {
			pos = pos2;
			num = num2;
			sq = second;
			dx = Xs[n_pts-2] - sq.center_x;
			dy = Ys[n_pts-2] - sq.center_y;
			//System.out.println("Second " + Xs[n_pts-2] + " " + sq.center_x + " " + Ys[n_pts-2]  + " " + sq.center_y);
					
		} else return;

		if(sq instanceof system.Circle) return;
		
		//slope = ((double)sq.width) / ((double)sq.height);

		// using a buffered zone for the critical angle, so lines don't flip-flop
		// as much while close to the critical angle.
		vbuff = 0.80 * ((double)sq.width) / ((double)sq.height);	// vertical slope buffer
		hbuff = 1.25 * ((double)sq.width) / ((double)sq.height);	// horizontal slope buffer
		
		delta = slope(sq);
		quad_ori = posnumTOquad(pos,num);

		/*if(dy==0) {
			if(dx<0) {
				if((pos != 'x') || (num != 1)) {
					sq.moveLine(this,quad_ori,0);
					pos = 'x';
					num = 1;
				}
			} else {
				if((pos != 'x') || (num != 2)) {
					sq.moveLine(this,quad_ori,2);
					pos = 'x';
					num = 2;
				}
			}
		} else {
		*/	//int delta = dx/dy;
			
			if(((delta > hbuff /*slope*/) || (delta < -1*hbuff /*slope*/)) && dx<0) { // left quadrent
				if((pos != 'x') || (num != 1)) {
					sq.moveLine(this,quad_ori,0);
					pos = 'x';
					num = 1;
				}
			} else if(((delta > hbuff /*slope*/) || (delta < -1*hbuff /*slope*/)) && dx>0) { // right quadrent
				if((pos != 'x') || (num != 2)) {
					sq.moveLine(this,quad_ori,2);
					pos = 'x';
					num = 2;
				}
			} else if((delta <= vbuff /*slope*/) && (delta >= -1*vbuff /*slope*/) && dy<0) { // top quadrent
				if((pos != 'y') || (num != 1)) {
					sq.moveLine(this,quad_ori,1);
					pos = 'y';
					num = 1;
				}
			} else if((delta <= vbuff /*slope*/) && (delta >= -1*vbuff /*slope*/) && dy>0) { // bottom quadrent
				if((pos != 'y') || (num != 2)) {
					sq.moveLine(this,quad_ori,3);
					pos = 'y';
					num = 2;
				}
			}
		//}
		
		//sq.resize(pos,num);
		if(ForS ==1){
			pos1 = pos;
			num1 = num;
		} else {
			pos2 = pos;
			num2 = num;
		}
	}

}
public void place(Square sq1, Square sq2) {
	if(first != null) {
		first.remove(this);
	}
	if(second != null) {
		second.remove(this);
	}
	
	this.first = sq1;
	this.second = sq2;
	
	if(sq1 == sq2){
		this.type = "loop";
		pos1 = 'y';
		num1 = 1;
		sq1.addLoop(this,posnumTOquad(pos1, num1));
		sq1.resizeLoop(posnumTOquad(pos1, num1));
	} else{
		setPoint(0,sq1.center_x,sq1.center_y);
		setPoint(n_pts-1,sq2.center_x,sq2.center_y);

		int dx = sq2.center_x - sq1.center_x;
		int dy = sq2.center_y - sq1.center_y;
		double cr_ang = ((double)sq1.width) / ((double)sq1.height);	// critical angle
		double delta = slope(sq1);

		if(((delta > cr_ang) || (delta < -1*cr_ang)) && dx<0) { // left quadrent
			sq1.add(this,0,1);
			pos1 = 'x';
			num1 = 1;
		} else if(((delta > cr_ang) || (delta < -1*cr_ang)) && dx>=0) { // right quadrent
			sq1.add(this,2,1);
			pos1 = 'x';
			num1 = 2;
		} else if((delta <= cr_ang) && (delta >= -1*cr_ang) && dy<0) { // top quadrent
			sq1.add(this,1,1);
			pos1 = 'y';
			num1 = 1;
		} else if((delta <= cr_ang) && (delta >= -1*cr_ang) && dy>=0) { // bottom quadrent
			sq1.add(this,3,1);
			pos1 = 'y';
			num1 = 2;
		} else {
			System.err.println("Error Processing lines!!!");
		}

		dx = -dx;
		dy = -dy;
		cr_ang = ((double)sq2.width) / ((double)sq2.height);	// critical angle
		delta = slope(sq2);

		if(((delta > cr_ang) || (delta < -1*cr_ang)) && dx<0) { // left quadrent
			sq2.add(this,0,2);
			pos2 = 'x';
			num2 = 1;
		} else if(((delta > cr_ang) || (delta < -1*cr_ang)) && dx>=0) { // right quadrent
			sq2.add(this,2,2);
			pos2 = 'x';
			num2 = 2;
		} else if((delta <= cr_ang) && (delta >= -1*cr_ang) && dy<0) { // top quadrent
			sq2.add(this,1,2);
			pos2 = 'y';
			num2 = 1;
		} else if((delta <= cr_ang) && (delta >= -1*cr_ang) && dy>=0) { // bottom quadrent
			sq2.add(this,3,2);
			pos2 = 'y';
			num2 = 2;
		} else {
			System.err.println("Error Processing lines!!!");
		}

		
		/*
		double max = 100000;
		double dist;
		int quad=0;
		for(int j=0; j<4; j++) {
			dist = sq1.dist(j,sq2.center_x,sq2.center_y);
			if(dist<max) {
				quad = j;
				max = dist;
			}
		}
		switch(quad) {
			case 0: pos1 = 'x'; num1 = 1; break;
			case 1: pos1 = 'y'; num1 = 1; break;
			case 2: pos1 = 'x'; num1 = 2; break;
			case 3: pos1 = 'y'; num1 = 2; break;
			default: break;
		}

		max = 100000;
		quad=0;
		for(int j=0; j<4; j++) {
			dist = sq2.dist(j,sq1.center_x,sq1.center_y);
			if(dist<max) {
				quad = j;
				max = dist;
			}
		}
		switch(quad) {
			case 0: pos2 = 'x'; num2 = 1; break;
			case 1: pos2 = 'y'; num2 = 1; break;
			case 2: pos2 = 'x'; num2 = 2; break;
			case 3: pos2 = 'y'; num2 = 2; break;
			default: break;
		}
			
		sq1.add(this,posnumTOquad(pos1,num1),1);
		sq2.add(this,posnumTOquad(pos2,num2),2);
		*/
	}
}
/**
 * This method was created in VisualAge.
 * @param state system.ATstate
 */
public void placeLoop(Square state) {
	pos1 = 'y';
	num1 = 1;
	state.addLoop(this,1);
	first = state;
	second = state;
	Loop();
}
/**
 * Insert the method's description here.
 * Creation date: (12/12/00 5:33:21 PM)
 * @return int
 * @param pos char
 * @param num int
 */
public static int posnumTOquad(char pos, int num) {
	// quad is my representation of the connection quadrent.
	// These will correspond to the legacy types pos,num.  
	//
	//						       quad1
	// quad 0 = 'x',1		      \_____/
	// quad 1 = 'y',1		quad0  |   | quad2
	// quad 2 = 'x',2		       |___|
	// quad 3 = 'y',2		      /     \
	//						       quad3

	if(pos == 'x' && num == 1)	return 0;
	if(pos == 'y' && num == 1)	return 1;
	if(pos == 'x' && num == 2)	return 2;
	if(pos == 'y' && num == 2)	return 3;
	return -1;
}
/**
 * This method was created in VisualAge.
 */
public void removePoint() {
	for(int j=choosen; j<n_pts-1; j++){
		Xs[j] = Xs[j+1];
		Ys[j] = Ys[j+1];
	}
	this.n_pts--;
}
/**
 * This method was created in VisualAge.
 */
public void resize(Square square) {
	if(first!=null){
		newSide(1);
	}
	
	if(second != null){
		newSide(2);
	}
	
	if (square == first) {
		first.rearrangeLines(posnumTOquad(pos1,num1));
	} else if (square == second) {
		second.rearrangeLines(posnumTOquad(pos2,num2));
	}
}
/**
 * Insert the method's description here.
 * Creation date: (3/28/00 2:52:50 PM)
 */
public void reverse() {
	if(type != "loop") {
		int holdXs[] = new int[10];
		int holdYs[] = new int[10];
		for (int i=0; i<n_pts; i++){
			holdXs[i] = Xs[n_pts-i-1];
			holdYs[i] = Ys[n_pts-i-1];
		}
		first.deleteLine(this,posnumTOquad(pos1,num1));
		second.deleteLine(this,posnumTOquad(pos2,num2));
		char holdP = pos1;
		int holdN = num1;
		pos1 = pos2;
		num1 = num2;
		pos2 = holdP;
		num2 = holdN;
		Square f = first;
		first = second;
		second = f;
		for(int i =0; i<n_pts; i++){
			Xs[i] = holdXs[i];
			Ys[i] = holdYs[i];
		}
		first.add(this,posnumTOquad(pos1,num1),1);
		second.add(this,posnumTOquad(pos2,num2),2);
		Arrow();
	}
}
/**
 * This method was created in VisualAge.
 */
public void rotateLoop(Square sq, int x1, int x2, int y1, int y2) {
	char pos;
	int num;
	//if(first != second) {
			pos = pos1;
			num = num1;
		
	//	sq.deleteLine(this,pos,num);
		if(pos == 'x'){
			if (num ==1) {
				if(x1<x2){
					if(sq.y1>y2){
						sq.deleteLine(this,posnumTOquad(pos,num));
						sq.addLoop(this,1);
						sq.rearrangeLines(1);
						pos = 'y';
						num = 1;
					} 
					if(sq.y2<y2) {
						sq.deleteLine(this,posnumTOquad(pos,num));
						sq.addLoop(this,3);
						sq.rearrangeLines(3);
						pos = 'y';
						num = 2;
					}
				}
	//			sq.resize('x',1);
			}else if (num ==2) {
				if(x1>x2){
					if(sq.y1>y2){
						sq.deleteLine(this,posnumTOquad(pos,num));
						sq.addLoop(this,1);
						sq.rearrangeLines(1);
						pos = 'y';
						num = 1;
					}
					if(sq.y2<y2) {
						sq.deleteLine(this,posnumTOquad(pos,num));
						sq.addLoop(this,3);
						sq.rearrangeLines(3);
						pos = 'y';
						num = 2;
					}
				}
	//			sq.resize('x',2);
			}
		}
		else if(pos=='y'){
			if(num ==1) {
				if(y1<y2){
					if(sq.x1>x2){
						sq.deleteLine(this,posnumTOquad(pos,num));
						sq.addLoop(this,0);
						sq.rearrangeLines(0);
						pos = 'x';
						num = 1;
					}
					if(sq.x2<x2){
						sq.deleteLine(this,posnumTOquad(pos,num));
						sq.addLoop(this,2);
						sq.rearrangeLines(2);
						pos = 'x';
						num = 2;
					}
				}
	//			sq.resize('y',1);
			}else if(num == 2) {
				if(y1>y2){
					if(sq.x1>x2){
						sq.deleteLine(this,posnumTOquad(pos,num));
						sq.addLoop(this,0);
						sq.rearrangeLines(0);
						pos = 'x';
						num = 1;
					}
					if(sq.x2<x2){
						sq.deleteLine(this,posnumTOquad(pos,num));
						sq.addLoop(this,2);
						sq.rearrangeLines(2);
						pos = 'x';
						num = 2;
					}
				}
	//			sq.resize('y',2);
			}
		}
		sq.rearrangeLines(posnumTOquad(pos,num));
		pos1 = pos;
		num1 = num;
		
	//} else {first.resizeLoop('y',1);}
}
/**
 * Insert the method's description here.
 * Creation date: (11/3/00 3:03:36 PM)
 * @param ch int
 */
public void setCh(int ch) {
	choosen = ch;	
}
/**
 * Insert the method's description here.
 * Creation date: (11/3/00 3:05:25 PM)
 * @param n int
 */
protected void setN(int n) {
	n_pts = n;	
}
/**
 * Insert the method's description here.
 * Creation date: (11/3/00 1:42:45 PM)
 * @param num int
 * @param xpos int
 * @param ypos int
 */
public void setPoint(int num, int xpos, int ypos) {
	if(num < n_pts) {
		Xs[num] = xpos;
		Ys[num] = ypos;

		if(type.equals("loop")) Loop();
	}
}
/**
 * This method was created in VisualAge.
 */
public void setPoints(){
	
}
/**
 * Insert the method's description here.
 * Creation date: (3/28/00 10:51:00 AM)
 */
public void setPos(char p1, int n1, char p2, int n2) {
	if(first != null && second != null) {
		first.deleteLine(this,posnumTOquad(pos1,num1));
		if(first!=second){
			second.deleteLine(this,posnumTOquad(pos2,num2));
		}
		pos1 = p1;
		num1 = n1;
		pos2 = p2;
		num2 = n2;
		if(first!=second){
			first.add(this,posnumTOquad(pos1,num1),1);
			second.add(this,posnumTOquad(pos2,num2),2);
		} else {
			first.addLoop(this,1);
			type = "loop";
		}
	} else {
		System.out.println("Error!!!  Line has null endings!");
	}
		
}
/**
 * Insert the method's description here.
 * Creation date: (11/9/00 12:27:58 PM)
 * @param t java.lang.String
 */
public void setType(String t) {
	//System.out.println("\nInput linetype = " + t + ".");
	if(t.equals("") || t.equals("\"")) {
		type = " ";
	} else {
		type = t;
	}
	//System.out.println("Assigned Linetype = " + type + ".");
	
}
/**
 * Insert the method's description here.
 * Creation date: (11/3/00 1:43:37 PM)
 * @param num int
 * @param pos int
 */
public void setX(int num, int pos) {
	if(num < n_pts) {
		Xs[num] = pos;
	}
}
/**
 * Insert the method's description here.
 * Creation date: (11/3/00 1:44:05 PM)
 * @param num int
 * @param pos int
 */
public void setY(int num, int pos) {
	if(num < n_pts) {
		Ys[num] = pos;
	}
}
/**
 * Insert the method's description here.
 * Creation date: (12/12/00 2:21:16 PM)
 * @return double
 * @param s system.Square
 */
public double slope(Square sq) {
	double dx = 0;
	double dy = 0;
	
	if(type.equals("loop")) {
		if(pos1=='y') return 0;
		else return INFINITE_SLOPE;
	} else {
		if (sq == first){
			dx = Xs[1] - sq.center_x;
			dy = Ys[1] - sq.center_y;
		} else if (sq == second) {
			dx = Xs[n_pts-2] - sq.center_x;
			dy = Ys[n_pts-2] - sq.center_y;
		}

		if(dy == 0) return INFINITE_SLOPE;
		return dx/dy;
	}
}
/**
 * Insert the method's description here.
 * Creation date: (11/9/00 12:27:31 PM)
 * @return java.lang.String
 */
public String type() {
	return type;
}
/**
 * Insert the method's description here.
 * Creation date: (11/3/00 1:46:59 PM)
 * @param num int
 */
public int x(int num) { return Xs[num]; }
/**
 * Insert the method's description here.
 * Creation date: (11/29/00 2:11:30 PM)
 */
public int x1() {
	int minpos = Xs[0];
	
	for(int i=1; i<n_pts; i++) {
		if (Xs[i] < minpos) minpos = Xs[i];
	}
	
	if(pos1=='x' && num1 == 1) minpos -= width;
	
	return minpos;
}
/**
 * Insert the method's description here.
 * Creation date: (11/29/00 1:57:50 PM)
 * @return int
 */
public int x2() {
	int maxpos = Ys[0];
	
	for(int i=1; i<n_pts; i++) {
		if (Ys[i] > maxpos) maxpos = Ys[i];
	}
	
	if(pos1=='x' && num1 == 2) maxpos += width;

	return maxpos;
}
/**
 * Insert the method's description here.
 * Creation date: (11/3/00 1:48:00 PM)
 * @return int
 * @param num int
 */
public int y(int num) {
	return Ys[num];
}
/**
 * Insert the method's description here.
 * Creation date: (11/29/00 2:12:02 PM)
 * @return int
 */
public int y1() {
	int minpos = Ys[0];
	
	for(int i=1; i<n_pts; i++) {
		if (Ys[i] < minpos) minpos = Ys[i];
	}
	
	if(pos1=='y' && num1 == 1) minpos -= height;
	
	return minpos;
}
/**
 * Insert the method's description here.
 * Creation date: (11/29/00 1:58:05 PM)
 * @return int
 */
public int y2() {
	int maxpos = Xs[0];
	
	for(int i=1; i<n_pts; i++) {
		if (Xs[i] > maxpos) maxpos = Xs[i];
	}
	
	if(pos1=='y' && num1 == 2) maxpos += height;
	
	return maxpos;
}
}
